<?php

/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 */

if (!defined("mxMainFileLoaded")) die ("You can't access this file directly...");

/**
 * @autor Sven Hedstroem-Lang <svenhlang@gmail.com>
 * @copyright 2022-04
 * @since pmx 2.8.1
 * @phpversion >=8.0.1
 * @api https://www.php.net/manual/de/reserved.variables.cookies.php
 * @api https://www.php.net/manual/de/function.setcookie.php
 * 
 * TODO: wird nicht benutzt - irgendwann ausbauen
 */
class pmxCookie {

    /**
     * @constructor
     * @private - verhindert die direkte Erzeugung des Objektes
     * @copyrigth pmx 2.8.1
     */
    private function __construct() {}

    /**
     * pmxCookie::set()
     * 
     * @api https://www.php.net/manual/de/function.setcookie.php
     * @param string $name
     * @param string $value
     * @param int [$seconds=0] - optional - set in seconds - Specifies when the cookie expires. If this parameter is omitted or set to 0, the cookie will expire at the end of the session (when the browser closes). Default is 0
     * @param string [$path=""] - optional - TODO: set default
     * @param string [$domain=""] - optional - TODO: set default
     * @param bool [$secure=false] - optional - TODO: check default
     * @param bool [$httponly=false] - optional
     * @return void
     * @copyrigth pmx 2.8.1
     * @example
     *      pmxCookie::setCookie("tab_seo", 1); // all other parameter are optional
     *      // remove cookie when closed the browser
     *      pmxCookie::setCookie("tab_seo", 2, (5 * 24 * 60 * 60));
     *      // -> set cookie "tab_seo" for 5 days
     * 
     * TODO: test, extra function um die Zeit einzugeben ?
     */
    public static function set(string $name, string $value, int $seconds = 0, string $path = "", string $domain = "", bool $secure = false, bool $httponly = false)
    {
        if ($seconds === 0) {
            setcookie(
                htmlspecialchars($name),
                $value
            );
        } else {
            // TODO:
            setcookie(
                htmlspecialchars($name),
                $value,
                time() + $seconds,
                /*,
                $path,
                $domain,
                $secure,
                $httponly
                */
            );
        }
    }

    /**
     * pmxCookie::get()
     * 
     * @return string - returns empty string "" if not found
     * @copyrigth pmx 2.8.1
     */
    public static function get(string $name)
    {
        return isset($_COOKIE[htmlspecialchars($name)]) ? htmlspecialchars($_COOKIE[$name]) : "";
    }

    /**
     * @return bool
     * @copyrigth pmx 2.8.1
     */
    public static function remove($name)
    {
        if (isset($_COOKIE[htmlspecialchars($name)])) {
            unset($_COOKIE[htmlspecialchars($name)]);
            self::set($name, "", 1);
            return true;
        }
        return false;
    }

    /**
     * @return bool
     * @copyrigth pmx 2.8.1
     */
    public static function exists($name)
    {
        return isset($_COOKIE[htmlspecialchars($name)]) ? true : false;
    }

}

?>