/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 */

/**
 * @autor Sven Hedstroem-Lang <svenhlang@gmail.com
 * @copyright 2022-04
 * @since pragmaMx 2.8.1
 * @require jQuery, jQueryUI
 * @require for pmxDom()
 */

/**
 * @param {Object} ele - The getElementById like "myid"
 * @param {Int} seconds 
 * @param {String} url
 */
 function addDomCountDown(uniqId, seconds, url) {
    let countDown = setInterval(function() {
        let num = seconds--;
        document.getElementById(uniqId).innerHTML = num.toString();
        if (num <= 0) {
            if (url !== "") {
                window.location = url;
            }
            clearInterval(countDown);
        }
    }, 1000);
}
