<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 */

defined('mxMainFileLoaded') or die('access denied');

/* --------- Konfiguration fuer den Block ----------------------------------- */

/* Anzahl der angezeigten Links, 0 um alle Links anzuzeigen */
$limit = 2;

/* max. Anzahl der Zeichen im Linktitel */
$maxlen = 24;

/* --------- Ende der Konfiguration ----------------------------------------- */

extract($block['settings'], EXTR_OVERWRITE);

global $prefix, $themesetting;

/* der passende Modulname */
$module_name = basename(dirname(dirname(__FILE__)));

if (!mxModuleAllowed($module_name)) {
    /* Block darf nicht gecached werden und weg... */
    $mxblockcache = false;
    return;
}

$content = '';
$cats = array();
foreach ($cats as $key => $values) {
    $cats[$key] = explode(',', str_replace(' ', '', $values));
}

/* Block kann gecached werden? */
$mxblockcache = false;

/* Kategorie der aktuellen Seite ermitteln */
switch (true) {
    case !isset($_GET['name']):
    case $_GET['name'] != $module_name;
    case !isset($_GET['cid']) && !isset($_GET['pid']):
    case isset($_GET['cid']) && $cats && !isset($cats[$_GET['cid']]):
        return;

    case isset($_GET['cid']) && intval($_GET['cid']):
        $qry = "SELECT 0 AS pid, c.cid, c.title, c.description
        FROM " . $prefix . "_pages_categories AS c
        WHERE c.cid = " . intval($_GET['cid']) . "
        LIMIT 1";
        break;

    case isset($_GET['pid']) && intval($_GET['pid']):
        $qry = "SELECT p.pid, c.cid, c.title, c.description
        FROM " . $prefix . "_pages AS p
        INNER JOIN " . $prefix . "_pages_categories AS c
          ON p.cid = c.cid
        WHERE p.pid = " . intval($_GET['pid']) . "
          AND p.active <> 0
        LIMIT 1";
        break;
}
$result = sql_query($qry);
$cat = sql_fetch_assoc($result);

if ($cats && !isset($cats[$cat['cid']])) {
    return;
}

/* den Blocktitel aus dem Kategorienamen bilden */
$blockfiletitle = $cat['title'];

/* das Design der Liste ermitteln, ist im Prinzip das Gleiche wie in den Modulblöcken */
$class_ul = (isset($themesetting['blocknav']['style'])) ? $themesetting['blocknav']['style']: 'list';
$class_cu = (isset($themesetting['blocknav']['current'])) ? $themesetting['blocknav']['current']: 'current';

if ($cats) {
    $where = " AND pid IN(" . implode(',', $cats[$cat['cid']]) . ")";;
    $entries = array_flip($cats[$cat['cid']]);
    $cat_entries = $entries;
    $order = '';
    $limit = '';
} else {
    $where = '';
    $entries = array();
    $order = ' ORDER BY date';
    $limit = (intval($limit)) ? ' LIMIT ' . $limit : '';
}

/* Daten auslesen */
$qry = "SELECT pid, title
        FROM " . $prefix . "_pages
        WHERE active <> 0
        AND cid=" . intval($cat['cid']) . $where . $order . $limit;
$result = sql_query($qry);
while (list($pid, $title) = sql_fetch_row($result)) {
    $link = 'modules.php?name=' . urlencode($module_name) . '&amp;pid=' . intval($pid);
    $view_title = mxCutString($title, $maxlen, "..", "");
    $titleattribut = ($title === $view_title) ? '' : ' title="' . $title . '"';
    $current = ($pid === $cat['pid']) ? ' class="' . $class_cu . '"' : '';
    $entries[$pid] = sprintf('<li%s%s><a href="%s">%s</a></li>', $titleattribut, $current, $link, $view_title);
}

if ($cats) {
    /* nur die Einträge zeigen, die angegeben wurden und die auch wirklich vorhanden sind */
    $entries = array_diff($entries, $cat_entries);
}

if ($entries) {
    $content .= '<ul class="' . $class_ul . ' dynconblo-' . $cat['cid'] . '">' . implode("\n", $entries) . '</ul>';
}

?>