<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 */

defined('mxMainFileLoaded') or die('access denied');

$pid = (empty($_REQUEST['pid'])) ? 0 : intval($_REQUEST['pid']);

$target = 'modules.php?name=' . $module_name . '&pid=' . $pid;
if (!MX_IS_ADMIN && (empty($_SERVER['HTTP_REFERER']) || strpos($_SERVER['HTTP_REFERER'], PMX_HOME_URL) === false)) {
    header('HTTP/1.1 301 Moved Permanently');
    header('Status: 301 Moved Permanently');
    return mxRedirect($target);
}

/* versch. HTTP Header senden */
if (!headers_sent()) {
    header('Content-type: text/html; charset=utf-8');
    header('Content-Language: ' . _DOC_LANGUAGE);
    header('X-Powered-By: pragmaMx ' . PMX_VERSION);
}

$result = sql_query("SELECT title, text, subtitle, page_header, page_footer FROM ${prefix}_pages WHERE pid=" . intval($pid));
list($title, $text, $subtitle, $page_header, $page_footer) = sql_fetch_row($result);

/* Sicherstellen, dass Seitentitel und Untertitel keine Tags enthalten und Sonderzeichen nicht zerstueckelt werden */
$title = strip_tags(str_replace('&nbsp;', ' ', $title));
$subtitle = strip_tags(str_replace('&nbsp;', ' ', $subtitle));
$logo = (file_exists($site_logo)) ? '<p>' . mxCreateImage($site_logo, $sitename) . '</p>' : '';

$content = '';
if ($subtitle) {
    $content .= '<h3>' . $subtitle . '</h3>';
}
if ($page_header) {
    $content .= '<div>' . $page_header . '</div><br />';
}
if ($text) {
    $content .= '<div>' . $text . '</div><br />';
}
if ($page_footer) {
    $content .= '<div>' . $page_footer . '</div><br /><br /><p class="align-center tiny">' . _COPYRIGHT . ' ' . $sitename . '</p>';
}

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
  <meta http-equiv="content-type" content="text/html; charset=utf-8" />
  <meta http-equiv="content-language" content="<?php echo _DOC_LANGUAGE ?>" />
  <meta name="robots" content="NOINDEX, NOFOLLOW" />
  <link rel="stylesheet" type="text/css" href="layout/style/style.css.php?t=<?php echo MX_THEME ?>" />
  <link rel="stylesheet" type="text/css" href="themes/<?php echo MX_THEME ?>/style/style.css" />
  <link rel="stylesheet" type="text/css" href="layout/style/printpage.css" />
  <title><?php echo $title ?></title>
</head>

<body class="printpage">
  <div id="p-page">
    <div id="p-head">
      <?php echo $logo ?>
      <h2><?php echo $title ?></h2>
    </div>

    <div id="p-main" class="content">
      <?php echo $content ?>
    </div>

    <div id="p-foot">
      <p><?php echo _COMESFROM ?> <?php echo $sitename ?><br />
      <?php echo PMX_HOME_URL ?></p>

      <p><?php echo _THEURL ?><br />
      <?php echo htmlspecialchars($target) ?></p>
    </div>
  </div>
</body>
</html>
