<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 *
 *
 * Based on Journey Links Hack
 * Copyright (c) 2000 by James Knickelbein
 * Journey Milwaukee (http://www.journeymilwaukee.com)
 */

defined('mxMainFileLoaded') or die('access denied');

if (!mxGetAdminPref("radmindownload")) {
    mxErrorScreen("Access Denied");
    die();
}

mxGetLangfile(PMX_MODULE);
include('modules/' . PMX_MODULE . '/d_config.php');
include('modules/' . PMX_MODULE . '/includes/functions.php');

$modimagepath = PMX_MODULES_PATH . PMX_MODULE . '/images/';

/**
 * Beschreibung
 */
function codered($num)
{
    $num = (int)$num;
    if (!empty($num)) {
        $num = "<b><span style='color: Red; font-weight: bolder;'>" . $num . "</span></b>";
    }
    return $num;
}

/**
 * Beschreibung
 */
function modAdminMenu()
{
    global $prefix;
    $result = sql_query("select * from " . $prefix . "_downloads_modrequest where brokendownload=1");
    $totalbroken = sql_num_rows($result);
    $result2 = sql_query("select * from " . $prefix . "_downloads_modrequest where brokendownload=0");
    $totalmodrequests = sql_num_rows($result2);

    $men[] = "<a href=\"" . adminUrl(PMX_MODULE) . "\">" . _NEW . "</a>";
    $men[] = "<a href=\"" . adminUrl(PMX_MODULE, 'List') . "\">" . _LISTALL . "</a>";
    $men[] = "<a href=\"" . adminUrl(PMX_MODULE, 'Config') . "\">" . _PTITLEDLC . "</a>";
    $men[] = "<a href=\"" . adminUrl(PMX_MODULE, 'Check') . "\">" . _VALIDATEDOWNLOADS . "</a>";
    $men[] = "<a href=\"" . adminUrl(PMX_MODULE, 'Catogories') . "\">" . _DLCATEGORIES . "</a>";
    if ($totalbroken)
        $men[] = "<a href=\"" . adminUrl(PMX_MODULE, 'ListBroken') . "\">" . _BROKENDOWNLOADSREP . "</a>&nbsp;(" . codered($totalbroken) . ")";
    if ($totalmodrequests)
        $men[] = "<a href=\"" . adminUrl(PMX_MODULE, 'ListModRequests') . "\">" . _DOWNLOADMODREQUEST . "</a>&nbsp;(" . codered($totalmodrequests) . ")";
    $men[] = "<a href=\"" . adminUrl(PMX_MODULE, 'CleanVotes') . "\">" . _CLEANDOWNLOADSDB . "</a>";

    OpenTable();
    echo "<center><font class=\"title\"><a href=\"" . adminUrl(PMX_MODULE) . "\"><b>" . _WEBDOWNLOADSADMIN . "</b></a></font><br /><br /></center>";
    echo "<center><font class=\"content\">[&nbsp;<span style=\"white-space: nowrap;\">" . implode("</span> <small class=\"tiny\">|</small> <span style=\"white-space: nowrap;\">", $men) . "</span>&nbsp;]</font></center>";
    CloseTable();
    echo '<br />';
}

/**
 * Tab "Categories"
 * @since pmx 2.8.1
 */
function modCatogories()
{
    global $prefix, $modimagepath;
    pmxHeader::add_script_code(
        "function checkCapt() {
            let toggle = document.getElementById('toggle').checked;
            let items = document.querySelectorAll('input[name=\"capt[]\"]');
            for (let ele of items) {ele.checked = toggle ? true : false;}
        }"
    );

    $img_delete = mxCreateImage($modimagepath . 'delete.gif', _DELETE, array('title' => _DELETE));
    $img_edit = mxCreateImage($modimagepath . 'edit.gif', _EDIT, array('title' => _MODCATEGORY));
    $img_view = mxCreateImage($modimagepath . 'info.gif', _SHOW, array('title' => _SHOW));

    $_cat = [];
    $result = sql_query("SELECT cid, title, parentid, captcha FROM " . $prefix . "_downloads_categories");
    while (list($cid, $ctitle, $parentid, $captcha) = sql_fetch_row($result)) {
        if (!empty($parentid)) {
            $ctitle = modGetParentTitles($parentid, $ctitle);
        }
        $_func = implode("&nbsp;", [
            '<a href="admin.php?op=' . PMX_MODULE . '/DelCat&cid=' . $cid . '">' . $img_delete . '</a>',
            '<a href="admin.php?op=' . PMX_MODULE . '/ModCat&cid=' . $cid . '">' . $img_edit . '</a>',
            '<a href="modules.php?name=' . PMX_MODULE . '&cid=' . $cid . '">' . $img_view . '</a>'
        ]);
        $_cat[strtolower($ctitle)] = '<tr>'.
        '<td>' . $ctitle . '</td>'.
        '<td>' . $_func . '</td>'.
        '<td><input id="' . $cid . '" name="capt[]" type="checkbox" value="' . $cid . '"' . ($captcha === '1' ? ' checked' : '') . '>&nbsp;'.
        '<label for="' . $cid . '">' . _ACTIVE . '</label></td>'.
        '</tr>';
    }
    ksort($_cat);
    $_out = [
        '<br>',
        '<center><a href=' . adminUrl(PMX_MODULE, 'Catogories') . '><button>' . _REFRESH . '</button></a></center>',
        '<form method="post" action="' . adminUrl(PMX_MODULE, 'Catogories') . '/Capt">',
        '<table class="full list">',
        '<thead><tr>',
        '<th>' . _DLCATEGORIES . '</th>',
        '<th>' . _FUNCTIONS . '</th>',
        '<th><input id="toggle" type="checkbox" onclick="checkCapt()">&nbsp;<label for="toggle">Captcha</label></th>',
        '</tr>',
        '</thead>',
        '<tbody>',
        implode('', $_cat).
        '<tr><td colspan="2">&nbsp;</td>',
        '<td><button type="submit">' . _SAVE . '</button></td></tr>',
        '</tbody></table>',
        '</form>'
    ];
    echo implode('', $_out);
}

/**
 * Save captcha in tab "Categories"
 * 
 * @private
 * @since pmx 2.8.1
 */
function _setCaptcha()
{
    global $prefix;
    sql_query("UPDATE " . $prefix . "_downloads_categories SET captcha='0'");
    if (isset($_POST['capt'])) {
        foreach ($_POST['capt'] as $key => $value) {
            sql_query("UPDATE " . $prefix . "_downloads_categories SET captcha='1' WHERE cid=" . intval($value));
        }
    }
    mxRedirect(adminUrl(PMX_MODULE, 'Catogories'), _CHANGESAREOK);
}

/**
 * List Active Downloads
 */
function modList()
{
    global $prefix, $modimagepath;

    $img_delete = mxCreateImage($modimagepath . 'delete.gif', _DELETE, array('title' => _DELETE));
    $img_edit = mxCreateImage($modimagepath . 'edit.gif', _EDIT, array('title' => _EDITTHISDOWNLOAD));
    $img_view = mxCreateImage($modimagepath . 'info.gif', _SHOW, array('title' => _SHOW));
    $img_check = mxCreateImage($modimagepath . 'check.gif', _DOWNLOADVALIDATION, array('title' => _DOWNLOADVALIDATION));
    $cid = (empty($_GET['cid'])) ? 0 : intval($_GET['cid']);

    $result = sql_query("SELECT COUNT(lid) FROM " . $prefix . "_downloads_downloads");
    list($numrows) = sql_fetch_row($result);

    if (isset($_GET['cid'])) {
        $qry = "SELECT lid, title, url, date as updated, name, email, hits FROM " . $prefix . "_downloads_downloads WHERE cid=" . intval($cid) . " ORDER BY date DESC";
    } else {
        $qry = "SELECT lid, title, url, date as updated, name, email, hits FROM " . $prefix . "_downloads_downloads ORDER BY date DESC LIMIT 150";
    }
    $result = sql_query($qry);

    include ("header.php");
    GraphicAdmin();
    modAdminMenu();
    OpenTable();
    $class = '';
    if ($numrows > 0) {
        echo '<center><a name="result" id="result"></a>'
         . '<form action="' . adminUrl(PMX_MODULE, '', '', '#result') . '" name="jump" id="jump">' . _DLCATEGORIES . ':&nbsp;'
         . '<select name="cid" onchange="location.href=\'' . adminUrl(PMX_MODULE, 'List') . '&amp;cid=\' + document.jump.cid.options[document.jump.cid.options.selectedIndex].value + \'#result\'">'
         . '' . modGetCategoriesSelect($cid, 'adminedit') . ''
         . '</select>&nbsp;<input type="submit" value="' . _SWITCHIT . '" />'
         . '<input type="hidden" name="op" value="' . PMX_MODULE . '/List" />'
         . '</form>'
         . '</center>'
         . '<br />';
        echo '
        	<table class="full list">
         		<thead>
         			<tr>
         				<th>' . _FILENAME . '</th>
         				<th>' . _DLAUTHOR . '</th>
         				<th>' . _DATE . '</th>
         				<th>' . _FUNCTIONS . '</th>
         				<th>' . _DLHITS . '</th>
         			</tr>
         		</thead>
         		<tbody>';
        while (list($lid, $title, $url, $date, $name, $email, $hits) = sql_fetch_row($result)) {
            $class = ($class == '') ? ' class="alternate-a"' : '';
            echo '
            		<tr' . $class . '>
             			<td><a href="' . $url . '">' . $title . '</a></td>
             			<td><a href="mailto:' . $email . '">' . $name . '</a></td>
             			<td>' . mx_strftime(_SHORTDATESTRING, mxSqlDate2UnixTime($date)) . '</td>
             			<td class="nowrap align-center">
             				' . modCheckPopupLink($url, $img_check) . '
             				<a href="' . adminUrl(PMX_MODULE, 'ModData', 'lid=' . $lid) . '">' . $img_edit . '</a>
             				<a href="' . adminUrl(PMX_MODULE, 'DelData', 'lid=' . $lid) . '">' . $img_delete . '</a>
             				<a href="modules.php?name=' . PMX_MODULE . '&amp;op=view&amp;lid=' . $lid . '">' . $img_view . '</a>
             			</td>
             			<td align="center">' . $hits . '</td>
             		</tr>';
        }
        echo '
        		</tbody>
        	</table>';
    }
    CloseTable();
    // hier gleich noch die Kategorie bearbeiten lassen
    if (isset($_GET['cid'])) {
        $cid = intval($_REQUEST['cid']);
        $qry = "select cid, title, cdescription, parentid, captcha from " . $prefix . "_downloads_categories where cid=" . $cid;
        // mxDebugFuncVars($qry);
        $result = sql_query($qry);
        $cat = sql_fetch_assoc($result);
        if (!empty($cat['cid'])) {
            echo '<br />';
            OpenTable();
            echo "<fieldset><legend>" . _MODCATEGORY . "</legend>"
             . "<form method=\"post\" action=\"" . adminUrl(PMX_MODULE) . "\">"
             . "<table class=\"form\">"
             . modCategoryForm($cat)
             . "<tr valign=\"top\"><td colspan=\"2\">
            <input type=\"hidden\" name=\"cid\" value=\"" . $cid . "\" />
            <input type=\"hidden\" name=\"op\" value=\"" . PMX_MODULE . "/ModCatSave\" />
            <input type=\"submit\" value=\"" . _SAVECHANGES . "\" />
            &nbsp;&nbsp;&nbsp;[&nbsp;<a href=\"" . adminUrl(PMX_MODULE, 'DelCat', "cid=" . $cid) . "\">" . _DELETE . "</a>&nbsp;]
            </td></tr>"
             . "</table>"
             . "</form></fieldset>";
            CloseTable();
        }
    }
    include ("footer.php");
}

/**
 * Beschreibung
 */
function modAdminMain()
{
    global $prefix;
    include ("header.php");
    GraphicAdmin();
    modAdminMenu();

    /**
     * List Downloads waiting for validation
     */
    $result = sql_query("select lid, cid, title, url, description, name as auth_name, email, submitter, filesize, version, homepage, updated from " . $prefix . "_downloads_newdownload ORDER BY lid");
    $numrows = sql_num_rows($result);
    if ($numrows > 0) {
        $i = 0;
        OpenTable();
        echo "<center><font class=\"option\"><b>" . _DOWNLOADSWAITINGVAL . "</b></font></center><br />";
        while ($thisdata = sql_fetch_assoc($result)) {
            $i++;
            echo '<hr noshade="noshade" size="1" />'
             . "<form action=\"" . adminUrl(PMX_MODULE, 'AddData') . "\" method=\"post\" name=\"downform\">"
             . "<b>" . _NEW . " " . $i . ".</b><br /><br />"
             . "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"3\">"
             . modDataForm($thisdata)
             . "<tr valign=\"top\"><td>&nbsp;</td><td><input type=\"checkbox\" name=\"addstory\" value=\"1\" />" . _DLADDSTORY . "</td></tr>"
             . "</table>"
             . "<input type=\"hidden\" name=\"new\" value=\"1\" />"
             . "<input type=\"hidden\" name=\"op\" value=\"" . PMX_MODULE . "/AddData\" />"
             . "<input type=\"submit\" value=\"" . _ADD . "\" /> [&nbsp;<a href=\"" . adminUrl(PMX_MODULE, 'DelNew', "lid=" . $thisdata['lid']) . "\">" . _DELETE . "</a> ]"
             . "</form>";
        }
        CloseTable();
        echo '<br />';
    }
    // Add a New Download to Database
    $result = sql_query("select cid, title from " . $prefix . "_downloads_categories");
    $num_categories = sql_num_rows($result);
    if ($num_categories > 0) {
        OpenTable();
        echo '<a name="addnew" id="addnew"></a>';
        echo "<fieldset><legend>" . _ADDNEWDOWNLOAD . "</legend>"
         . "<form method=\"post\" action=\"" . adminUrl(PMX_MODULE, 'AddData') . "\" name=\"downform\">"
         . "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"3\">"
         . modDataForm()
         . "<tr valign=\"top\"><td>&nbsp;</td><td><input type=\"checkbox\" name=\"addstory\" value=\"1\" />" . _DLADDSTORY . "</td></tr>"
         . "</table>"
         . "<input type=\"hidden\" name=\"new\" value=\"0\" />"
         . "<input type=\"hidden\" name=\"op\" value=\"" . PMX_MODULE . "/AddData\" />"
         . "<input type=\"submit\" value=\"" . _ADDURL . "\" /><br />"
         . "</form>"
         . "</fieldset>";
        CloseTable();
        echo '<br />';
    }
    // Modify Downloads
    $result = sql_query("select lid from " . $prefix . "_downloads_downloads");
    $allnumrows = sql_num_rows($result);
    if ($allnumrows > 0) {
        OpenTable();
        echo "<fieldset><legend>" . _MODDOWNLOAD . "</legend>"
         . "<form method=\"post\" action=\"" . adminUrl(PMX_MODULE) . "\">"
         . "<span class=\"content\">" . _DOWNLOADID . "</span>: <input type=\"text\" name=\"lid\" size=\"12\" maxlength=\"11\" />&nbsp;&nbsp;"
         . "<input type=\"hidden\" name=\"op\" value=\"" . PMX_MODULE . "/ModData\" />"
         . "<input type=\"submit\" value=\"" . _DLMODIFY . "\" />"
         . "</form></fieldset>";
        CloseTable();
        echo '<br />';
    }
    // Modify Category
    if ($num_categories > 0) {
        OpenTable();
        echo "<fieldset><legend>" . _MODCATEGORY . "</legend>"
         . "<form method=\"post\" action=\"" . adminUrl(PMX_MODULE) . "\">";
        echo _DLCATEGORY . ": <select name=\"cid\">" . modGetCategoriesSelect(0) . "</select>"
         . "<input type=\"hidden\" name=\"op\" value=\"" . PMX_MODULE . "/ModCat\" />"
         . "<input type=\"submit\" value=\"" . _DLMODIFY . "\" />"
         . "</form></fieldset>";
        CloseTable();
        echo '<br />';
    }
    // Add Category
    OpenTable();
    echo "<fieldset><legend>" . _DLADDSUBCATEGORY . "</legend>"
     . "<form method=\"post\" action=\"" . adminUrl(PMX_MODULE) . "\">"
     . "<table class=\"form\">"
     . modCategoryForm()
     . "<tr valign=\"top\"><td colspan=\"2\"><input type=\"hidden\" name=\"op\" value=\"" . PMX_MODULE . "/AddCat\" /><input type=\"submit\" value=\"" . _ADD . "\" /></td></tr>"
     . "</table>"
     . "</form></fieldset>";
    CloseTable();
    echo '<br />';
    // Transfer Categories
    if ($allnumrows > 0 && $num_categories > 1) {
        OpenTable();
        echo "<fieldset><legend>" . _DLTRANSFERDOWNLOADS . "</legend>"
         . "<form method=\"post\" action=\"" . adminUrl(PMX_MODULE) . "\">"
         . "<table class=\"form\">"
         . "<tr><td>" . _DLCATEGORY . ": </td><td><select name=\"cidfrom\">" . modGetCategoriesSelect(0, 'adminedit', 'hideemptycats') . "</select></td></tr>"
         . "<tr><td>" . _IN . "&nbsp;" . _DLCATEGORY . ": </td><td><select name=\"cidto\">" . modGetCategoriesSelect(0, 'adminedit') . "</select></td></tr>"
         . "<tr><td colspan=\"2\"><input type=\"hidden\" name=\"op\" value=\"" . PMX_MODULE . "/Transfer\" />"
         . "<input type=\"submit\" value=\"" . _DLTRANSFER . "\" /></td></tr>"
         . "</table>"
         . "</form>"
         . "</fieldset>";
        CloseTable();
        echo '<br />';
    }
    include ("footer.php");
}

/**
 * Beschreibung
 */
function modCategoryForm($cat = array())
{
    global $prefix;

    $editor = load_class('Textarea', array('name' => 'cdescription', 'value' => ((empty($cat['cdescription'])) ? '' : $cat['cdescription']), 'mode' => 'mini', 'height' => '130'));
    // $userconfig = load_class('Userconfig');
    // $groupoptions = getAllAccessLevelSelectOptions($userconfig->default_group);
    // mxDebugFuncVars($groupoptions);
    // _DLGROUPSEE, _DLGROUPDOWN
    $out = ""
     . "<tr valign=\"top\"><td>" . _NAME . ": </td><td><input type=\"text\" name=\"title\" size=\"60\" maxlength=\"100\" value=\"" . ((empty($cat['title'])) ? '' : htmlspecialchars($cat['title'])) . "\" /></td></tr>"
     . "<tr valign=\"top\"><td>" . _IN . "&nbsp;" . _DLCATEGORY . ":</td><td colspan=\"2\"><select name=\"parentid\">" . modGetCategoriesSelect(((empty($cat['parentid'])) ? 0 : intval($cat['parentid'])), 'adminedit') . "</select></td></tr>"
     . "<tr valign=\"top\"><td colspan=\"2\">" . _DLDESCRIPTION . ":<br />" . $editor->getHtml() . "</td></tr>"
    // . "<tr valign=\"top\"><td>" . _USERGROUPS . ":</td><td><select name=\"moveto_group\">" . $groupoptions . "</select></td></tr>"
    . "<tr valign=\"top\"><td>" . _DLUSECAPTCHA . "?</td><td>
     <input type=\"radio\" name=\"captcha\" value=\"1\"" . ((empty($cat['captcha'])) ? '' : ' checked="checked"') . ' />' . _YES . "&nbsp;
     <input type=\"radio\" name=\"captcha\" value=\"0\"" . ((empty($cat['captcha'])) ? ' checked="checked"' : '') . ' />' . _NO . "</td></tr>" ;
    return $out;
}

/**
 * Beschreibung
 */
function modModifyData($lid)
{
    global $prefix;
    $qry = "SELECT dd.*, dd.name as auth_name, dd.date as updated, dc.title AS ctitle, dc.parentid AS cparentid, de.downloadid AS editorialid
        FROM " . $prefix . "_downloads_downloads AS dd
        LEFT JOIN " . $prefix . "_downloads_categories AS dc ON dd.cid = dc.cid
        LEFT JOIN " . $prefix . "_downloads_editorials AS de ON dd.lid = de.downloadid
        WHERE dd.lid = " . intval($lid);
    $result = sql_query($qry);
    $row = sql_fetch_assoc($result);
    // falls die lid nicht existiert, abbrechen
    if (empty($row['lid'])) {
        mxErrorScreen('download id ' . intval($lid) . ' not found...');
    }
    include ("header.php");
    GraphicAdmin();
    modAdminMenu();
    OpenTable();
    modViewData($row, 'single', 'full');
    CloseTable();
    echo '<br />';
    OpenTable();
    echo "<fieldset><legend>" . _MODDOWNLOAD . "</legend>";
    echo '<form action="' . adminUrl(PMX_MODULE, 'ModDataSave') . '" method="post" name="downform" id="downform">'
     . "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"3\">"
     . modDataForm($row)
     . "<tr valign=\"top\"><td colspan=\"2\" align=\"center\"><input type=\"hidden\" name=\"op\" value=\"modifyrequestsave\" />"
     . "<br /><br /><input type=\"submit\" value=\"" . _DLMODIFY . "\" /> [&nbsp;<a href=\"" . adminUrl(PMX_MODULE, 'DelData', "lid=$lid") . "\">" . _DELETE . "</a> ]</td></tr>"
     . "</table>"
     . "<input type=\"hidden\" name=\"op\" value=\"" . PMX_MODULE . "/ModDataSave\" />"
     . "</form></fieldset>";
    CloseTable();
    echo '<br />';

    /**
     * Modify or Add Editorial
     */
    $resulted2 = sql_query("select adminid, editorialtimestamp, editorialtext, editorialtitle from " . $prefix . "_downloads_editorials where downloadid=" . intval($lid));
    $recordexist = sql_num_rows($resulted2);
    if ($recordexist) {
        list($adminid, $editorialtimestamp, $editorialtext, $editorialtitle) = sql_fetch_row($resulted2);
        $formatted_date = formattimestamp($editorialtimestamp);
    }

    $editor = load_class('Textarea', array('name' => 'editorialtext', 'value' => ((empty($editorialtext)) ? "" : $editorialtext), 'height' => '250'));

    OpenTable();
    if ($recordexist) {
        echo "<h3>" . _MODEDITORIAL . "</h3>"
         . "<form action=\"" . adminUrl(PMX_MODULE) . "\" method=\"post\">"
         . "<input type=\"hidden\" name=\"downloadid\" value=\"$lid\" />"
         . "<input type=\"hidden\" name=\"op\" value=\"" . PMX_MODULE . "/ModEditorial\" />"
         . _DLAUTHOR . ": $adminid<br />"
         . _DATEWRITTEN . ": $formatted_date<br /><br />"
         . _EDITORIALTITLE . ":<br /><input type=\"text\" name=\"editorialtitle\" value=\"" . mxEntityQuotes($editorialtitle) . "\" size=\"50\" maxlength=\"100\" /><br />"
         . _EDITORIALTEXT . ":<br />" . $editor->getHtml() . '<br />'
         . "<input type=\"submit\" value=\"" . _MODEDITORIAL . "\" /> [&nbsp;<a href=\"" . adminUrl(PMX_MODULE, 'DelEditorial', "downloadid=$lid") . "\">" . _DELETE . "</a>&nbsp;]";
    } else {
        echo "<fieldset><legend>" . _ADDEDITORIAL . "</legend>"
         . "<form action=\"" . adminUrl(PMX_MODULE) . "\" method=\"post\">"
         . "<input type=\"hidden\" name=\"downloadid\" value=\"$lid\" />"
         . "<input type=\"hidden\" name=\"op\" value=\"" . PMX_MODULE . "/AddEditorial\" />"
         . _EDITORIALTITLE . ":<br /><input type=\"text\" name=\"editorialtitle\" value=\"" . ((empty($editorialtitle)) ? "" : htmlspecialchars($editorialtitle)) . "\" size=\"50\" maxlength=\"100\" /><br />"
         . _EDITORIALTEXT . ":<br />" . $editor->getHtml() . '<br />'
         . "<input type=\"submit\" value=\"" . _ADDEDITORIAL . "\" />"
         . "</form></fieldset>";
    }
    CloseTable();
    echo '<br />';

    /**
     * Show Comments
     */
    $result5 = sql_query("SELECT ratingdbid, ratinguser, ratingcomments, ratingtimestamp FROM " . $prefix . "_downloads_votedata WHERE ratinglid = " . intval($lid) . " AND ratingcomments != '' ORDER BY ratingtimestamp DESC");
    $totalcomments = sql_num_rows($result5);
    OpenTable();
    echo '<table class="full list">';
    echo "<tr><td colspan=7><b>" . _NUMOFCOMMENTS . " (" . _OFALL . ": $totalcomments)</b><br /><br /></td></tr>";
    if ($totalcomments == 0) {
        echo "<tr><td colspan=7><center>" . _LNOCOMMENTS . "<br /></center></td></tr>";
    } else {
        echo "<tr><td width=20 colspan=1><b>" . _USER . "</b></td><td colspan=5><b>" . _LCOMMENT . "</b></td><th>" . _DELETE . "</th></tr>";
        $x = 0;
        $colorswitch = '';
        while (list($ratingdbid, $ratinguser, $ratingcomments, $ratingtimestamp) = sql_fetch_row($result5)) {
            $formatted_date = formattimestamp($ratingtimestamp);
            $colorswitch = ($colorswitch) ? '' : ' class="alternate-a"';
            echo "<tr $colorswitch><td>$ratinguser</td><td colspan=5>$ratingcomments</td><td><center><b><a href=\"" . adminUrl(PMX_MODULE, 'DelComment', "lid=$lid&amp;rid=$ratingdbid") . "\">X</a></b></center></td></tr>";
            $x++;
        }
    }
    // Show Registered Users Votes
    $result5 = sql_query("SELECT ratingdbid, ratinguser, rating, ratinghostname, ratingtimestamp FROM " . $prefix . "_downloads_votedata WHERE ratinglid = " . intval($lid) . " AND ratinguser != 'outside' AND ratinguser != '" . $GLOBALS['anonymous'] . "' ORDER BY ratingtimestamp DESC");
    $totalvotes = sql_num_rows($result5);
    echo "<tr><td colspan=7><br /><br /><b>" . _NOREGUSERSVOTES . " (" . _LTOTALVOTES . ": $totalvotes)</b><br /><br /></td></tr>";
    if ($totalvotes == 0) {
        echo "<tr><td colspan=7><center>" . _NOREGUSERSVOTES . "<br /></center></td></tr>";
    } else {
        echo "<tr><td><b>" . _USER . "</b></td><td><b>" . _WHONHOST1 . "</b></td><td><b>" . _RATING . "</b></td><td><b>" . _USERAVGRATING . "</b></td><td><b>" . _NUMBEROFRATINGS . "</b></td><td><b>" . _DATE . "</b></td><th>" . _DELETE . "</th></tr>";
        $x = 0;
        $colorswitch = '';
        while (list($ratingdbid, $ratinguser, $rating, $ratinghostname, $ratingtimestamp) = sql_fetch_row($result5)) {
            $formatted_date = formattimestamp($ratingtimestamp);
            // Individual user information
            $result2 = sql_query("SELECT rating FROM " . $prefix . "_downloads_votedata WHERE ratinguser = '$ratinguser'");
            $usertotalcomments = sql_num_rows($result2);
            $useravgrating = 0;
            while (list($rating2) = sql_fetch_row($result2)) {
                $useravgrating = $useravgrating + $rating2;
            }
            $useravgrating = $useravgrating / $usertotalcomments;
            $useravgrating = number_format($useravgrating, 1);
            $colorswitch = ($colorswitch) ? '' : ' class="alternate-a"';
            echo "<tr $colorswitch><td>$ratinguser</td><td>$ratinghostname</td><td>$rating</td><td>$useravgrating</td><td>$usertotalcomments</td><td>$formatted_date  </font></b></td><td><center><b><a href=\"" . adminUrl(PMX_MODULE, 'DelVote', "lid=$lid&amp;rid=$ratingdbid") . "\">X</a></b></center></td></tr>";
            $x++;
        }
    }
    // Show Unregistered Users Votes
    $result5 = sql_query("SELECT ratingdbid, rating, ratinghostname, ratingtimestamp FROM " . $prefix . "_downloads_votedata WHERE ratinglid = " . intval($lid) . " AND ratinguser = '" . $GLOBALS['anonymous'] . "' ORDER BY ratingtimestamp DESC");
    $totalvotes = sql_num_rows($result5);
    echo "<tr><td colspan=7><b><br /><br />" . _UNREGUSERSVOTES . " (" . _LTOTALVOTES . ": $totalvotes)</b><br /><br /></td></tr>";
    if ($totalvotes == 0) {
        echo "<tr><td colspan=7><center>" . _NOUNREGUSERSVOTES . "<br /></center></td></tr>";
    } else {
        echo "<tr><td colspan=2><b>" . _WHONHOST1 . "</b></td><td colspan=3><b>" . _RATING . "</b></td><td><b>" . _DATE . "</b></font></td><th>" . _DELETE . "</th></tr>";
        $x = 0;
        $colorswitch = '';
        while (list($ratingdbid, $rating, $ratinghostname, $ratingtimestamp) = sql_fetch_row($result5)) {
            $formatted_date = formattimestamp($ratingtimestamp);
            $colorswitch = ($colorswitch) ? '' : ' class="alternate-a"';
            echo "<tr $colorswitch><td colspan=2>$ratinghostname</td><td colspan=3>$rating</td><td>$formatted_date  </font></b></td><td><center><b><a href=\"" . adminUrl(PMX_MODULE, 'DelVote', "lid=$lid&amp;rid=$ratingdbid") . "\">X</a></b></center></td></tr>";
            $x++;
        }
    }
    // Show Outside Users Votes
    $result5 = sql_query("SELECT ratingdbid, rating, ratinghostname, ratingtimestamp FROM " . $prefix . "_downloads_votedata WHERE ratinglid = " . intval($lid) . " AND ratinguser = 'outside' ORDER BY ratingtimestamp DESC");
    $totalvotes = sql_num_rows($result5);
    echo "<tr><td colspan=7><b><br /><br />" . _OUTSIDEVOTERS . " (" . _LTOTALVOTES . ": $totalvotes)</b><br /><br /></td></tr>";
    if ($totalvotes == 0) {
        echo "<tr><td colspan=7><center>" . _NOOUTSIDEVOTES . " " . $GLOBALS['sitename'] . "<br /></center></td></tr>";
    } else {
        echo "<tr><td colspan=2><b>" . _WHONHOST1 . "</b></td><td colspan=3><b>" . _RATING . "</b></td><td><b>" . _DATE . "</b></td><th>" . _DELETE . "</th></tr>";
        $x = 0;
        $colorswitch = '';
        while (list($ratingdbid, $rating, $ratinghostname, $ratingtimestamp) = sql_fetch_row($result5)) {
            $formatted_date = formattimestamp($ratingtimestamp);
            $colorswitch = ($colorswitch) ? '' : ' class="alternate-a"';
            echo "<tr $colorswitch><td colspan=2>$ratinghostname</td><td colspan=3>$rating</td><td>$formatted_date  </font></b></td><td><center><b><a href=\"" . adminUrl(PMX_MODULE, 'DelVote', "lid=$lid&amp;rid=$ratingdbid") . "\">X</a></b></center></td></tr>";
            $x++;
        }
    }
    echo "</table>";
    CloseTable();
    echo '<br />';
    include ("footer.php");
}

/**
 * Beschreibung
 */
function modModifyDataSave()
{
    global $prefix;
    $_POST = modCheckData($_POST);
    $qry = "UPDATE " . $prefix . "_downloads_downloads SET
            cid=" . intval($_POST['cid']) . ",
            sid=0,
            title='" . mxAddSlashesForSQL($_POST['title']) . "',
            url='" . mxAddSlashesForSQL(mx_urltohtml($_POST['url'])) . "',
            description='" . mxAddSlashesForSQL($_POST['description']) . "',
            name='" . mxAddSlashesForSQL($_POST['auth_name']) . "',
            email='" . mxAddSlashesForSQL($_POST['email']) . "',
            hits=" . intval($_POST['hits']) . ",
            submitter='" . mxAddSlashesForSQL($_POST['submitter']) . "',
            filesize=" . intval($_POST['filesize']) . ",
            version='" . mxAddSlashesForSQL($_POST['version']) . "',
            homepage='" . mxAddSlashesForSQL($_POST['homepage']) . "',
            date='" . mxAddSlashesForSQL($_POST['updated']) . "'
            WHERE lid=" . intval($_POST['lid']);
    // mxDebugFuncVars($qry); exit;
    $result = sql_query($qry);
    if ($result) {
        // brokendownload=1 AND
        sql_query("DELETE FROM `{$prefix}_downloads_modrequest` WHERE lid=" . intval($_POST['lid']));
        mxRedirect(adminUrl(PMX_MODULE, 'ModData', 'lid=' . intval($_POST['lid'])), _CHANGESAREOK);
    } else {
        mxErrorScreen('Database Error (modModifyDataSave)<br /><br />' . sql_error());
    }
}

/**
 * Beschreibung
 */
function modDelComment($lid, $rid)
{
    global $prefix;
    sql_query("UPDATE " . $prefix . "_downloads_votedata SET ratingcomments='' WHERE ratingdbid = " . intval($rid));
    sql_query("UPDATE " . $prefix . "_downloads_downloads SET totalcomments = (totalcomments - 1) WHERE lid = " . intval($lid));
    mxRedirect(adminUrl(PMX_MODULE, 'ModData', 'lid=' . $lid), _CHANGESAREOK);
}

/**
 * Beschreibung
 */
function modDelVote($lid, $rid)
{
    global $prefix;
    sql_query("delete from " . $prefix . "_downloads_votedata where ratingdbid=$rid");
    $voteresult = sql_query("select rating, ratinguser, ratingcomments FROM " . $prefix . "_downloads_votedata WHERE ratinglid = " . intval($lid));
    $totalvotesDB = sql_num_rows($voteresult);
    include ("modules/" . PMX_MODULE . "/includes/voteinclude.php");
    sql_query("UPDATE " . $prefix . "_downloads_downloads SET downloadratingsummary=$finalrating,totalvotes=$totalvotesDB,totalcomments=$truecomments WHERE lid = " . intval($lid));
    mxRedirect(adminUrl(PMX_MODULE, 'ModData', 'lid=' . $lid), _CHANGESAREOK);
}

/**
 * Beschreibung
 */
function modListBroken()
{
    global $prefix, $user_prefix, $modimagepath;

    $img_check = mxCreateImage($modimagepath . 'check.gif', _DOWNLOADVALIDATION, array('title' => _DOWNLOADVALIDATION));
    $img_delete = mxCreateImage($modimagepath . 'delete.gif', _DELETE, array('title' => _DELETE));
    $img_edit = mxCreateImage($modimagepath . 'edit.gif', _EDIT, array('title' => _EDITTHISDOWNLOAD));
    $img_ignore = mxCreateImage($modimagepath . 'tag_blue.gif', _IGNORE, array('title' => _IGNORE));

    $result = sql_query("select requestid, lid, modifysubmitter from " . $prefix . "_downloads_modrequest where brokendownload=1 ORDER BY requestid");
    $totalbroken = sql_num_rows($result);

    include ("header.php");
    GraphicAdmin();
    modAdminMenu();
    OpenTable();
    echo '<h3>' . _DUSERREPBROKEN . ' (' . $totalbroken . ')</h3>'
     . '<ul class="infolist">'
     . '<li>' . $img_ignore . '&nbsp;' . _DIGNOREINFO . '</li>'
     . '<li>' . $img_delete . '&nbsp;' . _DDELETEINFO . '</li>'
     . '</ul>';
    if ($totalbroken == 0) {
        echo '<center><font class="content">' . _DNOREPORTEDBROKEN . '</font></center><br /><br /><br />';
    } else {
        $colorswitch = '';
        echo '<table class="full list">'
         . '<tr>'
         . '<th>' . _MODITEMS . '</th>'
         . '<th width="1%">' . 'check' . '</th>'
         . '<th width="1%">' . _IGNORE . '</th>'
         . '<th width="1%">' . _DELETE . '</th>'
         . '<th width="1%">' . _EDIT . '</th>'
         . '<th>' . _DLSUBMITTER . '</th>'
         . '<th>' . _DOWNLOADOWNER . '</th>'
         . '</tr>';
        while (list($requestid, $lid, $modifysubmitter) = sql_fetch_row($result)) {
            $result2 = sql_query("select title, url, submitter from " . $prefix . "_downloads_downloads where lid=" . intval($lid));
            if ($modifysubmitter != $GLOBALS['anonymous']) {
                $result3 = sql_query("select email from {$user_prefix}_users where uname='" . mxAddSlashesForSQL($modifysubmitter) . "'");
                list($email) = sql_fetch_row($result3);
            }
            list($title, $url, $owner) = sql_fetch_row($result2);
            $result4 = sql_query("select email from {$user_prefix}_users where uname='" . mxAddSlashesForSQL($owner) . "'");
            list($owneremail) = sql_fetch_row($result4);
            if (!empty($email)) {
                $modifysubmitter = "<a href=\"mailto:$email\">$modifysubmitter</a>";
            }
            if (!empty($owneremail)) {
                $owner = "<a href=\"mailto:$owneremail\">$owner</a>";
            }
            $colorswitch = ($colorswitch) ? '' : ' class="alternate-a"';
            echo '<tr ' . $colorswitch . '>'
             . '<td><a href="' . $url . '">' . $title . '</a></td>'
             . '<td><center>' . modCheckPopupLink($url, $img_check) . '</center></td>'
             . '<td><center><a href="' . adminUrl(PMX_MODULE, 'IgnoreBroken', 'lid=' . $lid) . '">' . $img_ignore . '</a></center></td>'
             . '<td><center><a href="' . adminUrl(PMX_MODULE, 'DelBroken', 'lid=' . $lid) . '">' . $img_delete . '</a></center></td>'
             . '<td><center><a href="' . adminUrl(PMX_MODULE, 'ModData', 'lid=' . $lid) . '">' . $img_edit . '</a></center></td>'
             . '<td>' . $modifysubmitter . '</td>'
             . '<td>' . $owner . '</td>'
             . '</tr>';
        }
        echo "</table>";
    }
    CloseTable();
    include ("footer.php");
}

/**
 * Beschreibung
 */
function modDelBroken($lid)
{
    global $prefix;
    // mxDebugFuncVars($_REQUEST);
    $lid = (isset($_REQUEST['lid'])) ? intval($_REQUEST['lid']) : 0;
    if (!isset($_POST['okdelete'])) {
        $qry = "SELECT dd.*, dd.name as auth_name, dd.date as updated, dc.title AS ctitle, dc.parentid AS cparentid, de.downloadid AS editorialid
            FROM " . $prefix . "_downloads_downloads AS dd
            LEFT JOIN " . $prefix . "_downloads_categories AS dc ON dd.cid = dc.cid
            LEFT JOIN " . $prefix . "_downloads_editorials AS de ON dd.lid = de.downloadid
            WHERE dd.lid = " . intval($lid);
        $result = sql_query($qry);
        $row = sql_fetch_assoc($result);
        include("header.php");
        OpenTable();
        modViewData($row, 'single', 'full');
        CloseTable();
        echo '<br />';
        OpenTable();
        echo '<div align="center">' . _DLAREYOUSURE . '<br /><br />' . _DDELETEINFO . '<br /><br />
        <form action="' . adminUrl(PMX_MODULE, 'DelBroken') . '" method="post">
        <input type="hidden" name="op" value="' . PMX_MODULE . '/DelBroken" />
        <input type="hidden" name="lid" value="' . $lid . '" />
        <input type="submit" name="okdelete" value="' . _YES . '" />&nbsp;&nbsp;<input type="submit" name="okdelete" value="' . _NO . '" />
        </form></div>';
        CloseTable();
        include("footer.php");
    } else {
        if ($_POST['okdelete'] != _YES || empty($lid)) {
            mxRedirect(adminUrl(PMX_MODULE, 'ListBroken'));
        } else {
            sql_query("delete from " . $prefix . "_downloads_downloads where lid=" . intval($lid));
            $notdeleted = modCheckAndCleanSubdata($lid);
            if ($notdeleted) {
                mxErrorScreen('Database Error (modDelBroken)<br /><br />' . sql_error());
            } else {
                mxRedirect(adminUrl(PMX_MODULE, 'ListBroken'), _DLDELETED);
            }
        }
    }
}

/**
 * Beschreibung
 */
function modIgnoreBroken($lid)
{
    global $prefix;
    $result = sql_query("delete from " . $prefix . "_downloads_modrequest where lid=" . intval($lid) . " and brokendownload=1");
    if ($result) {
        mxRedirect(adminUrl(PMX_MODULE, 'ListBroken'), _CHANGESAREOK);
    } else {
        mxErrorScreen('Database Error (modIgnoreBroken)<br /><br />' . sql_error());
    }
}

/**
 * Beschreibung
 */
function modListModRequests()
{
    global $modimagepath, $prefix, $user_prefix;
    $img_check = mxCreateImage($modimagepath . 'check.gif', _DOWNLOADVALIDATION, array('title' => _DOWNLOADVALIDATION));
    $result = sql_query("select requestid, lid, cid, title, url, description, modifysubmitter, name, email, filesize, version, homepage, updated from " . $prefix . "_downloads_modrequest where brokendownload=0 ORDER BY requestid");
    $totalmodrequests = sql_num_rows($result);
    $i = 0;
    include ("header.php");
    GraphicAdmin();
    modAdminMenu();
    OpenTable();
    echo "<h3>" . _DUSERMODREQUEST . " ($totalmodrequests)</h3>";
    while (list($requestid, $lid, $cid, $title, $url, $description, $modifysubmitter, $name, $email, $filesize, $version, $homepage, $updated) = sql_fetch_row($result)) {
        $i++;
        $result2 = sql_query("select cid, title, url, description, name, email, submitter, filesize, version, homepage, date as updated from " . $prefix . "_downloads_downloads where lid=$lid");
        list($origcid, $origtitle, $origurl, $origdescription, $origname, $origemail, $owner, $origfilesize, $origversion, $orighomepage, $origupdated) = sql_fetch_row($result2);
        $result3 = sql_query("select title from " . $prefix . "_downloads_categories where cid=$cid");
        $result5 = sql_query("select title from " . $prefix . "_downloads_categories where cid=$origcid");
        $result7 = sql_query("select email from {$user_prefix}_users where uname='$modifysubmitter'");
        $result8 = sql_query("select email from {$user_prefix}_users where uname='$owner'");
        list($cidtitle) = sql_fetch_row($result3);
        list($origcidtitle) = sql_fetch_row($result5);
        list($modifysubmitteremail) = sql_fetch_row($result7);
        list($owneremail) = sql_fetch_row($result8);
        if (!$owner) {
            $owner = "administration";
        }
        if ($owneremail) {
            $owner = "<a href=\"mailto:$owneremail\">$owner</a>";
        }
        $modifysubmitter = ($modifysubmitter) ? $modifysubmitter : $GLOBALS['anonymous'];
        if ($modifysubmitteremail) {
            $modifysubmitter = "<a href=\"mailto:$modifysubmitteremail\">$modifysubmitter</a>";
        }

        ?>

<table class="full list">
<tr valign="top">
  <th width="16%">#<?php echo $i ?></th>
  <th width="41%"><?php echo _DLORIGINAL ?></th>
  <th width="2%">&nbsp;</th>
  <th width="41%"><?php echo _DLPROPOSED ?></th>
</tr>
<tr valign="top">
  <td class="tiny"><?php echo _DLTITLE ?>:</td>
  <td><b><?php echo $origtitle ?></b></td>
  <td><?php echo modVisulizeDiff($origtitle, $title) ?></td>
  <td><b><?php echo $title ?></b></td>
</tr>
<tr valign="top" class="alternate">
  <td class="tiny"><?php echo _DLFILEURL ?>:</td>
  <td>
    <a href="<?php echo $origurl ?>"><?php echo mxCutString($origurl, 45) ?></a>
    <?php echo modCheckPopupLink($origurl, $img_check) ?>
  </td>
  <td><?php echo modVisulizeDiff($origurl, $url) ?></td>
  <td>
    <a href="<?php echo $url ?>"><?php echo mxCutString($url, 45) ?></a>
    <?php echo modCheckPopupLink($url, $img_check) ?>
  </td>
</tr>
<tr valign="top">
  <td class="tiny"><?php echo _DLDESCRIPTION ?>:</td>
  <td><?php echo $origdescription ?></td>
  <td><?php echo modVisulizeDiff($origdescription, $description) ?></td>
  <td><?php echo $description ?></td>
</tr>
<tr valign="top" class="alternate">
  <td class="tiny"><?php echo _DLCATEGORY ?>:</td>
  <td><?php echo $origcidtitle ?></td>
  <td><?php echo modVisulizeDiff($origcidtitle, $cidtitle) ?></td>
  <td><?php echo $cidtitle ?></td>
</tr>
<tr valign="top">
  <td class="tiny"><?php echo _DLAUTHORNAME ?>:</td>
  <td><?php echo $origname ?></td>
  <td><?php echo modVisulizeDiff($origname, $name) ?></td>
  <td><?php echo $name ?></td>
</tr>
<tr valign="top" class="alternate">
  <td class="tiny"><?php echo _DLAUTHOREMAIL ?>:</td>
  <td><?php echo $origemail ?></td>
  <td><?php echo modVisulizeDiff($origemail, $email) ?></td>
  <td><?php echo $email ?></td>
</tr>
<tr valign="top">
  <td class="tiny"><?php echo _LASTUPDATED ?>:</td>
  <td><?php echo formatTimestamp($origupdated) ?></td>
  <td><?php echo modVisulizeDiff($origupdated, $updated) ?></td>
  <td><?php echo formatTimestamp($updated) ?></td>
</tr>
<tr valign="top" class="alternate">
  <td class="tiny"><?php echo _DLFILESIZE ?>:</td>
  <td><?php echo modFormatFilesize($origfilesize) ?></td>
  <td><?php echo modVisulizeDiff($origfilesize, $filesize) ?></td>
  <td><?php echo modFormatFilesize($filesize);

        ?></td>
</tr>
<tr valign="top">
  <td class="tiny"><?php echo _DLVERSION ?>:</td>
  <td><?php echo $origversion ?></td>
  <td><?php echo modVisulizeDiff($origversion, $version) ?></td>
  <td><?php echo $version ?></td>
</tr>
<tr valign="top" class="alternate">
  <td class="tiny"><?php echo _DLHOMEPAGE ?>:</td>
  <td><a href="<?php echo $orighomepage ?>" target="new"><?php echo mxCutString($orighomepage, 45) ?></a></td>
  <td><?php echo modVisulizeDiff($orighomepage, $homepage) ?></td>
  <td><a href="<?php echo $homepage ?>" target="new"><?php echo mxCutString($homepage, 45) ?></a></td>
</tr>

<tr class="alternate-2">
<td colspan="2">
  <p><?php echo _DLSUBMITTER . ': ' . $modifysubmitter ?></p>
  <p><?php echo _OWNER . ': ' . $owner ?></p>
</td>
<td align="center" valign="middle" colspan="2">
  <a href="<?php echo adminUrl(PMX_MODULE, 'ChangeModRequests', 'requestid=' . $requestid) ?>" class="button"><?php echo _ACCEPT ?></a>
  <a href="<?php echo adminUrl(PMX_MODULE, 'ChangeIgnoreRequests', 'requestid=' . $requestid) ?>" class="button"><?php echo _IGNORE ?></a>
  <a href="<?php echo adminUrl(PMX_MODULE, 'ModData', 'lid=' . $lid) ?>" class="button"><?php echo _EDITTHISDOWNLOAD ?></a>
</td>
</tr>

</table>

<?php
    }
    if ($totalmodrequests == 0) {
        echo "<center><p class=\"note\">" . _NOMODREQUESTS . '</p><br /><br />'
         . _GOBACK . "<br /><br /></center>";
    }

    CloseTable();
    include ("footer.php");
}

/**
 * Beschreibung
 */
function modChangeModRequests($requestid)
{
    global $prefix;
    $result = sql_query("select requestid, lid, cid, title, url, description, name, email, filesize, version, homepage, updated from " . $prefix . "_downloads_modrequest where requestid=" . intval($requestid));
    list($requestid, $lid, $cid, $title, $url, $description, $name, $email, $filesize, $version, $homepage, $updated) = sql_fetch_row($result);
    if (!empty($lid)) {
        $ok = sql_query("UPDATE " . $prefix . "_downloads_downloads SET
            cid=" . intval($cid) . ",
            sid=0,
            title='" . mxAddSlashesForSQL($title) . "',
            url='" . mxAddSlashesForSQL(mx_urltohtml($url)) . "',
            description='" . mxAddSlashesForSQL($description) . "',
            name='" . mxAddSlashesForSQL($name) . "',
            email='" . mxAddSlashesForSQL($email) . "',
            filesize='" . intval($filesize) . "',
            version='" . mxAddSlashesForSQL($version) . "',
            homepage='" . mxAddSlashesForSQL($homepage) . "',
            date='" . mxAddSlashesForSQL($updated) . "'
            WHERE lid = " . intval($lid));
        if ($ok) {
            sql_query("DELETE FROM " . $prefix . "_downloads_modrequest where requestid=" . intval($requestid));
            mxRedirect(adminUrl(PMX_MODULE, 'ModData', 'lid=' . $lid), _CHANGESAREOK);
        } else {
            mxErrorScreen('Database Error (modChangeModRequests)<br /><br />' . sql_error());
        }
    } else {
        mxRedirect(adminUrl(PMX_MODULE, 'ListModRequests'), 'ERROR: Recordset not found...', 5);
    }
}

/**
 * Beschreibung
 */
function modChangeIgnoreRequests($lid)
{
    global $prefix;
    $result = sql_query("delete from " . $prefix . "_downloads_modrequest where requestid=" . intval($lid));
    if ($result) {
        mxRedirect(adminUrl(PMX_MODULE, 'ListModRequests'), _CHANGESAREOK);
    } else {
        mxErrorScreen('Database Error (modChangeIgnoreRequests)<br /><br />' . sql_error());
    }
}

/**
 * Beschreibung
 */
function modCleanVotes()
{
    global $prefix;
    if (!empty($_POST['okdelete'])) {
        $cid = (empty($_POST['cid'])) ? 0 : intval($_POST['cid']);
        if ($_POST['okdelete'] == _NO) {
            mxRedirect(adminUrl(PMX_MODULE));
        }
        $totalvoteresult = sql_query("select distinct ratinglid FROM " . $prefix . "_downloads_votedata");
        while (list($lid) = sql_fetch_row($totalvoteresult)) {
            $voteresult = sql_query("select rating, ratinguser, ratingcomments FROM " . $prefix . "_downloads_votedata WHERE ratinglid = " . intval($lid));
            $totalvotesDB = sql_num_rows($voteresult);
            include ("modules/" . PMX_MODULE . "/includes/voteinclude.php");
            sql_query("UPDATE " . $prefix . "_downloads_downloads SET downloadratingsummary=$finalrating,totalvotes=$totalvotesDB,totalcomments=$truecomments WHERE lid = $lid");
        }
        mxRedirect(adminUrl(PMX_MODULE), _CHANGESAREOK);
    } else {
        include("header.php");
        modAdminMenu();
        OpenTableAl();
        echo "<div align=\"center\" class=\"option\">" . _CLEANDOWNLOADSDB . "</div><br /><br /><font class=\"content\">";
        echo _DELVOTEWARNING;
        echo '<div align="center"><br /><br />
        <form action="' . adminUrl(PMX_MODULE) . '" method="post">
        <input type="hidden" name="op" value="' . PMX_MODULE . '/CleanVotes" />
        <input type="submit" name="okdelete" value="' . _YES . '" />&nbsp;&nbsp;<input type="submit" name="okdelete" value="' . _NO . '" />
        </form></div>';
        CloseTableAl();
        include("footer.php");
    }
}

/**
 * Beschreibung
 */
function modModifyCat()
{
    global $prefix;
    $cid = intval($_REQUEST['cid']);
    $qry = "select cid, title, cdescription, parentid, captcha from " . $prefix . "_downloads_categories where cid=" . $cid;
    // mxDebugFuncVars($qry);
    $result = sql_query($qry);
    $cat = sql_fetch_assoc($result);
    include ("header.php");
    GraphicAdmin();
    modAdminMenu();
    OpenTable();
    echo "<fieldset><legend>" . _MODCATEGORY . "</legend>"
     . "<form method=\"post\" action=\"" . adminUrl(PMX_MODULE, "ModCat&amp;cid=" . $cid) . "\">"
     . "<table class=\"form\">"
     . modCategoryForm($cat)
     . "<tr valign=\"top\"><td colspan=\"2\">
    <input type=\"hidden\" name=\"cid\" value=\"" . $cid . "\" />
    <input type=\"hidden\" name=\"op\" value=\"" . PMX_MODULE . "/ModCatSave\" />
    <input type=\"submit\" value=\"" . _SAVECHANGES . "\" />
    &nbsp;&nbsp;&nbsp;[&nbsp;<a href=\"" . adminUrl(PMX_MODULE, 'DelCat', "cid=" . $cid) . "\">" . _DELETE . "</a>&nbsp;]
    </td></tr>"
     . "</table>"
     . "</form></fieldset>";
    CloseTable();
    include("footer.php");
}

/**
 * Beschreibung
 */
function modAddCat()
{
    global $prefix;
    if (empty($_POST['parentid'])) {
        $_POST['parentid'] = 0;
    }
    $_POST['title'] = strip_tags(trim($_POST['title']));
    if (empty($_POST['title'])) {
        $error = _DOWNCATNOTITLE;
    } else {
        $result = sql_query("select cid from " . $prefix . "_downloads_categories where title='" . mxAddSlashesForSQL($_POST['title']) . "' AND parentid=" . intval($_POST['parentid']));
        if ((sql_num_rows($result))) {
            $error = _ERRORTHESUBCATEGORY . " <i>" . mxStripSlashes($_POST['title']) . "</i> " . _ALREADYEXIST;
        }
    }
    if (isset($error)) {
        include("header.php");
        GraphicAdmin();
        modAdminMenu();
        OpenTable();
        echo "<br /><center><font class=\"content\"><b>" . $error . "</b><br /><br />" . _GOBACK . "<br /><br /></center>";
        CloseTable();
        include("footer.php");
    } else {
        $result = sql_query("insert into " . $prefix . "_downloads_categories (title, cdescription, parentid, captcha) values ('" . mxAddSlashesForSQL($_POST['title']) . "', '" . mxAddSlashesForSQL($_POST['cdescription']) . "', '" . intval($_POST['parentid']) . "', '" . intval($_POST['captcha']) . "')");
        if ($result) {
            mxRedirect(adminUrl(PMX_MODULE), _CHANGESAREOK);
        } else {
            mxErrorScreen('Database Error (modAddCat)<br /><br />' . sql_error());
        }
    }
}

/**
 * Beschreibung
 */
function modModifyCatSave()
{
    global $prefix;
    $_POST['parentid'] = (empty($_POST['parentid'])) ? 0 : intval($_POST['parentid']);
    $_POST['title'] = trim(strip_tags(stripslashes($_POST['title'])));
    if (empty($_POST['title'])) {
        $error = _DOWNCATNOTITLE;
    } else if ($_POST['parentid'] == $_POST['cid']) {
        $error = _ERRORTHECATEGORY . ' &quot;' . $_POST['title'] . '&quot; == ' . _SUBCATEGORY . ' &quot;' . $_POST['title'] . '&quot;';
    } else {
        $result = sql_query("select count(cid) from " . $prefix . "_downloads_categories where title='" . mxAddSlashesForSQL($_POST['title']) . "' AND parentid=" . intval($_POST['parentid']) . " AND cid<>" . intval($_POST['cid']));
        list($exist) = sql_fetch_row($result);
        if ($exist) {
            $error = _ERRORTHESUBCATEGORY . " <i>" . mxStripSlashes($_POST['title']) . "</i> " . _ALREADYEXIST;
        }
    }
    if (isset($error)) {
        include("header.php");
        GraphicAdmin();
        modAdminMenu();
        OpenTable();
        echo "<br /><center><font class=\"content\"><b>" . $error . "</b><br /><br />" . _GOBACK . "<br /><br /></center>";
        CloseTable();
        include("footer.php");
    } else {
        $ok = sql_query("update " . $prefix . "_downloads_categories set title='" . mxAddSlashesForSQL($_POST['title']) . "', cdescription='" . mxAddSlashesForSQL($_POST['cdescription']) . "', parentid=" . intval($_POST['parentid']) . ", captcha=" . intval($_POST['captcha']) . " where cid=" . intval($_POST['cid']));
        if ($ok) {
            mxRedirect(adminUrl(PMX_MODULE, 'ModCat', 'cid=' . intval($_POST['cid'])), _CHANGESAREOK);
        } else {
            mxErrorScreen('Database Error (modModifyCatSave)<br /><br />' . sql_error());
        }
    }
}

/**
 * Beschreibung
 */
function modDelCat()
{
    global $prefix;
    if (!empty($_POST['okdelete'])) {
        $cid = (empty($_POST['cid'])) ? 0 : intval($_POST['cid']);
        if ($_POST['okdelete'] == _NO) {
            mxRedirect(adminUrl(PMX_MODULE, 'ModCat', 'cid=' . intval($cid)) . '');
        }
        // TODO: das taugt noch nix, der verknuepfte Kram muss noch geloescht werden
        sql_query("delete from " . $prefix . "_downloads_downloads where cid=" . intval($cid));
        // suppression des liens de cat?ries filles
        $result2 = sql_query("select cid from " . $prefix . "_downloads_categories where parentid=" . intval($cid));
        while (list($cid2) = sql_fetch_row($result2)) {
            sql_query("delete from " . $prefix . "_downloads_downloads where cid=" . intval($cid2));
        }
        sql_query("delete from " . $prefix . "_downloads_categories where parentid=" . intval($cid));
        sql_query("delete from " . $prefix . "_downloads_categories where cid=" . intval($cid));
        mxRedirect(adminUrl(PMX_MODULE), _DLCATDELETED);
    } else {
        $cid = (empty($_REQUEST['cid'])) ? 0 : intval($_REQUEST['cid']);
        $result = sql_query("select count(cid) from " . $prefix . "_downloads_categories where parentid=" . intval($cid));
        list($nbsubcat) = sql_fetch_row($result);
        $nblink = modCountAll($cid);
        include("header.php");
        // GraphicAdmin();
        modAdminMenu();
        OpenTable();
        echo "<div align=\"center\" class=\"option\">" . _DELETECATEGORY . "</div><br /><br /><font class=\"content\">";
        echo _DLTHEREARE . " <b>" . $nbsubcat . "</b> " . _DLSUBCAT . " " . _DLATTACHEDTOCAT . '<br />';
        echo _DLTHEREARE . " <b>" . $nblink . "</b> " . _MODITEMS . " " . _DLATTACHEDTOCAT . '<br /><br />';
        echo _DLCATWARNING;
        echo '<div align="center"><br /><br />
        <form action="' . adminUrl(PMX_MODULE) . '" method="post">
        <input type="hidden" name="op" value="' . PMX_MODULE . '/DelCat" />
        <input type="hidden" name="cid" value="' . $cid . '" />
        <input type="submit" name="okdelete" value="' . _YES . '" />&nbsp;&nbsp;<input type="submit" name="okdelete" value="' . _NO . '" />
        </form></div>';
        CloseTable();
        include("footer.php");
    }
}

/**
 * Beschreibung
 */
function modTransferToCat($cidfrom, $cidto)
{
    global $prefix;
    $result = sql_query("update " . $prefix . "_downloads_downloads set cid=" . intval($cidto) . " where cid=" . intval($cidfrom));
    if ($result) {
        mxRedirect(adminUrl(PMX_MODULE), _CHANGESAREOK);
    } else {
        mxErrorScreen('Database Error (modTransferToCat)<br /><br />' . sql_error());
    }
}

/**
 * Beschreibung
 */
function modDelData($lid)
{
    global $prefix;
    // mxDebugFuncVars($_REQUEST);
    $lid = (isset($_REQUEST['lid'])) ? intval($_REQUEST['lid']) : 0;
    if (!isset($_POST['okdelete'])) {
        include("header.php");
        $qry = "SELECT dd.*, dd.name as auth_name, dd.date as updated, dc.title AS ctitle, dc.parentid AS cparentid, de.downloadid AS editorialid
            FROM " . $prefix . "_downloads_downloads AS dd
            LEFT JOIN " . $prefix . "_downloads_categories AS dc ON dd.cid = dc.cid
            LEFT JOIN " . $prefix . "_downloads_editorials AS de ON dd.lid = de.downloadid
            WHERE dd.lid = " . intval($lid);
        $result = sql_query($qry);
        $row = sql_fetch_assoc($result);
        OpenTable();
        modViewData($row, 'single', 'full');
        CloseTable();
        echo '<br />';
        OpenTable();
        echo '<div align="center">' . _DLAREYOUSURE . '<br /><br />
        <form action="' . adminUrl(PMX_MODULE, 'DelData') . '" method="post">
        <input type="hidden" name="op" value="' . PMX_MODULE . '/DelData" />
        <input type="hidden" name="lid" value="' . $lid . '" />
        <input type="submit" name="okdelete" value="' . _YES . '" />&nbsp;&nbsp;<input type="submit" name="okdelete" value="' . _NO . '" />
        </form></div>';
        CloseTable();
        include("footer.php");
    } else {
        if ($_POST['okdelete'] != _YES || empty($lid)) {
            mxRedirect(adminUrl(PMX_MODULE));
        } else {
            sql_query("delete from " . $prefix . "_downloads_downloads where lid=" . intval($lid));
            $notdeleted = modCheckAndCleanSubdata($lid);
            if ($notdeleted) {
                mxErrorScreen('Database Error (modDelData)<br /><br />' . sql_error());
            } else {
                mxRedirect(adminUrl(PMX_MODULE), _DLDELETED);
            }
        }
    }
}

/**
 * Beschreibung
 */
function modDelNew()
{
    global $prefix;
    // mxDebugFuncVars($_REQUEST);
    $lid = (isset($_REQUEST['lid'])) ? intval($_REQUEST['lid']) : 0;
    if (!isset($_POST['okdelete'])) {
        include("header.php");
        OpenTable();
        echo '<div align="center">' . _DLAREYOUSURE . '<br /><br />
        <form action="' . adminUrl(PMX_MODULE, 'DelNew') . '" method="post">
        <input type="hidden" name="op" value="' . PMX_MODULE . '/DelNew" />
        <input type="hidden" name="lid" value="' . $lid . '" />
        <input type="submit" name="okdelete" value="' . _YES . '" />&nbsp;&nbsp;<input type="submit" name="okdelete" value="' . _NO . '" />
        </form></div>';
        CloseTable();
        include("footer.php");
    } else {
        if ($_POST['okdelete'] != _YES || empty($lid)) {
            mxRedirect(adminUrl(PMX_MODULE));
        } else {
            sql_query("delete from " . $prefix . "_downloads_newdownload where lid=" . $lid);
            mxRedirect(adminUrl(PMX_MODULE), _DLDELETED);
        }
    }
}

/**
 * Beschreibung
 */
function modAddEditorial($downloadid, $editorialtitle, $editorialtext)
{
    global $aid, $prefix;
    $result = sql_query("insert into " . $prefix . "_downloads_editorials values (" . intval($downloadid) . ", '" . mxAddSlashesForSQL($aid) . "', now(), '" . mxAddSlashesForSQL($editorialtext) . "', '" . mxAddSlashesForSQL($editorialtitle) . "')");
    if ($result) {
        mxRedirect(adminUrl(PMX_MODULE, 'ModData', 'lid=' . $downloadid), _EDITORIALADDED, 3);
    } else {
        mxErrorScreen('Database Error (modAddEditorial)<br /><br />' . sql_error());
    }
}

/**
 * Beschreibung
 */
function modModifyEditorial($downloadid, $editorialtitle, $editorialtext)
{
    global $prefix;
    $result = sql_query("update " . $prefix . "_downloads_editorials set editorialtext='" . mxAddSlashesForSQL($editorialtext) . "', editorialtitle='" . mxAddSlashesForSQL($editorialtitle) . "' where downloadid=" . intval($downloadid));
    if ($result) {
        mxRedirect(adminUrl(PMX_MODULE, 'ModData', 'lid=' . $downloadid), _EDITORIALMODIFIED, 3);
    } else {
        mxErrorScreen('Database Error (modModifyEditorial)<br /><br />' . sql_error());
    }
}

/**
 * Beschreibung
 */
function modDelEditorial($downloadid)
{
    global $prefix;
    $result = sql_query("delete from " . $prefix . "_downloads_editorials where downloadid=" . intval($downloadid));
    if ($result) {
        mxRedirect(adminUrl(PMX_MODULE, 'ModData', 'lid=' . $downloadid), _EDITORIALREMOVED, 3);
    } else {
        mxErrorScreen('Database Error (modDelEditorial)<br /><br />' . sql_error());
    }
}

/**
 * Beschreibung
 */
function modCheckResponse()
{
    global $prefix, $modimagepath;
    // mxDebugFuncVars($_POST);
    $cids = (isset($_REQUEST['cids'])) ? $_REQUEST['cids'] : array(0);

    include ("header.php");
    GraphicAdmin();
    modAdminMenu();
    OpenTable();
    echo '<fieldset><legend>' . _DOWNLOADVALIDATION . '</legend>
    <form action="' . adminUrl(PMX_MODULE, 'Check', '', '#result') . '" method="post" name="jump" id="jump">
            <b>' . _CHECKCATEGORIES . '</b><br />
            <select name="cids[]" size="15" multiple="multiple">' . modGetCategoriesSelect($cids, 'adminedit', 'hideemptycats') . '</select> <br />
            <input type="submit" value="' . _DLGO . '" />
            <input type="hidden" name="op" value="' . PMX_MODULE . '/Check" />
    </form>
    </fieldset>
    ';
    CloseTable();
    echo '<br />';
    // Ergebnisse
    if (isset($_REQUEST['cids']) && is_array($cids)) {
        ini_set("max_execution_time", '0');
        set_time_limit(0);

        $img_edit = mxCreateImage($modimagepath . 'edit.gif', _EDIT, array('title' => _EDITTHISDOWNLOAD));
        $img_dele = mxCreateImage($modimagepath . 'delete.gif', _DELETE, array('title' => _DELETE));
        $img_view = mxCreateImage($modimagepath . 'check.gif', _DOWNLOADVALIDATION, array('title' => _DOWNLOADVALIDATION));

        $cids = implode(',', $cids);
        $qry = "SELECT dd.*, dc.title AS ctitle, dc.parentid AS cparentid
            FROM " . $prefix . "_downloads_downloads AS dd
            LEFT JOIN " . $prefix . "_downloads_categories AS dc ON dd.cid = dc.cid
            WHERE dd.cid IN(" . $cids . ")
            ORDER BY dd.cid, dd.title";
        $result = sql_query($qry);
        $lastcid = '--dummy--';
        $colorswitch = '';
        while ($row = sql_fetch_assoc($result)) {
            $colorswitch = ($colorswitch) ? '' : ' class="alternate-a"';
            // wenn andere Kategorie als vorher
            if ($row['cid'] !== $lastcid) {
                $cattitle = (empty($row['ctitle'])) ? 'HIDDEN (' . _DOWNLOADSMAINCAT . ')' : modGetParentTitles($row['cparentid'], $row['ctitle']);
                // Zwischenueberschrift ausgeben und $lastsid zuruecksetzen
                $rows[] = '<tr ' . $colorswitch . '><td colspan="5">' . _VALIDATINGCAT . ': <b>' . $cattitle . '</b></td></tr>';
                $rows[] = '<tr ' . $colorswitch . '>
                        <th colspan="3">' . _STATUS . '</th>
                        <th>' . _DOWNLOADTITLE . '</th>
                        <th width="10%">' . _FUNCTIONS . '</th>
                        </tr>';
                $lastcid = $row['cid'];
                $colorswitch = ($colorswitch) ? '' : ' class="alternate-a"';
            }
            clearstatcache();
            $header = modGetResponseHeader($row['url']);
            if ($header['status'] >= 200 && $header['status'] < 300 && $header['type']) {
                $status = '<div style="background-color: Green; color: Yellow; padding: 2px;">' . _OK . '</div>';
            } else if (($header['status'] > 0 && $header['status'] < 200) || ($header['status'] >= 300 && $header['status'] < 400)) {
                $status = '??';
            } else {
                $status = '<div style="background-color: Red; color: Yellow; padding: 2px;">' . _FAILED . '</div>';
            }
            $detail = modCheckPopupLink($row['url'], $img_view);
            $rows[] = '<tr ' . $colorswitch . '>
            <td width="1%">' . $status . '</td>
            <td width="1%">' . $header['status'] . '</td>
            <td width="1%">' . $detail . '</td>
            <td><a href="' . $row['url'] . '" target="_blank">' . $row['title'] . '</a></td>
            <td>
                <a href="' . adminUrl(PMX_MODULE, 'ModData', 'lid=' . $row['lid']) . '">' . $img_edit . '</a> &nbsp;&nbsp;
                <a href="' . adminUrl(PMX_MODULE, 'DelData', 'lid=' . $row['lid']) . '">' . $img_dele . '</a>
            </td>
            </tr>';
        } // end while
        echo '<a name="result" id="result"></a>';
        OpenTable();
        if (isset($rows)) {
            echo '<table class="full list">' . implode("\n", $rows) . '</table>';
        } else {
            echo '<h3>' . _NOTHINGINVIEW . '</h3>';
        }
        CloseTable();
        echo '<br />';
    }
    include ("footer.php");
}

/**
 * Beschreibung
 */
function modAddNewData()
{
    global $prefix;

    $_POST = modCheckData($_POST);

    if (count($_POST['msg'])) {
        include("header.php");
        GraphicAdmin();
        modAdminMenu();
        OpenTable();
        echo "<center><b>" . implode('<br />', $_POST['msg']) . "</b><br /><br />" . _GOBACK . "</center>";
        CloseTable();
        include("footer.php");
        exit;
    }

    $qry = "INSERT INTO " . $prefix . "_downloads_downloads SET
        cid=" . intval($_POST['cid']) . ",
        sid=0,
        title='" . mxAddSlashesForSQL($_POST['title']) . "',
        url='" . mxAddSlashesForSQL(mx_urltohtml($_POST['url'])) . "',
        description='" . mxAddSlashesForSQL($_POST['description']) . "',
        name='" . mxAddSlashesForSQL($_POST['auth_name']) . "',
        email='" . mxAddSlashesForSQL($_POST['email']) . "',
        submitter='" . mxAddSlashesForSQL($_POST['submitter']) . "',
        filesize=" . intval($_POST['filesize']) . ",
        version='" . mxAddSlashesForSQL($_POST['version']) . "',
        homepage='" . mxAddSlashesForSQL($_POST['homepage']) . "',
        hits=" . intval($_POST['hits']) . ",
        date='" . mxAddSlashesForSQL($_POST['updated']) . "'
        ";
    $result = sql_query($qry);
    if ($result) {
        $newlid = sql_insert_id();
        if (!empty($_POST['new'])) {
            sql_query("delete from " . $prefix . "_downloads_newdownload where lid=" . intval($_POST['lid']));
        }
        // Automatisch einen News-Artikel erstellen
        if (!empty($_POST['addstory'])) {
            $admindata = mxGetAdminData();
            switch (true) {
                case !empty($_POST['submitter']):
                    $submitterdata = mxGetUserDataFromUsername($_POST['submitter']);
                    if (empty($submitterdata['uname'])) {
                        $uid = 0;
                        $uname = strip_tags($_POST['submitter']);
                        $stuserlink = $uname;
                    } else {
                        $uid = $submitterdata['uid'];
                        $uname = $submitterdata['uname'];
                        $stuserlink = mxCreateUserprofileLink($uname);
                    }
                    break;

                case MX_IS_USER:
                    $userinfo = mxGetUserData();
                    $uid = $userinfo['uid'];
                    $uname = $userinfo['uname'];
                    $stuserlink = $GLOBALS['anonymous'];
                    break;

                default:
                    $uid = 0;
                    $uname = $admindata['aid'];
                    $stuserlink = $GLOBALS['anonymous'];
            }

            $stmsg = '<br />' . $stuserlink . ' ' . _DANNO1;
            $stmsg .= '<br />' . _DANNO2 . ' <b>' . $_POST['title'] . '</b>' . (_DANNO3 == '') ? '' : ' ' . _DANNO3;
            $stmsg .= '<br /><br />' . _DANNO4;
            $stmsg .= '<br /><br /><b>' . _DLDESCRIPTION . '</b>:<br />';
            $stmsg .= $_POST['description'] . '<br /><br />';
            $stmsg .= '<a href="modules.php?name=' . PMX_MODULE . '&amp;op=view&amp;lid=' . $newlid . '">' . _DANNO5 . '</a>';
            $title = mxHtmlEntityDecode($_POST['title']);
            $stmsg = mxHtmlEntityDecode($stmsg);
            // diese Abfrage verwenden, um die Story direkt einzufuegen
            // $qry = "insert into ".$prefix."_stories (catid,aid,title,time,hometext,topic, counter, informant) values (2,'".mxAddSlashesForSQL($admindata['aid'])."','".mxAddSlashesForSQL($title)."',now(),'".mxAddSlashesForSQL($stmsg)."',2, 0,'".mxAddSlashesForSQL($uname)."')";
            $qry = "insert into " . $prefix . "_queue (uid,uname,subject,story,timestamp) values ('" . $uid . "','" . mxAddSlashesForSQL($uname) . "','" . mxAddSlashesForSQL($title) . "','" . mxAddSlashesForSQL($stmsg) . "',now())";
            sql_query($qry);
        }
        // end Hack um automatisch eine Story zu erstellen
        mxRedirect(adminUrl(PMX_MODULE), _NEWDOWNLOADADDED, 3);
    } else {
        mxErrorScreen('Database Error (modAddNewData)<br /><br />' . sql_error());
    }
}

/**
 * Configuration Functions to Setup all the Variables
 */
function modConfig()
{
    include ("modules/" . PMX_MODULE . "/d_config.php");
    include ("header.php");
    GraphicAdmin();
    modAdminMenu();

    OpenTable();
    echo '<fieldset><legend>' . _WDOWNLOADADMINHEAD . '</legend>
    <form action="' . adminUrl(PMX_MODULE, 'Config') . '" method="post">
    <table cellspacing="0" cellpadding="2">
    <tr>
        <td width="83%">' . _BLOCKSHOW_RIGHT . ':</td>
        <td style="white-space: nowrap;"><input type="radio" name="lindex" value="1"' . ((empty($lindex)) ? '' : ' checked="checked"') . ' />&nbsp;' . _YES . '&nbsp;<input type="radio" name="lindex" value="0"' . ((empty($lindex)) ? ' checked="checked"' : '') . ' />&nbsp;' . _NO . ' </td>
    </tr>
    <tr>
        <td>' . _SHOWQUICKJUMPER . ':</td>
        <td><input type="radio" name="showquickjump" value="1"' . ((empty($showquickjump)) ? '' : ' checked="checked"') . ' />&nbsp;' . _YES . '&nbsp;<input type="radio" name="showquickjump" value="0"' . ((empty($showquickjump)) ? ' checked="checked"' : '') . ' />&nbsp;' . _NO . ' </td>
    </tr>
    <tr>
        <td>' . _COUNTCATCOLS . ':</td>
        <td><input type="text" name="catcols" value="' . ((empty($catcols) || intval($catcols) < 1) ? 1 : intval($catcols)) . '"  size="2" maxlength="1" /> </td>
    </tr>
    <tr>
        <td>' . _SORTCATCOLS . ':</td>
        <td><select name="catsort"> <option value="0"' . ((empty($catsort)) ? ' selected="selected" class="current"': '') . '>' . _SORTCATCOLS_1 . '</option> <option value="1"' . ((!empty($catsort)) ? ' selected="selected" class="current"': '') . '>' . _SORTCATCOLS_2 . '</option> </select> </td>
    </tr>
    <tr>
        <td>' . _SHOWCOUNTERS . ':</td>
        <td><input type="radio" name="showcounters" value="1"' . ((empty($showcounters)) ? '' : ' checked="checked"') . ' />&nbsp;' . _YES . '&nbsp;<input type="radio" name="showcounters" value="0"' . ((empty($showcounters)) ? ' checked="checked"' : '') . ' />&nbsp;' . _NO . ' </td>
    </tr>
    <tr>
        <td>' . _SHOWEMPTYCATS . ':</td>
        <td><input type="radio" name="showemptycategories" value="1"' . ((empty($showemptycategories)) ? '' : ' checked="checked"') . ' />&nbsp;' . _YES . '&nbsp;<input type="radio" name="showemptycategories" value="0"' . ((empty($showemptycategories)) ? ' checked="checked"' : '') . ' />&nbsp;' . _NO . ' </td>
    </tr>
    <tr><td colspan="2"><hr noshade="noshade" size="1" /></td>
    </tr>
    <tr>
        <td>' . _PERPAGE . ':</td>
        <td><input type="text" name="perpage" value="' . $perpage . '" size="3" maxlength="2" /> </td>
    </tr>
    <tr>
        <td>' . _NEWDOWNLOAD . ':</td>
        <td><input type="text" name="newdownloads" value="' . $newdownloads . '" size="3" maxlength="2" /> </td>
    </tr>
    <tr>
        <td>' . _DOWNLOADRESULTS . ':</td>
        <td><input type="text" name="downloadsresults" value="' . $downloadsresults . '" size="3" maxlength="2" /> </td>
    </tr>
    <tr>
        <td>' . _SHOWDETAILS . ':</td>
        <td><input type="radio" name="showdetails" value="1"' . ((empty($showdetails)) ? '' : ' checked="checked"') . ' />&nbsp;' . _YES . '&nbsp;<input type="radio" name="showdetails" value="0"' . ((empty($showdetails)) ? ' checked="checked"' : '') . ' />&nbsp;' . _NO . ' </td>
    </tr>
    <tr><td colspan="2"><hr noshade="noshade" size="1" /></td>
    </tr>
    <tr>
        <td>' . _USERATING . '</td>
        <td> <input type="radio" name="usevoting" value="1" ' . ((!empty($usevoting)) ? ' checked="checked"': '') . ' />' . _YES . '&nbsp; <input type="radio" name="usevoting" value="0"' . ((empty($usevoting)) ? ' checked="checked"': '') . ' />' . _NO . '</td>
    </tr>
    <tr>
        <td>' . _USEOUTSIDEVOTING . '</td>
        <td> <input type="radio" name="useoutsidevoting" value="1" ' . ((!empty($useoutsidevoting)) ? ' checked="checked"': '') . ' />' . _YES . '&nbsp; <input type="radio" name="useoutsidevoting" value="0"' . ((empty($useoutsidevoting)) ? ' checked="checked"': '') . ' />' . _NO . '</td>
    </tr>
    <tr>
        <td>' . _ANONWAITDAYS . ':</td>
        <td><input type="text" name="anonwaitdays" value="' . $anonwaitdays . '" size="4" maxlength="4" /> </td>
    </tr>
    <tr>
        <td>' . _OUTSIDEWAITDAYS . ':</td>
        <td><input type="text" name="outsidewaitdays" value="' . $outsidewaitdays . '" size="4" maxlength="4" /> </td>
    </tr>
    <tr>
        <td>' . _ANONWEIGHT . ':</td>
        <td><input type="text" name="anonweight" value="' . $anonweight . '" size="4" maxlength="4" /> </td>
    </tr>
    <tr>
        <td>' . _OUTSIDEWEIGHT . ':</td>
        <td><input type="text" name="outsideweight" value="' . $outsideweight . '" size="4" maxlength="4" /> </td>
    </tr>
    <tr>
        <td>' . _DETAILVOTEDECIMAL . ':</td>
        <td><input type="text" name="detailvotedecimal" value="' . $detailvotedecimal . '" size="4" maxlength="4" /> </td>
    </tr>
    <tr>
        <td>' . _MAINVOTEDECIMAL . ':</td>
        <td><input type="text" name="mainvotedecimal" value="' . $mainvotedecimal . '" size="4" maxlength="4" /> </td>
    </tr>
    <tr>
        <td>' . _DOWNLOADVOTEMIN . ':</td>
        <td><input type="text" name="downloadvotemin" value="' . $downloadvotemin . '" size="10" maxlength="10" /> </td>
    </tr>
    <tr>
        <td>' . _TOPRATEDPERCENTTRIGGER . '</td>
        <td> <input type="radio" name="topdownloadspercentrigger" value="1" ' . ((!empty($topdownloadspercentrigger)) ? ' checked="checked"': '') . ' />' . _YES . '&nbsp; <input type="radio" name="topdownloadspercentrigger" value="0"' . ((empty($topdownloadspercentrigger)) ? ' checked="checked"': '') . ' />' . _NO . '</td>
    </tr>
    <tr>
        <td>' . _TOPRATEDCOUNT . ':</td>
        <td><input type="text" name="topdownloads" value="' . $topdownloads . '" size="4" maxlength="4" /> </td>
    </tr>
    <tr>
        <td>' . _USECOMMENTS . '</td>
        <td> <input type="radio" name="usecomments" value="1" ' . ((!empty($usecomments)) ? ' checked="checked"': '') . ' />' . _YES . '&nbsp; <input type="radio" name="usecomments" value="0"' . ((empty($usecomments)) ? ' checked="checked"': '') . ' />' . _NO . '</td>
    </tr>
    <tr><td colspan="2"><hr noshade="noshade" size="1" /></td>
    </tr>
    <tr>
        <td>' . _POPULAR . ':</td>
        <td><input type="text" name="popular" value="' . $popular . '" size="10" maxlength="10" /> </td>
    </tr>
    <tr>
        <td>' . _MOSTPOPDOWNLOADPERCENTTRIGGER . '</td>
        <td> <input type="radio" name="mostpopdownloadspercentrigger" value="1" ' . ((!empty($mostpopdownloadspercentrigger)) ? ' checked="checked"': '') . ' />' . _YES . '&nbsp; <input type="radio" name="mostpopdownloadspercentrigger" value="0"' . ((empty($mostpopdownloadspercentrigger)) ? ' checked="checked"': '') . ' />' . _NO . '</td>
    </tr>
    <tr>
        <td>' . _MOSTPOPDOWNLOAD . ':</td>
        <td><input type="text" name="mostpopdownloads" value="' . $mostpopdownloads . '" size="4" maxlength="4" /> </td>
    </tr>
    <tr><td colspan="2"><hr noshade="noshade" size="1" /></td>
    </tr>
    <tr>
        <td>' . _HIDEDIRCTPATH . '</td>
        <td> <input type="radio" name="hidepath" value="1" ' . ((!empty($hidepath)) ? ' checked="checked"': '') . ' />' . _YES . '&nbsp; <input type="radio" name="hidepath" value="0"' . ((empty($hidepath)) ? ' checked="checked"': '') . ' />' . _NO . '</td>
    </tr>
    <tr>
        <td>' . _ADDDOWNLOAD . '</td>
        <td> <input type="radio" name="user_adddownload" value="1" ' . ((!empty($user_adddownload)) ? ' checked="checked"': '') . ' />' . _YES . '&nbsp; <input type="radio" name="user_adddownload" value="0"' . ((empty($user_adddownload)) ? ' checked="checked"': '') . ' />' . _NO . '</td>
    </tr>
    <tr>
        <td>' . _ANONADDDOWNLOADLOCK . '</td>
        <td> <input type="radio" name="downloads_anonadddownloadlock" value="1" ' . ((!empty($downloads_anonadddownloadlock)) ? ' checked="checked"': '') . ' />' . _YES . '&nbsp; <input type="radio" name="downloads_anonadddownloadlock" value="0"' . ((empty($downloads_anonadddownloadlock)) ? ' checked="checked"': '') . ' />' . _NO . '</td>
    </tr>
    <tr>
        <td>' . _BLOCKUNREGMODIFY . '</td>
        <td> <input type="radio" name="blockunregmodify" value="1" ' . ((!empty($blockunregmodify)) ? ' checked="checked"': '') . ' />' . _YES . '&nbsp; <input type="radio" name="blockunregmodify" value="0"' . ((empty($blockunregmodify)) ? ' checked="checked"': '') . ' />' . _NO . '</td>
    </tr>
    <tr>
        <td>' . _NOTIFYSUBMISSION . '</td>
        <td> <input type="radio" name="downnotify" value="1" ' . ((!empty($downnotify)) ? ' checked="checked"': '') . ' />' . _YES . '&nbsp; <input type="radio" name="downnotify" value="0"' . ((empty($downnotify)) ? ' checked="checked"': '') . ' />' . _NO . '</td>
    </tr>
    </table><br /><br />
    <input type="hidden" name="op" value="' . PMX_MODULE . '/ConfigSave" size=20 />
    <center><input type="submit" value="' . _SAVECHANGES . '" size=20 /></center>
    </form>
    </fieldset>';
    CloseTable();
    include ("footer.php");
    /*
    <tr>
        <td>' . _ADDNEWS . '</td>
        <td> <input type="radio" name="downnews" value="1" '.((!empty($downnews)) ? ' checked="checked"': '').' />' . _YES . '&nbsp; <input type="radio" name="downnews" value="0"'.((empty($downnews)) ? ' checked="checked"': '').' />' . _NO .'</td>
    </tr>
     */
}

/**
 * Beschreibung
 */
function modConfigSave()
{
    foreach ($_POST as $key => $value) {
        $_POST[$key] = intval($value);
    }
    extract($_POST);
    $anonweight = ($anonweight < 1) ? 1 : $anonweight;
    $catcols = ($catcols < 1) ? 1 : $catcols;

    $content = "<?php\n";
    $content .= "/************************************\n";
    $content .= " pragmaMx - Web Content Management System\n";
    $content .= " Copyright by pragmaMx Developer Team - http://www.pragmamx.org\n";
    $content .= " write with: \$Id: admin.php 499 2022-05-11 12:15:10Z PragmaMx $\n";
    $content .= "************************************/\n\n";
    $content .= "\$lindex = '$lindex';\n";
    $content .= "\$perpage = '$perpage';\n";
    $content .= "\$popular = '$popular';\n";
    $content .= "\$newdownloads = '$newdownloads';\n";
    $content .= "\$topdownloads = '$topdownloads';\n";
    $content .= "\$downloadsresults = '$downloadsresults';\n";
    $content .= "\$downloads_anonadddownloadlock = '$downloads_anonadddownloadlock';\n";
    $content .= "\$anonwaitdays = '$anonwaitdays';\n";
    $content .= "\$outsidewaitdays = '$outsidewaitdays';\n";
    $content .= "\$useoutsidevoting = '$useoutsidevoting';\n";
    $content .= "\$anonweight = '$anonweight';\n";
    $content .= "\$outsideweight = '$outsideweight';\n";
    $content .= "\$detailvotedecimal = '$detailvotedecimal';\n";
    $content .= "\$mainvotedecimal = '$mainvotedecimal';\n";
    $content .= "\$topdownloadspercentrigger = '$topdownloadspercentrigger';\n";
    $content .= "\$topdownloads = '$topdownloads';\n";
    $content .= "\$mostpopdownloadspercentrigger = '$mostpopdownloadspercentrigger';\n";
    $content .= "\$mostpopdownloads = '$mostpopdownloads';\n";
    $content .= "\$downloadvotemin = '$downloadvotemin';\n";
    $content .= "\$blockunregmodify = '$blockunregmodify';\n";
    $content .= "\$user_adddownload = '$user_adddownload';\n";
    $content .= "\$downnotify = '$downnotify';\n";
    $content .= "\$showcounters = '$showcounters';\n";
    $content .= "\$showdetails = '$showdetails';\n";
    $content .= "\$showquickjump = '$showquickjump';\n";
    $content .= "\$showemptycategories = '$showemptycategories';\n";
    $content .= "\$catcols = '$catcols';\n";
    $content .= "\$catsort = '$catsort';\n";
    $content .= "\$usecomments = '$usecomments';\n";
    $content .= "\$usevoting = '$usevoting';\n";
    $content .= "\$hidepath = '$hidepath';\n";
    $content .= "\n";
    $content .= "?>";
    $conffile = "modules/" . PMX_MODULE . "/d_config.php";

    if (mx_write_file($conffile, $content, true)) {
        $msg = _CHANGESAREOK;
        $delay = 0;
    } else {
        $msg = _CHANGESNOTOK;
        $delay = 5;
    }

    mxRedirect(adminUrl(PMX_MODULE, 'Config'), $msg, $delay);
}

/**
 * Beschreibung
 */
function modVisulizeDiff($original, $modified)
{
    return ($original == $modified) ? '&nbsp;=&nbsp' : '<b><&nbsp;></b>';
}

switch ($op) {
    case PMX_MODULE . '/Catogories':
        mxIncludeHeader();
        GraphicAdmin();
        modAdminMenu();
        OpenTable();
        modCatogories();
        CloseTable();
        mxIncludeFooter();
        break;
    case PMX_MODULE . '/Catogories/Capt':
        _setCaptcha();
        break;
    case PMX_MODULE . '/List':
        modList();
        break;

    case PMX_MODULE . '/DelNew':
        modDelNew();
        break;

    case PMX_MODULE . '/AddCat':
        modAddCat($title, $cdescription);
        break;

    case PMX_MODULE . '/AddData':
        modAddNewData();
        break;

    case PMX_MODULE . '/AddEditorial':
        modAddEditorial($downloadid, $editorialtitle, $editorialtext);
        break;

    case PMX_MODULE . '/ModEditorial':
        modModifyEditorial($downloadid, $editorialtitle, $editorialtext);
        break;

    case PMX_MODULE . '/Check':
        modCheckResponse();
        break;

    case PMX_MODULE . '/DelEditorial':
        modDelEditorial($downloadid);
        break;

    case PMX_MODULE . '/CleanVotes':
        modCleanVotes();
        break;

    case PMX_MODULE . '/ListBroken':
        modListBroken();
        break;

    case PMX_MODULE . '/DelBroken':
        modDelBroken($lid);
        break;

    case PMX_MODULE . '/IgnoreBroken':
        modIgnoreBroken($lid);
        break;

    case PMX_MODULE . '/ListModRequests':
        modListModRequests();
        break;

    case PMX_MODULE . '/ChangeModRequests':
        modChangeModRequests($requestid);
        break;

    case PMX_MODULE . '/ChangeIgnoreRequests':
        modChangeIgnoreRequests($requestid);
        break;

    case PMX_MODULE . '/DelCat':
        modDelCat();
        break;

    case PMX_MODULE . '/ModCat':
        modModifyCat();
        break;

    case PMX_MODULE . '/ModCatSave':
        modModifyCatSave();
        break;

    case PMX_MODULE . '/ModData':
        modModifyData($lid);
        break;

    case PMX_MODULE . '/ModDataSave':
        modModifyDataSave();
        break;

    case PMX_MODULE . '/DelData':
        modDelData($lid);
        break;

    case PMX_MODULE . '/DelVote':
        modDelVote($lid, $rid);
        break;

    case PMX_MODULE . '/DelComment':
        modDelComment($lid, $rid);
        break;

    case PMX_MODULE . '/Transfer':
        modTransferToCat($cidfrom, $cidto);
        break;

    case PMX_MODULE . '/Config':
        modConfig();
        break;

    case PMX_MODULE . '/ConfigSave':
        modConfigSave();
        break;

    default:
        modAdminMain();
        break;
}

?>