<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 *
 *
 * Based on Journey Links Hack
 * Copyright (c) 2000 by James Knickelbein
 * Journey Milwaukee (http://www.journeymilwaukee.com)
 */

defined('mxMainFileLoaded') or die('access denied');

function search()
{
    global $prefix, $module_name, $pagetitle;

    $min = (empty($_GET['min']) || $_GET['min'] < 0) ? 0 : intval($_GET['min']);
    $orderby = (empty($_GET['orderby'])) ? DLDEFAULTORDER : modGetOrderBy($_GET['orderby']);
    $query = (empty($_GET['query'])) ? '' : trim(strip_tags(stripslashes($_GET['query'])));
    // Datensaetze pro Seite, gesteuert ueber config
    $show = (empty($GLOBALS['downloadsresults']) || intval($GLOBALS['downloadsresults']) <= 0) ? 10 : $GLOBALS['downloadsresults'];
    $x = 0;
    if (!empty($query)) {
        $words = preg_split('#\W+#u', $query, PREG_SPLIT_NO_EMPTY);
        foreach($words as $word) {
            $part[] = "(dd.description LIKE '%" . mxAddSlashesForSQL($word) . "%' OR dd.description LIKE '%" . htmlspecialchars($word, ENT_QUOTES) . "%' OR dd.title LIKE '%" . mxAddSlashesForSQL($word) . "%' OR dd.title LIKE '%" . htmlspecialchars($word, ENT_QUOTES) . "%')";
        }
        $part[] = "dd.cid > 0";
        $searchstring = ' (' . implode(' AND ', $part) . ') ';
        $result = sql_query("SELECT count(lid) FROM " . $prefix . "_downloads_downloads AS dd WHERE " . $searchstring);
        list($totalselectedrows) = sql_fetch_row($result);
        $link = "modules.php?name=" . $module_name . "&amp;op=search&amp;query=" . str_replace('%', '%%', urlencode($query)) . "&amp;min=%d";
        $pageview = modShowPageView($totalselectedrows, $min, $show, $link . (($orderby == DLDEFAULTORDER) ? '' : '&amp;orderby=' . $orderby));
        $qry = "SELECT dd.*, dd.name as auth_name, dd.date as updated, dc.title AS ctitle, dc.parentid AS cparentid, de.downloadid AS editorialid
            FROM " . $prefix . "_downloads_downloads AS dd
            LEFT JOIN " . $prefix . "_downloads_categories AS dc ON dd.cid = dc.cid
            LEFT JOIN " . $prefix . "_downloads_editorials AS de ON dd.lid = de.downloadid
            WHERE " . $searchstring . "
            ORDER BY " . modConvertOrderForSql($orderby) . "
            LIMIT " . $min . "," . $show;
        $result = sql_query($qry);
        $nrows = sql_num_rows($result);
    }
    // Daten fuer header aufbereiten
    $title = _SEARCHRESULTS4 . ": <i>" . htmlspecialchars($query, ENT_QUOTES) . "</i>";
    $pagetitle = strip_tags($title);

    include(PMX_MODULES_DIR . DS . $module_name . '/includes/header.php');
    if (empty($query)) {
        OpenTable();
        echo '<div align="center" class="content">' . _NOMATCHES . '<br /><br />' . _GOBACK . '<br /><br /><br /><br /><br /><br /><br /><br /></div>';
        CloseTable();
        include(PMX_MODULES_DIR . DS . $module_name . '/includes/footer.php');
        return;
    }
    // title(_SEARCHRESULTS4 . ": <i>" . htmlspecialchars($query, ENT_QUOTES) . "</i>");
    $qry = "SELECT dc.cid, dc.title, dc.parentid, Count(dd.lid) AS anz
        FROM " . $prefix . "_downloads_categories AS dc INNER JOIN " . $prefix . "_downloads_downloads AS dd ON dc.cid = dd.cid
        WHERE (dc.title LIKE '%" . $query . "%') AND dc.cid > 0
        GROUP BY dc.cid, dc.parentid, dc.title
        ORDER BY dc.title;";
    $result2 = sql_query($qry);
    $sincat = sql_num_rows($result2);
    if ($sincat) {
        OpenTable();
        echo "<font class=\"option\"><b>" . _USUBCATEGORIES . "</b></font><br />";
        while (list($cid, $title, $parentid, $numrows) = sql_fetch_row($result2)) {
            if ($parentid > 0) {
                $title = modGetParentTitles($parentid, $title);
            }
            echo "<strong><big>·</big></strong>&nbsp;<a href=\"modules.php?name=" . $module_name . "&amp;cid=" . $cid . "\">" . $title . "</a> ($numrows)<br />";
        }
        CloseTable();
        echo '<br />';
    }

    if (empty($nrows)) {
        OpenTable();
        echo '<div align="center" class="content">' . _NOMATCHES . '<br /><br />' . _GOBACK . '<br /><br /><br /><br /><br /><br /><br /><br /></div>';
        CloseTable();
        echo '<br />';
    } else {
        OpenTable();
        if ($nrows > 3) {
            modSortMenu($orderby, $link);
        } while ($row = sql_fetch_assoc($result)) {
            modViewData($row, 'list');
        }
        CloseTable();
        echo '<br />';
        if ($pageview) {
            OpenTable();
            echo "<div align=\"center\" class=\"option\">" . _SEARCHRESULTS4 . ": <b><i>" . htmlspecialchars($query, ENT_QUOTES) . "</i></b></div><br />";
            echo $pageview;
            CloseTable();
            echo '<br />';
        }
    }

    /**
     * OpenTable();
     * echo "<center><font class=\"content\">"
     * . _TRY2SEARCH . " &quot;" . $query . "&quot; " . _INOTHERSENGINES . '<br />'
     * . "<a target=\"_blank\" href=\"http://www.altavista.com/cgi-bin/query?pg=q&amp;sc=on&amp;hl=on&amp;act=2006&amp;par=0&amp;q=$query&amp;kl=XX&amp;stype=stext\">Alta Vista</a> - "
     * . "<a target=\"_blank\" href=\"http://search.lycos.com/default.asp?lpv=1&amp;loc=searchhp&amp;tab=web&amp;query=$query&amp;amp;maxhits=20\">Lycos</a> - "
     * . "<a target=\"_blank\" href=\"http://search.yahoo.com/bin/search?p=$query\">Yahoo</a>"
     * . '<br />'
     * . "<a target=\"_blank\" href=\"http://www.google.com/search?q=$query\">Google</a> - "
     * . "<a target=\"_blank\" href=\"http://freshmeat.net/search/?q=$query&section=projects\">Freshmeat</a>"
     * . "</font>";
     * CloseTable();
     */

    include(PMX_MODULES_DIR . DS . $module_name . '/includes/footer.php');
}

?>