<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 *
 *
 * Based on Journey Links Hack
 * Copyright (c) 2000 by James Knickelbein
 * Journey Milwaukee (http://www.journeymilwaukee.com)
 */

defined('mxMainFileLoaded') or die('access denied');

if (!$usevoting) {
    mxRedirect('modules.php?name=' . $module_name, _NOTVOTINGWARN, 5);
}

function TopRated()
{
    global $prefix, $module_name, $pagetitle;
    global $topdownloadspercentrigger, $topdownloads, $downloadvotemin;
    // Anzeige in Prozent oder Anzahl, gesteuert ueber config
    if ($topdownloadspercentrigger) {
        $result = sql_query("select count(lid) from " . $prefix . "_downloads_downloads where downloadratingsummary <> 0 AND totalvotes >= " . intval($downloadvotemin) . " AND cid > 0");
        list($totalratedrows) = sql_fetch_row($result);
        $toprowspercent = intval($topdownloads);
        $topdownloads = ceil($totalratedrows * $toprowspercent / 100);
    }
    // qry
    $qry = "SELECT dd.*, dd.name as auth_name, dd.date as updated, dc.title AS ctitle, dc.parentid AS cparentid, de.downloadid AS editorialid
        FROM " . $prefix . "_downloads_downloads AS dd
         LEFT JOIN " . $prefix . "_downloads_categories AS dc ON dd.cid = dc.cid
         LEFT JOIN " . $prefix . "_downloads_editorials AS de ON dd.lid = de.downloadid
        WHERE dd.downloadratingsummary <> 0 and dd.totalvotes >= " . intval($downloadvotemin) . "
         AND dd.cid > 0
        ORDER BY dd.downloadratingsummary DESC
        LIMIT 0," . intval($topdownloads);
    $result = sql_query($qry);
    $totalrows = sql_num_rows($result);
    // Daten fuer header aufbereiten
    if ($topdownloadspercentrigger == 1) {
        $title = $toprowspercent . '%&nbsp;' . _DBESTRATED . ' (' . _OF . ' ' . $totalratedrows . ' ' . _TRATEDDOWNLOADS . ')';
    } else {
        $title = $totalrows . '&nbsp;' . _DBESTRATED;
    }
    $pagetitle = strip_tags($title);
    $pagesubmenu = '<span class="tiny">' . _NOTE . ' ' . $downloadvotemin . ' ' . _TVOTESREQ . '</span>';
    // die Ausgabe
    include(PMX_MODULES_DIR . DS . $module_name . '/includes/header.php');
    if ($totalrows) {
        OpenTable();
        while ($row = sql_fetch_assoc($result)) {
            modViewData($row, 'list');
        }
        CloseTable();
        echo '<br />';
    } else {
        OpenTable();
        echo '<div align="center" class="content">' . _NOTHINGINVIEW . '<br /><br />' . _GOBACK . '<br /><br /><br /><br /><br /><br /><br /><br /></div>';
        CloseTable();
        echo '<br />';
    }
    include(PMX_MODULES_DIR . DS . $module_name . '/includes/footer.php');
}

?>