<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 */

/*
#FAQ

RewriteRule ^FAQ-.*-category-([0-9]+)(-.*)?\.html$ mod.php?name=FAQ&cat=$1&_MORE_=$2 [L]

*/

$hook = function($name, $parameter, &$replaces)
{
    if (!isset($parameter[$name])) {
        return;
    }
    global $prefix;

    $cat = array();
    $pid = array();
    $pic = array();

    foreach ($parameter[$name] as $key => $para) {
        switch (true) {
            case (isset($para['cat'])):
                $cat[0][] = $para['cat'];
                $cat[$key] = $para;
                break;
            case (isset($para['cid']) && intval($para['cid']) && !(isset($para['pa']))):
                $cid[0][] = $para['cid'];
                $cid[$key] = $para;
                break;
            case (isset($para['pid']) && intval($para['pid']) && !(isset($para['pa']))):
                $pid[0][] = $para['pid'];
                $pid[$key] = $para;
                break;
        }
    }

    /**
     */
    if ($cat) {
        $inquery = implode(',', array_unique(array_shift($cat)));
        $qry = "SELECT id_cat, categories FROM {$prefix}_faqcategories WHERE id_cat in ($inquery)";
        $result = sql_system_query($qry);
        $titles = array();
        while (list($catid, $title) = sql_fetch_row($result)) {
            /**
             * den aus der DB ausgelesenen Titel als URL tauglich machen
             * - Umlaute werden umgeschrieben
             * - Sonderzeichen werden durch den angegebenen 2ten Parameter ersetzt
             * Einstellung:
             * der zweite Parameter der Funktion, als Sonderzeichenersatz
             */
            $titles[$catid] = pmxModrewrite::title_entities($title, '-');
        }

        foreach ($cat as $key => $link) {
            if (isset($titles[$link['cat']])) {
                /**
                 * schreibt alle Parameter um in das normale pragmaMx mod_rewrite Format,
                 * also getrennt mit den Bindestrichen
                 * Einstellung:
                 * alle Parameter, die nicht benötigt werden, weil sie z.B. anderweitig
                 * in der URL verwendet werden, als zusätzlichen Parameter der Funktion
                 * übergeben
                 */
                $new_url = pmxModrewrite::title_parameters($link, 'cat');
                /**
                 * den neuen URL zusammensetzen
                 * Einstellung:
                 * nach belieben zusammensetzen und entspr. die .htaccess anpassen
                 */
                // $title = $name . '-lid-' . $title . '-' . $lid . $end; // Original m-t
                $new_url = $name . '-' . $titles[$link['cat']] . '-category-' . $link['cat'] . $new_url;
                /**
                 * die globalen Ersetzungsparameter mit den neuen Werten überschreiben
                 * Einstellung: keine, muss exakt so bleiben!
                 */
                $replaces[$key] = $link['prefix'] . $new_url . $link['suffix'];
            }
        }
    }
}

?>