<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 572 $
 * $Author: PragmaMx $
 * $Date: 2022-08-26 20:02:36 +0200 (Fr, 26. Aug 2022) $
 */


defined('mxMainFileLoaded') or die('access denied');

$mxblockcache = false;

/* der passende Modulname */
$module_name = basename(dirname(dirname(__FILE__)));

switch (true) {
    case MX_MODULE != $module_name:
    case empty($GLOBALS['story_blocks']):
    case !mxModuleAllowed($module_name):
        return;
}

/* --------- Konfiguration fuer den Block ----------------------------------- */

/* Definition der anzuzeigenden Links */
$medias = array(
    array('title' => 'Mail',
    'link' => ' mailto:?&subject=&body=[1]',
    'class' => 'mail'
    ),  	 
    array('title' => 'Twitter',
        'link' => 'https://twitter.com/intent/tweet?source=webclient&amp;text=[2]&amp;url=[1]',
        'class' => 'twitter'
        ),
    array('title' => 'Facebook',
		'link'=>'https://www.facebook.com/share.php?u=[1]&amp;t=[2]',
        'class' => 'facebook'
        ),
    array('title' => 'Instagram',
    'link' => 'https://instagram.com/share.php?u=[1]&amp;t=[2]',
    'class' => 'instagram'
    ),
   array('title' => 'Pinterest',
       'link' => 'https://pinterest.com/pin/create/button/?url=[1]&amp;title=[2]',
       'class' => 'pinterest'
       ),
    array('title' => 'LinkedIN',
        'link' => 'https://www.linkedin.com/shareArticle?mini=true&url=[1]',
        'class' => 'linkedin'
        ),
    array('title' => 'Tumblr',
     'link' => 'http://www.tumblr.com/share?v=3&u=[1]&t=[2]',
     'class' => 'tumblr'
     ), 
     array('title' => 'Vimeo',
       'link' => 'http://www.vimeo.com/share?v=3&u=[1]&t=[2]',
       'class' => 'vimeo'
      ),     
    array('title' => 'XING',
      'link' => 'https://www.xing.com/spi/shares/new?url=[1]',
      'class' => 'xing'
      ),  	

    array('title' => 'Skype',
    'link' => 'https://web.skype.com/share?url=[1]]',
    'class' => 'skype'
    ),  	 
    array('title' => 'Evernote',
    'link' => 'https://www.evernote.com/clip.action?url=[1]',
    'class' => 'evernote'
    ),  	 
	);

  /*
  https://web.skype.com/share?url=[1]]

  https://myspace.com/post?u=[1]&t=[2]&c=desc

  https://www.evernote.com/clip.action?url=[1]

  https://telegram.me/share/url?url=[1]&text=[2]]

  viber://forward?text=[1]

    https://service.weibo.com/share/share.php?url=[1]&title=[2]]

    https://reddit.com/submit?url=[1]&title=[2]]


    mailto:?&subject=&body=[1]

    https://api.whatsapp.com/send?text=[1]


  */

$imgpath = PMX_IMAGE_PATH."social/";
// Bloc title, comment and/or change if you have change $limit and need custom title
$blockfiletitle = _NEWS_SOCIALSHARING;

/* --------- Ende der Konfiguration ----------------------------------------- */

extract($block['settings'], EXTR_OVERWRITE);

$replaces = array(/* Platzhalter definieren */
    '[1]' => urlencode(PMX_HOME_URL . '/modules.php?name=' . $module_name . '&file=article&sid=' . $GLOBALS['story_blocks']['sid']),
    '[2]' => $GLOBALS['story_blocks']['title'],
    '[3]' => $GLOBALS['sitename'],
    );

ob_start();

?>
<style type="text/css">
  .socialb{ margin-bottom: 19px; }
  .socialb a{  border-bottom: none !important; display: block; float: left; height: 32px; margin: 0 ; width: 32px; }
  .socialb a:hover{ position: relative; top: -1px; }
  .socialb li{ display: list-item; }
  .socialb p{ font-weight: bold; margin-bottom: 1em; }
  .socialb span{ display: none; }
  .socialb ul{ line-height: 40px; list-style: none; margin: 0; padding: 0;}
  .socialb ul li {padding: 0 !important;margin: 2px 5px !important; position:relative;display:block;float: left;}
</style>

<?php
pmxHeader::add_style_code(ob_get_clean());

ob_start();

?>

<div class="socialb">
  <p><?php echo _NEWS_SOCIALSHARING2 ?></p>
  <ul>
    <?php foreach ($medias as $key => $l) {
     $link = str_replace(array_keys($replaces), array_values($replaces), $l['link']); ?>
     <li><a class="social-<?php echo $l['class'] ?>" title="<?php echo sprintf(_NEWS_SOCIALSHARING3, $l['title']) ?>" style='background: url("<?php echo $imgpath.$l['class']; ?>.png") no-repeat top left;' onclick="window.open('<?php echo $link ?>', 'sharer_<?php echo $key ?>', 'toolbar=0,status=0,width=626,height=436'); return false" rel="nofollow" target="_blank" href="<?php echo $link ?>"><span><?php echo $l['title'] ?></span></a></li>
    <?php } //endforeach ?>
  </ul>
  <div class="clear"></div>
</div>

<?php
$content = ob_get_clean();

?>