<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 *
 * this file based on:
 * PHP-NUKE-Addon Newsletter 1.40
 * Copyright(c) by Andreas Guenther, 26.08.2001
 * webmaster@bariba.de / http://www.bariba.de
 * php-nuke Web Portal System - http://phpnuke.org/
 * Thatware - http://thatware.org/
 *
 * Some modifications and additions by
 * jubilee (c) 2005 http://www.marx-city.de
 *
 * based upon
 * mycgi - Helper Library
 * ==========================
 * Andreas Guenther, 20.08.2001
 * Comments to webmaster@bariba.de / http://www.bariba.de
 * Version 0.02B
 */

defined('mxMainFileLoaded') or die('access denied');

function letter_garbage()
{
    global $prefix;

    $frist = 30; // die Ablauffrist in Tagen

    /* Neuzugänge:       Status 1 und regdate kleiner als xx Tage */
    /* doi-Angeforderte: Status 3 und checkkey kleiner als xx Tage aber doppelt */
    $past1 = time() - ($frist * 86400); // 86400 = 1 Tag in Sekunden
    $past2 = time() - ($frist * 86400 * 2); // 86400 = 1 Tag in Sekunden

    $query = "DELETE FROM {$prefix}_newsletter
      WHERE (status=1 AND regdate < {$past1})
         OR (status=3 AND checkkey < {$past2})
      ";
    sql_query($query);
}

function _get_letter_defaults()
{
    global $adminmail;
    $letter_defaults = array(/* Standardwerte */
        'letter_id' => 0,
        'subject' => _NL_DEFAULTSUBJECT,
        'text' => '',
        'html' => '',
        'sender' => $adminmail,
        'sid' => Array(),
        'sidtype' => 0,
        'separator_sid' => 0,
        'bid' => Array(),
        'separator_bid' => 0,
        );
    return $letter_defaults;
}

function _letter_br2nl($value)
{
    $returnvalue = str_replace('<br />', "\n", $value);
    $value = str_replace('<br />', "\n", $returnvalue);
    return $value;
}

function _letter_get_crc($salt)
{
    if (is_array($salt)) {
        $salt = serialize($salt);
    }
    return sprintf('%u', crc32($GLOBALS['mxSecureKey'] . $salt));
}

/**
 * Shows the captcha-image
 * -------------------------------------------------------------------------------
 * Zeigt das Captcha-Bild
 */
function cgiCaptcha()
{
    $captcha_object = load_class('Captcha', 'newsletteron');
    if ($captcha_object->get_active()) {
        echo "<div align=\"center\">\n";
        echo $captcha_object->complete();
        echo "\n</div>";
    }
}

/**
 * Prints a <SELECT> with given name or if name is empty a </SELECT>
 * -------------------------------------------------------------------------------
 */
function cgiSelect($name = '', $multiple = '', $array = 0)
{
    if ($name == '') {
        echo '</select>' . "\n";
    } else {
        if ($array == 1) {
            $brackets = '[]';
        } else {
            $brackets = '';
        }
        $multiple = ($multiple == 'multiple') ? 'multiple = "multiple"' : '';
        echo '<select name="' . $name . $brackets . '" ' . $multiple . '>' . "\n";
    }
}

/**
 * Prints a <option value ="$value">$name</option>
 * If $name is empty then $name = $value
 * -------------------------------------------------------------------------------
 */
function cgiOption($value, $name = "", $selected = "")
{
    if ($name == "") {
        $name = $value;
    }
    switch (true) {
        case is_array($selected) && in_array($value, $selected):
        case $value == $selected:
            echo "<option value=\"" . $value . "\" selected=\"selected\" class=\"current\">" . $name . "</option>\n";
            break;
        default:
            echo "<option value=\"" . $value . "\">" . $name . "</option>\n";
    }
}

/**
 * prints a <input type='text'... with the given values
 */
function cgiText($name, $value, $size, $max)
{
    echo "<input type=\"text\" name=\"" . $name . "\" value=\"" . $value . "\" size=\"" . $size . "\" maxlength=\"" . $max . "\" />\n";
}

/**
 * prints a '<textarea'... with the given values
 */
function cgiTextArea($name, $rows, $cols, $value = '')
{
    echo "<textarea name=\"" . $name . "\" rows=\"" . $rows . "\" cols=\"" . $cols . "\">" . $value . "</textarea>\n";
}

?>