<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 */

defined('mxMainFileLoaded') or die('access denied');
$modname = basename(dirname(dirname(__FILE__)));

unset($sqlqry);

if (!isset($tables["{$prefix}_priv_msgs"])) {
    $sqlqry[] = "
CREATE TABLE `{$prefix}_priv_msgs` (
  `msg_id` int(10) NOT NULL auto_increment,
  `msg_image` varchar(100) default NULL,
  `subject` varchar(100) default NULL,
  `from_userid` int(10) NOT NULL default '0',
  `to_userid` int(10) NOT NULL default '0',
  `msg_time` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `msg_text` text,
  `read_msg` tinyint(10) NOT NULL default '0',
  PRIMARY KEY  (`msg_id`),
  KEY `to_userid` (`to_userid`),
  KEY `read_msg` (`read_msg`),
  KEY `from_userid` (`from_userid`),
  KEY `msg_time` (`msg_time`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
} else {
    // Felder aktualisieren
    $tf = setupGetTableFields("{$prefix}_priv_msgs");
    switch (true) {
        case $tf['msg_time']['Null'] != 'NO':
        case $tf['msg_time']['Type'] != 'timestamp':
        case $tf['msg_time']['Default'] != 'CURRENT_TIMESTAMP':
            /* vorher gültige Daten erzeugen, sonst Fehler:
             * Incorrect datetime value: '0000-00-00 00:00:00' for column '***' at....*/
            $sqlqry[] = "UPDATE `${prefix}_priv_msgs` SET `msg_time` = NOW( ) WHERE `msg_time` LIKE '0000-00-00%'";
            $sqlqry[] = "ALTER TABLE `${prefix}_priv_msgs`
                CHANGE `msg_time` `msg_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP
                ";
    }
    // indexe
    $indexes = setupGetTableIndexes("{$prefix}_priv_msgs");
    if (!isset($indexes['PRIMARY'])) {
        $sqlqry[] = "ALTER TABLE `{$prefix}_priv_msgs` ADD PRIMARY KEY ( `msg_id` );";
    } else if ($indexes['PRIMARY']['Column_name'] != 'msg_id') {
        $sqlqry[] = "ALTER TABLE `{$prefix}_priv_msgs` DROP PRIMARY KEY, ADD PRIMARY KEY ( `msg_id` );";
    }
    if (isset($indexes['msg_id'])) $sqlqry[] = "ALTER TABLE `{$prefix}_priv_msgs` DROP INDEX `msg_id`;";
    if (!isset($indexes['to_userid'])) $sqlqry[] = "ALTER TABLE `{$prefix}_priv_msgs` ADD INDEX to_userid( `to_userid` );";
    if (!isset($indexes['read_msg'])) $sqlqry[] = "ALTER TABLE `{$prefix}_priv_msgs` ADD INDEX `read_msg` ( `read_msg` ) ";
    if (!isset($indexes['from_userid'])) $sqlqry[] = "ALTER TABLE `{$prefix}_priv_msgs` ADD INDEX `from_userid` ( `from_userid` ) ";
    if (!isset($indexes['msg_time'])) $sqlqry[] = "ALTER TABLE `{$prefix}_priv_msgs` ADD INDEX `msg_time` ( `msg_time` ) ";
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

?>