<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 *
 *
 * Part of phpBB integration
 * Copyright (c) 2001 by
 * Richard Tirtadji AKA King Richard (rtirtadji@hotmail.com)
 * Hutdik Hermawan AKA hotFix (hutdik76@hotmail.com)
 * http://www.phpnuke.web.id
 */

defined('mxMainFileLoaded') or die('access denied');

/**
 * userlist in a seperated window
 */
function userslist()
{
    global $userdata, $Default_Theme, $prefix, $user_prefix, $excludedusers, $url_images, $module_name, $showAdminAsUser, $showAdminPrefix;
    $content = "";
    $totalmembers = 1;
    $winheigth = 200;
    $qry = "SELECT uid, uname FROM {$user_prefix}_users WHERE user_stat=1 ORDER BY uname;";
    $result = sql_query($qry); # alle user aus Tabelle auslesen
    while (list($uid, $uname) = sql_fetch_row($result)) {
        $content .= "$totalmembers &nbsp;<a href=\"#\" onclick=\"setname('$uname')\" style=\"text-decoration : none;\">$uname</a><br />\n";
        $totalmembers++; # Anzahl aller User hochzaehlen/ermitteln
    }
    $totalmembers = $totalmembers - 1; # Wieder einen User abziehen (war bei init 1)
    if ($totalmembers < 30) {
        $winheigth = $totalmembers * 30;
    }

    $ThemeSel = mxGetTheme();

    echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n";
    echo "<html><head><title>" . _PMSUSERSLIST . "</title>";
    echo "<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\">\n";
    echo "<meta http-equiv=\"content-language\" content=\"" . _DOC_LANGUAGE . "\">\n";
    echo '<link rel="stylesheet" type="text/css" href="layout/style/style.css.php?t=' . $ThemeSel . '" />', "\n";
    echo '<link rel="stylesheet" type="text/css" href="themes/' . $ThemeSel . '/style/style.css" />', "\n";
    echo "<script type=\"text/javascript\">
/* <![CDATA[ */
	function resizewin(){
		window.resizeTo(240,$winheigth);
		window.moveTo((screen.width/2)-100,(screen.height/2)-($winheigth/2));
		window.focus();
	}
	function setname(thename) {
		opener.document.pmsubmit.to_user.value=thename;
	}
/* ]]> */
</script>";
    echo "</head><body class=\"allone popup\" onload='resizewin()'>";
    echo "<div class='content'>" . $content . "</div>";
    echo "</body></html>";
}

function get_userdata_from_id($userid)
{
    $userid = (int)$userid;
    $userdata = mxGetUserDataFromUid($userid);
    return (count($userdata)) ? $userdata : array("error" => "1");
}

function printsmilies()
{
    global $url_smiles, $smilie;
    $cols = 3;
    $count = 0;
    // asort($smilie);
    $break = (sizeof($smilie) / $cols);
    $rowspan = $cols + 1;
    $colspan = $break + 1;
    pmxHeader::add_script(PMX_JAVASCRIPT_PATH . 'unb_lib/unb_common.js');
    pmxHeader::add_script(PMX_JAVASCRIPT_PATH . 'unb_lib/unb_lib.js');
    echo "<table cellspacing=\"0\" cellpadding=\"2\" width=\"120\" class=\"smiliebar\">
	<tr><td rowspan=\"$colspan\" width=\"1\"></td><td colspan=\"$rowspan\"><font class=\"tiny\">" . _PMSCLICKSMILEBUTTONS . "</font></td></tr>
	<tr valign=\"top\"><td>";
    foreach ($smilie as $vals) {
        $count++;
        echo mxCreateImage($url_smiles . '/' . $vals[2], $vals[1] . ' ' . $vals[0], 0, ' onClick="UnbInsertText(\'' . $vals[0] . ' \')"');
        if (($count >= $break) && $count < sizeof($smilie)) {
            echo "</td><td>";
            $break = $break + $count;
            // $count=0;
        }
    }
    echo "</td></tr></table>";
}

function printbuddysmilies()
{
    global $url_smiles, $smilie;
    $cols = 1;
    $count = 0;
    // asort($smilie);
    $break = (sizeof($smilie) / $cols);
    $content = '';
    foreach ($smilie as $vals) {
        $count++;
        $content .= mxCreateImage($url_smiles . '/' . $vals[2], $vals[1] . ' ' . $vals[0], 0, ' onClick="UnbInsertText(\'' . $vals[0] . ' \')" style="cursor: pointer; margin: .2em .15em;"');
        if (($count >= $break) && $count < sizeof($smilie)) {
            $content .= '<br />';
            $break = $break + $count;
        }
    }
    return $content;
}

function putitems()
{
    global $prefix, $url_images;
    pmxHeader::add_script(PMX_JAVASCRIPT_PATH . 'unb_lib/unb_common.js');
    pmxHeader::add_script(PMX_JAVASCRIPT_PATH . 'unb_lib/unb_lib.js');
    echo '<table cellspacing="0" cellpadding="3" class="bbbar"><tr>';

    echo '<td>' . mxCreateImage($url_images . '/bb_url.gif', 'BBCode: ' . _BBURL, 0, 'onclick="UnbEditorDoCmd(event, \'url\'); return false;"') . '</td>';
    echo '<td>' . mxCreateImage($url_images . '/bb_email.gif', 'BBCode: ' . _BBEMAIL, 0, 'onclick="UnbEditorDoCmd(event, \'email\'); return false;"') . '</td>';
    echo '<td>' . mxCreateImage($url_images . '/bb_image.gif', 'BBCode: ' . _BBIMG, 0, 'onclick="UnbEditorDoCmd(event, \'img\'); return false;"') . '</td>';
    echo '<td>' . mxCreateImage($url_images . '/bb_bold.gif', 'BBCode: ' . _BBBOLD, 0, 'onclick="UnbEditorDoCmd(event, \'bold\'); return false;"') . '</td>';
    echo '<td>' . mxCreateImage($url_images . '/bb_italicize.gif', 'BBCode: ' . _BBITALIC, 0, 'onclick="UnbEditorDoCmd(event, \'italic\'); return false;"') . '</td>';
    echo '<td>' . mxCreateImage($url_images . '/bb_quote.gif', 'BBCode: ' . _BBQUOTE, 0, 'onclick="UnbEditorDoCmd(event, \'quote\'); return false;"') . '</td>';

    echo '</tr></table><div class="tiny">' . _PMSCLICKCODEBUTTONS . '</div>';
}

function pmValueToText($tmp)
{
    $tmp = str_replace(chr(9), "&nbsp;&nbsp;&nbsp;&nbsp;", $tmp);
    $tmp = str_replace(chr(10), "", $tmp);
    $tmp = str_replace(chr(13), " ", $tmp);
    $tmp = str_replace("<", "&lt;", $tmp);
    $tmp = str_replace(">", "&gt;", $tmp);
    $tmp = str_replace("\"", "&quot;", $tmp);
    $tmp = str_replace("'", "`", $tmp);
    $tmp = mxNL2BR($tmp);
    return $tmp;
}

function mxPmGetPictos($current)
{
    global $url_icons;
    $count = 0;

    $endings = array('gif', 'png', 'jpg', 'jpeg');
    $filelist = array();
    $tmp = (array)glob(str_replace(DS, '/', $url_icons . '/*'));
    foreach ($tmp as $image) {
        $info = pathinfo($image);
        if (isset($info['extension']) && in_array(strtolower($info['extension']), $endings)) {
            $filelist[$info['basename']] = $image;
        }
    }
    natcasesort($filelist);

    $pictos = '<table cellspacing="0" cellpadding="0" class="pictobar"><tr>';
    foreach ($filelist as $basename => $file) {
        if ($basename == $current || $file == $current) {
            $sel = ' checked="checked"';
        } else {
            $sel = '';
        }
        $pictos .= '<td><input type="radio" name="image" value="' . $basename . '"' . $sel . ' />' . mxCreateImage($file) . '</td>';
        $count++;
        if ($count >= 8) {
            $count = 0;
            $pictos .= '</tr><tr>';
        }
    }
    $pictos .= '</tr></table>';
    $pictos = str_replace('<tr></tr>', '', $pictos);
    return $pictos;
}

if (!function_exists('msg_smile')) {
    function msg_smile($x)
    {
        return $x;
    }
}
if (!function_exists('msg_desmile')) {
    function msg_desmile($x)
    {
        return $x;
    }
}
if (!function_exists('msg_bbencode')) {
    function msg_bbencode($x)
    {
        return $x;
    }
}
if (!function_exists('msg_bbdecode')) {
    function msg_bbdecode($x)
    {
        return $x;
    }
}
if (!function_exists('msg_bbencode_quote')) {
    function msg_bbencode_quote($x)
    {
        return $x;
    }
}

?>