<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 *
 *
 * Base on Reviews Addon
 * Copyright (c) 2000 by Jeff Lambert (jeffx@ican.net) http://www.qchc.com
 * More scripts on http://www.jeffx.qchc.com
 */

defined('mxMainFileLoaded') or die('access denied');

if (!mxGetAdminPref('radminreviews')) {
    mxErrorScreen("Access Denied");
    die();
}

$module_name = basename(dirname(__DIR__));
mxGetLangfile($module_name);

require_once(dirname(__DIR__) . '/includes/config.php');
require_once(dirname(__DIR__) . '/includes/functions.php');

function reviews()
{
    global $prefix, $module_name, $revautoactivate, $revimagepath;

    include_once("header.php");
    title(_REVADMIN);

    OpenTable();
    echo "<center><p class=\"option\"><b>" . _REVWAITING . "</b></p>";
    $result = sql_query("select * from " . $prefix . "_reviews WHERE active='0' order by id");
    $numrows = sql_num_rows($result);
    if ($numrows > 0) {
        $editor = load_class('Textarea', array('height' => '300', 'pagebreak' => true));
        while (list($id, $date, $title, $text, $reviewer, $score, $cover, $url, $url_title, $hits, $rlanguage, $active) = sql_fetch_row($result)) {
            $id = (empty($id)) ? 0 : intval($id);
            for($i = 0; $i < 11; $i++) {
                if ($score == $i)
                    $select[$i] = ' selected="selected" class="current"';
                else
                    $select[$i] = "";
            }
            echo "<hr noshade size=\"1\"><br />"
             . ""
             . "<form action=\"" . adminUrl(PMX_MODULE) . "\" method=\"post\">"
             . "<table cellpadding=\"1\" cellspacing=\"2\" width=\"100%\">"
             . "<tr><td><b>" . _REVIEWID . ":</b></td><td><b>$id</b>"
             . "</td></tr>"
             . "<tr><td>" . _DATE . ":</td><td>" . mx_strftime(_DATESTRING . ' %H:%m', $date) . "</td></tr>"
             . "<tr><td>" . _PRODUCTTITLE . ":</td><td><input type=\"text\" name=\"title\" value=\"" . mxentityquotes($title) . "\" size=\"60\" maxlength=\"255\" /></td></tr>";
            if ($GLOBALS['multilingual']) {
                echo "<tr><td>" . _LANGUAGE . ":</td><td>" . mxLanguageSelect('rlanguage', $rlanguage, 'language', 1) . "</td></tr>";
            }
            echo "<tr valign='top'><td>" . _RTEXT . ":</td><td>" . $editor->getHtml(array('name' => 'text_' . $id, 'value' => $text)) . "</td></tr>"
             . "<tr><td>" . _RELATEDLINK . ":</td><td><input type=\"text\" name=\"url\" value=\"" . mxentityquotes($url) . "\" size=\"60\" maxlength=\"255\" /></td></tr>"
             . "<tr><td>" . _LINKTITLE . ":</td><td><input type=\"text\" name=\"url_title\" value=\"" . mxentityquotes($url_title) . "\" size=\"60\" maxlength=\"255\" /></td></tr>"
             . "<tr><td>" . _COVERIMAGE . ":</td>"
             . "<td>" . revImageBrowse($cover) . "<br />"
             . "<span class=\"tiny\">" . sprintf(_RIMAGEFILEREQ, $revimagepath) . "</span>"
             . "</td></tr>"
             . "<tr><td>" . _REVIEWER . ":</td><td><input type=\"text\" name=\"reviewer\" value=\"" . mxentityquotes($reviewer) . "\" size=\"30\" maxlength=\"255\" /></td></tr>"
             . "<tr><td>" . _SCORE . "</td>
      				<td>
      					<select name=\"score\">
      				    <option value=\"10\" $select[10]>10</option>
      				    <option value=\"9\" $select[9]>9</option>
      				    <option value=\"8\" $select[8]>8</option>
      				    <option value=\"7\" $select[7]>7</option>
      				    <option value=\"6\" $select[6]>6</option>
      				    <option value=\"5\" $select[5]>5</option>
      				    <option value=\"4\" $select[4]>4</option>
      				    <option value=\"3\" $select[3]>3</option>
      				    <option value=\"2\" $select[2]>2</option>
      				    <option value=\"1\" $select[1]>1</option>
      				    <option value=\"0\" $select[0]>0</option>
      				 	</select>
      				</td></tr>"
             . "</table><br />"
             . "<input type=\"hidden\" name=\"date\" value=\"$date\" />"
             . "<input type=\"hidden\" name=\"id\" value=\"$id\" />"
             . "<input type=\"hidden\" name=\"op\" value=\"" . PMX_MODULE . "/add\" />"
             . "<input type=\"submit\" value=\"" . _ADDREVIEW . "\" />"
             . " - [&nbsp;<a href=\"" . adminUrl(PMX_MODULE, 'delete', 'id=' . $id) . "\">" . _DELETE . "</a>&nbsp;]"
             . "</form>";
        }
        echo "<hr noshade size=\"1\"><br /><br />";
    } else {
        echo "<br /><br /><i>" . _NOREVIEW2ADD . "</i><br /><br />";
        if ($revautoactivate) {
            echo '<p class="important">' . _AUTOACTIVATENOTIC . '</p>';
        }
    }
    echo "<p><a href=\"modules.php?name=$module_name&amp;rop=write_review\">" . _CLICK2ADDREVIEW . "</a></p></center>";
    CloseTable();
    echo '<br />';
    OpenTable();
    echo "<center><font class=\"option\"><b>" . _DELMODREVIEW . "</b></font><br /><br />" . _MODREVINFO . "</center>";
    CloseTable();
    echo "<br /><br />";
    include_once("footer.php");
}

function add_review()
{
    global $prefix;
    extract($_POST);
    $rlanguage = (empty($rlanguage)) ? '' : $rlanguage;
    $id = (empty($_POST['id'])) ? 0 : intval($_POST['id']);
    $text = $_POST['text_' . $id];
    sql_query("UPDATE " . $prefix . "_reviews SET title='" . mxAddSlashesForSQL($title) . "', text='" . mxAddSlashesForSQL($text) . "', reviewer='" . mxAddSlashesForSQL($reviewer) . "', score='$score', cover='" . mxAddSlashesForSQL($cover) . "', url='" . mxAddSlashesForSQL(mx_urltohtml($url)) . "', url_title='" . mxAddSlashesForSQL($url_title) . "', rlanguage='" . mxAddSlashesForSQL($rlanguage) . "', active='1' WHERE id='" . intval($id) . "'");
    return mxRedirect(adminUrl(PMX_MODULE));
}

function delete($id)
{
    global $prefix;
    sql_query("DELETE FROM " . $prefix . "_reviews WHERE id = " . intval($id));
    return mxRedirect(adminUrl(PMX_MODULE));
}

switch ($op) {
    case PMX_MODULE . "/add":
        add_review();
        break;

    case PMX_MODULE . "/delete":
        delete($id);
        break;

    default:
        reviews();
        break;
}

?>