<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 */

defined('mxMainFileLoaded') or die('access denied');
global $prefix, $blockid;
/* der passende Modulname */
$module_name = basename(dirname(dirname(__FILE__)));
mxGetLangfile(dirname(__DIR__));

class adminBlock {

	private $_config=array();
	private $_block=array();
	private $_settings=array();
	
	function __construct ($bid) 
	{
		global $bid;
		$this->_config['bid']=$bid;
		$this->_block=mxGetBlock($bid);
		$this->main();
	}

	function main ()
	{
		
		$module_name=basename(dirname(dirname(__FILE__)));
		
		$tb=load_class("AdminForm","adminblock");   
		
		$msg=FALSE;
		$redirect=false;
		switch(pmxAdminform::CheckButton())
		{
			case "save":
				$redirect=true;
			case "accept":
				$config=$_POST['config'];
				//$this->_SetBlockConfig($this->_config['bid'],$config);
				mxSetBlockConfig($this->_config['bid'],$config);
				if ($redirect) mxRedirect(adminUrl("blocks"));
				
				$msg=mxText("_CHANGESAREOK");

				break;

			case "back":
				mxRedirect(adminUrl("blocks"));
				break;
			default:

				break;  
		}

		$this->_block = mxGetBlock($this->_config['bid']);
		$this->_settings = $this->_SetDefault($this->_block['config']);

		pmxHeader::add_jquery();
		pmxHeader::add_script_code("
			$(document).ready(function () {
            		$('#a5546425').css('display', 'block');
            		$('#a5546425').fadeOut(6000);
			});
			"	
		);		
		
		$tb->__set("tb_direction", 'right');
		$tb->__set("infobutton", false);
		$tb->__set("tb_pic_heigth", 25);
		$tb->__set("csstoolbar", "toolbar1");
		$tb->__set("cssform", "a403030");
		$tb->__set('buttontext', false);
		$tb->__set('homelink', false);
		$tb->__set('fieldhomebutton', true);
		$tb->__set('title', mxText("_BLOCK") ." - ". mxText("_SETTINGS")."" );
		$tb->__set('acceptbutton', true);
		
		$tb->addToolbar("save");	
		$tb->addToolbar("accept");	
		$tb->addToolbarLink("preview","admin.php?op=blocks/show&bid=".$this->_config['bid']);	
		// https://development.tecmu.de/admin.php?op=blocks/show&bid=22
		$tb->addToolbarLink("back","admin.php?op=blocks");

		$config = $this->_settings;


		/*
		$limit = 55; // max Keywords used
		$minkeys = 3; // min Keywords for output
		$randomTags = true;  // Keywords zufällig sortieren
		$randomSize = true;  // Fontgröße zufällig verteilen
		*/

		if ($msg) $tb->add("","output","<div id='a5546425' class='info'>".$msg."</div>");
		
		$tb->addFieldset("blocks",mxText("_BLOCK") . ":  ". $this->_block['title'] . " (".str_replace(".php","",$this->_block['blockfile']).")");

		$tb->add("blocks","yesno","config[global_keywords]",$config['global_keywords'],mxText("_SEARCH_TC_GLOBALTAGS"),mxText("_SEARCH_TC_GLOBALTAGS_INFO"));

		$tb->add("blocks","number","config[limit]",$config['limit'],mxText("_SEARCH_TC_MAXKEYWORDS"),mxText("_SEARCH_TC_MAXKEYWORDS_INFO"),3,3);
		$tb->add("blocks","number","config[minkeys]",$config['minkeys'],mxText("_SEARCH_TC_MINKEYWORDS"),mxText("_SEARCH_TC_MINKEYWORDS_INFO"),3,3);
		$tb->add("blocks","yesno","config[randomTags]",$config['randomTags'],mxText("_SEARCH_TC_RANDOMTAGS"),mxText("_SEARCH_TC_RANDOMTAGS_INFO"));
		$tb->add("blocks","yesno","config[randomSize]",$config['randomSize'],mxText("_SEARCH_TC_RANDOMSIZE"),mxText("_SEARCH_TC_RANDOMTAGS_INFO"));


		
	  	/* formular abrufen */
		$form = $tb->Show();
		echo $form;
		
		
		/* zusatzinfos abrufen */
		
		/* blockdaten holen */
		$block = mxGetBlockData($this->_block, true);
		//mxDebugFuncVars($this->_block);
		echo '<p>'. _BLOCKPREVIEW .'&nbsp;&nbsp;<b>'. $this->_block['title'] .'&nbsp;('. $this->_block['blockfile'] .')&nbsp;</b>:</p><br /><div class="box">';
		render_blocks($block,true) ;
		echo '	</div><br />';
		
		/* */
		
	}


	private function _SetDefault($config)
	{
		$default = array(
			"limit"=>20,
			"minkeys"=>3,
			"randomTags"=>1,
			"randomSize"=>1,

		);
		$config=array_merge($default,$config);
		return $config;
	}



}
global $bid,$blockfile;

//mxDebugFuncVars($bid,$blockfile,$op);

$op=(!isset($op))?"":$op;
$bid=(!isset($bid))?NULL:$bid;
$tmp = new adminBlock($bid);
unset ($tmp);




?>