<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 */

$hook = function($module_name, $options, &$entries)
{
    global $prefix;

    switch (true) {
        case $options['type'] === 'modules':
            return $entries[$module_name] = _SECTIONS;

        case $options['type'] === 'items':

            extract($options);

            /* Sections Kategorien */
            $result = sql_query("SELECT DISTINCT c.secid, c.secname AS title, UNIX_TIMESTAMP(date_add(now(), INTERVAL - 2 MONTH)) AS datum
                    FROM `{$prefix}_sections` AS c
                    LEFT JOIN {$prefix}_seccont AS s ON ( c.secid = s.secid )
                    WHERE s.secid IS NOT NULL
                    GROUP BY c.secid
                    LIMIT " . $limit);
            if ($result) {
                while ($row = sql_fetch_object($result)) {
                    $text = $row->title;
                    $entries[] = array(/* Moduldaten */
                        'loc' => "modules.php?name=" . $module_name . "&category=" . $row->secid,
                        'lastmod' => $row->datum,
                        'text' => $text,
                        );
                }
            }

            /* Sections Artikel */
            $result = sql_query("SELECT artid, title, content, UNIX_TIMESTAMP(date_add(now(), INTERVAL - 2 MONTH)) AS datum
            FROM {$prefix}_seccont
            ORDER BY artid DESC
            LIMIT " . $limit);
            if ($result) {
                while ($row = sql_fetch_object($result)) {
                    $text = $row->title . ' ' . $row->content;
                    $entries[] = array(/* Moduldaten */
                        'loc' => "modules.php?name=" . $module_name . "&artid=" . $row->artid,
                        'lastmod' => $row->datum,
                        'text' => $text,
                        );
                }
            }
    }
}

?>