<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *

 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 *
 *
 */

defined('mxMainFileLoaded') or die('access denied');


if (!mxGetAdminPref('radminsuper')) {
    mxErrorScreen("Access Denied");
    die();
}

include_once(PMX_MODULES_PATH. basename(dirname(dirname(__FILE__))) . DS. "includes" . DS ."functions.php");
include_once(PMX_MODULES_PATH. basename(dirname(dirname(__FILE__))) . DS. "includes" . DS ."statistics.class.php");
 
/* Sprachdatei auswählen */


mxGetLangfile(dirname(dirname(__FILE__)));

class adminStatistics extends  pmxStatisticmod 
{
 	private $config=array();
	var $module_name;
	var $stats;
	
	function __construct () 
	{
		$this->module_name =basename(dirname(dirname(__FILE__)));
		$this->config=array("content"=>1,
			'total'=>1,
			'visitors'=>1,
			'periods'=>1,
			'browsers'=>1,
			'os'=>1,
			'miscstats'=>1,
			'interna'=>1,
			'content'=>1,
			
		);
		parent::__construct();
		$cf=load_class("Config","Statistics");		
		$cfstat=$cf->getSection("Statistics");
		$this->config=array_merge($this->config,$cfstat);
		$this->_isBackend=true;
		
	}
	
	
	function adminMain ()
	{

		$tb=load_class("AdminForm","adminStatistics");   
		pmxHeader::add_style(PMX_MODULES_PATH . $this->_module_name . '/style/style.css');
		
        settype($_GET['year'], 'integer');
        settype($_GET['month'], 'integer');
        settype($_GET['day'], 'integer');
        settype($_GET['act'], 'string');		
		
		$act=isset($_GET['act'])?$_GET['act']:"";
		
		switch(pmxAdminform::CheckButton())
		{
			case "config":
				mxRedirect(adminUrl($this->module_name)."/config");
				break;
			case "group":
				mxRedirect(adminUrl($this->module_name)."&amp;act=visitors");
				break;
			case "time":
				mxRedirect(adminUrl($this->module_name)."&amp;act=periods");
				break;
			case "misc":
				mxRedirect(adminUrl($this->module_name)."&amp;act=contents");
				break;
		}

		//mxDebugFuncVars($this->config,$cfstat);

		$tb->__set("tb_direction", 'right');
		$tb->__set("infobutton", false);
		$tb->__set("tb_pic_heigth", 25);
		$tb->__set("csstoolbar", "toolbar1");
		$tb->__set("cssform", "a403030");
		$tb->__set('buttontext', false);
		$tb->__set('homelink', true);
		$tb->__set('fieldhomebutton', true);
		//$tb->__set('formtabs', true);
		$tb->__set('acceptbutton', false);
		$tb->__set('tb_text', (!mxModuleActive($this->module_name))?"<div class=\"error\">" . _MODULENOTACTIVE . " <a href=\"admin.php?op=".$this->module_name."&amp;act=activate\" class=\"button\" >"._ACTIVATE."</a></div>":"");
		
		$tb->addToolbar("misc",_STAT_MISCS,PMX_MODULES_PATH . $this->module_name."/images/misc.png");	
		$tb->addToolbar("group",_STAT_VISITORS,PMX_MODULES_PATH . $this->module_name."/images/group.png");	
		$tb->addToolbar("time",_STAT_PERIODS,PMX_MODULES_PATH . $this->module_name."/images/periods.png");	
		$tb->addToolbar("config");	


        $tabs = array(/* Standardtabs */
            'contents' => _STAT_MISCS,
            'visitors' => _STAT_VISITORS,
            'periods' => _STAT_PERIODS,
            );

	
        switch ($act) {

            case "visitors":
                $content = $this->visitors();
                $currenttab = 'visitors';
				$tb->addFieldset("visitors",mxText("_STAT_VISITORS"));	
				$tb->add("visitors","html",''.$content.'');
                break;

            case "periods":
                $content = $this->periods();
                $currenttab = 'periods';
				$tb->addFieldset("periods",mxText("_STAT_PERIODS"));
				$tb->add("periods","html",''.$content.'');
                break;

            case "yearly":
                $content = $this->yearly();
                $currenttab = 'periods';
				$tb->addFieldset("periods",mxText("_STAT_PERIODS"));
				$tb->add("periods","html",''.$content.'');				
                break;

            case "monthly":
                $content = $this->monthly();
                $currenttab = 'periods';
				$tb->addFieldset("periods",mxText("_STAT_PERIODS"));	
				$tb->add("periods","html",''.$content.'');
                break;

            case "daily":
                $content = $this->daily();
                $currenttab = 'periods';
				$tb->addFieldset("periods",mxText("_STAT_PERIODS"));	
				$tb->add("periods","html",''.$content.'');
                break;
			case "activate":
				$this->setmoduleactive();
				mxRedirect(adminUrl($this->module_name)."");
            case "contents":
            default:
                $content = $this->contents();
                $currenttab = 'contents';
				$tb->addFieldset("misc",mxText("_STAT_MISCS"));	
				$tb->add("misc","html",''.$content.'');
                break;
				
        }

        $this->_template->assign('module_name', $this->_module_name);
        $this->_template->assign('tabs', $tabs);
        $this->_template->assign('today', mx_strftime(_DATESTRING));
        $this->_template->assign('current', $currenttab);
        $this->_template->assign('content', $content);
        

		$form = $tb->Show();
		
		
		/*
		 * Template
		 */
		// Template initialisieren
		$template = load_class('Template');
		$template->add_path(dirname(dirname(__FILE__)).DS.'templates'.DS);	
		/* hier die Ausgabefelder angeben */
		$info2=_STAT_STATS;
		/* Variablen an das Template uebergeben */
		$template->assign(compact('form', 'info2'));

		mxIncludeHeader();
		/* Template ausgeben (echo) */
		
		$template->display('admin.html');
		
		
		mxIncludeFooter();			
	}
	
	
	function adminSettings ()
	{

		$tb=load_class("AdminForm","adminStatisticsSettings");   
		$redirect=false;
		
		switch(pmxAdminform::CheckButton())
		{
			case "save":
				$redirect=true;
			case "accept":
				
				$this->config=$_POST['config'];
				$msg=mxText("_CHANGESAREOK");
				$cf=load_class("Config","Statistics");	
				$cf->setSection("Statistics",$this->config);
				break;

		}
		if ($redirect) mxRedirect(adminUrl($this->module_name)."");
		
		$tb->__set("tb_direction", 'right');
		$tb->__set("infobutton", false);
		$tb->__set("tb_pic_heigth", 25);
		$tb->__set("csstoolbar", "toolbar1");
		$tb->__set("cssform", "a403030");
		$tb->__set('buttontext', false);
		$tb->__set('homelink', false);
		$tb->__set('fieldhomebutton', true);
		$tb->__set('formtabs', false);
		$tb->__set('acceptbutton', false);
		
		
		$tb->addToolbar("accept");	
		$tb->addToolbar("save");	


		$tb->addFieldset("settings",mxText("_SETTINGS"), _STAT_INFO);
		
		$tb->add("settings","output",mxText("_STAT_SHOW"));
		//$tb->add("settings","checkbox","config[total]",$this->config['total'],_STAT_TOTALSUMM ." "._STAT_HITS,"");
		$tb->add("settings","checkbox","config[miscstats]",$this->config['miscstats'],_STAT_MISCSTATS,"");
		$tb->add("settings","checkbox","config[interna]",$this->config['interna'],_STAT_PERS,"");
		$tb->add("settings","checkbox","config[visitors]",$this->config['visitors'],_STAT_VISITORS,"");
		$tb->add("settings","checkbox","config[periods]",$this->config['periods'],_STAT_PERIODS,"");
		//$tb->add("settings","checkbox","config[browsers]",$this->config['browsers'],_STAT_BROWSERS,"");
		//$tb->add("settings","checkbox","config[os]",$this->config['os'],_STAT_OPERATINGSYS,"");
		//$tb->add("settings","checkbox","config[content]",$this->config['content'],_STAT_MISCSTATS,"");

		$form = $tb->Show();
		/*
		 * Template
		 */
		// Template initialisieren
		$template = load_class('Template');
		$template->add_path(dirname(dirname(__FILE__)).DS.'templates'.DS);	
		/* hier die Ausgabefelder angeben */
		$info2=_STAT_STATS;
		/* Variablen an das Template uebergeben */
		$template->assign(compact('form', 'info2'));

		mxIncludeHeader();
		/* Template ausgeben (echo) */
		$template->display('admin.html');

		mxIncludeFooter();			
	}
	
	function setmoduleactive($active=1) {
		global $doc_cfg, $module_name, $credits, $setup_result, $prefix, $doc;
		mxSetModuleActive($module_name,$active);
		return;
	}
 
}

$module_name=basename(dirname(dirname(__FILE__)));
$op=(!isset($op))?"":$op;
$tmp=false;
$tmp= new adminStatistics();

switch ($op) {
	
	case $module_name."/config":
		$tmp->adminSettings();
        break;
    default:
		$tmp->adminMain();
        break;
}
unset($tmp);
?>