<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 584 $
 * $Author: PragmaMx $
 * $Date: 2022-08-29 21:51:21 +0200 (Mo, 29. Aug 2022) $
 */

defined('mxMainFileLoaded') or die('access denied');
pmxBase::set("plugins",0);
$module_name = basename(__DIR__);
mxGetLangfile($module_name);

$top = (isset($_GET['top'])) ? intval($_GET['top']) : 10;
if (empty($top) || $top > 100) {
    $top = 10;
}

$hook = load_class('Hook', 'top');
$hook->set('top', $top);
$items = $hook->get(array());
if (!$items || !is_array($items)) {
    $items = array();
}

/* modulspezifisches Stylesheet einbinden */
pmxHeader::add_style('modules/' . $module_name . '/style/style.css');

/* Template initialisieren */
$template = load_class('Template');
$template->init_path(__FILE__);
$template->caption = _TOPWELCOME . ' ' . $GLOBALS['sitename'];
$template->items = $items;
// $template->init_template(__FILE__);
$content = $template->fetch('main.html');

$pagetitle = _TOP10;
include('header.php');
OpenTable();
echo $content;
CloseTable();
include('footer.php');

?>
