<?php
/**
 * This file is part of 
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 */

defined('mxMainFileLoaded') or die('access denied');
$modname = basename(dirname(dirname(__FILE__)));

unset($sqlqry);
// Usergaestebuch
// pruefen ob die Usergaestebuchtabelle aktuell ist, ggf. umbenennen
if (isset($tables["${prefix}_userguest"])) {
    $tf = setupGetTableFields("${prefix}_userguest");
    if (!isset($tf['gid']) || !isset($tf['touser']) || !isset($tf['text']) || !isset($tf['date']) || !isset($tf['wer']) || !isset($tf['dummy']) || !isset($tf['touserid']) || !isset($tf['fromuserid'])) {
        $badugbtable = RENAME_PREFIX . "${prefix}_userguest";
        $sqlqry[] = "RENAME TABLE `${prefix}_userguest` TO `" . $badugbtable . "`;";
        unset($tables["${prefix}_userguest"]);
    }
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}
// ab pragmaMx 0.1.7
if (!isset($tables["${prefix}_userguest"]) || isset($badugbtable)) {
    $sqlqry[] = "
CREATE TABLE `${prefix}_userguest` (
  `gid` int(11) NOT NULL auto_increment,
  `touser` varchar(25) NOT NULL default '',
  `text` text NULL,
  `date` int(11) NOT NULL default '0',
  `wer` varchar(25) NOT NULL default '',
  `dummy` tinyint(4) NOT NULL default '0',
  `touserid` int(11) NOT NULL default '0',
  `fromuserid` int(11) NOT NULL default '0',
  PRIMARY KEY  (`gid`),
  KEY `date` (`date`),
  KEY `wer` (`wer`),
  KEY `dummy` (`dummy`),
  KEY `touserid` (`touserid`),
  KEY `fromuserid` (`fromuserid`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;
";
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}
// ende ab pragmaMx 0.1.7
// alte Versionen noch konvertieren, falls obiger Test fehlgeschlagen
if (isset($badugbtable)) {
    $sqlqry[] = "INSERT INTO ${prefix}_userguest ( gid, touser, `text`, `date`, wer, dummy, touserid, fromuserid )
        SELECT ugb.gid, ugb.touser, ugb.text, UNIX_TIMESTAMP(ugb.wann), ugb.wer, ugb.dummy, touser.uid, fromuser.uid
        FROM (" . $badugbtable . " AS ugb
        LEFT JOIN {$user_prefix}_users AS touser ON ugb.touser = touser.uname)
        LEFT JOIN {$user_prefix}_users AS fromuser ON ugb.wer = fromuser.uname;";
}

if (isset($tables["${prefix}_userguest"])) {
    // Felder ueberpruefen
    $tf = setupGetTableFields("${prefix}_userguest");
    if ($tf['wer']['Type'] != 'varchar(25)') $sqlqry[] = "ALTER TABLE `${prefix}_userguest` CHANGE `wer` `wer` VARCHAR( 25 ) NOT NULL default ''";
    if ($tf['touser']['Type'] != 'varchar(25)') $sqlqry[] = "ALTER TABLE `${prefix}_userguest` CHANGE `touser` `touser` VARCHAR( 25 ) NOT NULL default ''";
    if ($tf['text']['Default'] !== null || $tf['touser']['Default'] === null || $tf['wer']['Default'] === null) {
        $sqlqry[] = "ALTER TABLE `${prefix}_userguest`
                CHANGE `text` `text` text NULL,
                CHANGE `touser` `touser` varchar(25) NOT NULL default '',
                CHANGE `wer` `wer` varchar(25) NOT NULL default '' ";
    }
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

$indexes = setupGetTableIndexes("${prefix}_userguest");
if (!isset($indexes['date'])) $sqlqry[] = "ALTER TABLE `${prefix}_userguest` ADD INDEX `date` ( `date` )  ;";
if (!isset($indexes['wer'])) $sqlqry[] = "ALTER TABLE `${prefix}_userguest` ADD INDEX `wer` ( `wer` ) ;";
if (!isset($indexes['dummy'])) $sqlqry[] = "ALTER TABLE `${prefix}_userguest` ADD INDEX `dummy` ( `dummy` ) ;";
if (!isset($indexes['touserid'])) $sqlqry[] = "ALTER TABLE `${prefix}_userguest` ADD INDEX `touserid` ( `touserid` ) ;";
if (!isset($indexes['fromuserid'])) $sqlqry[] = "ALTER TABLE `${prefix}_userguest` ADD INDEX `fromuserid` ( `fromuserid` ) ;";

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}
// aufraeumen
unset($numrows, $badugbtable);

?>