<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 *
 *
 * Based on Journey Links Hack
 * Copyright (c) 2000 by James Knickelbein
 * Journey Milwaukee (http://www.journeymilwaukee.com)
 */

defined('mxMainFileLoaded') or die('access denied');

if (!$usevoting || !$usecomments) {
    mxRedirect('modules.php?name=' . $module_name, _NOCOMMENTSWARN, 5);
}

function viewcomments($lid)
{
    global $prefix, $module_name, $pagetitle, $usecomments, $usevoting, $modimagepath;
    if (!modCheckAndCleanSubdata($lid)) {
        mxRedirect('modules.php?name=' . $module_name);
    }

    $result = sql_query("SELECT lid, title FROM " . $prefix . "_links_links WHERE lid = " . intval($lid) . " AND cid > 0");
    list($lid, $title) = sql_fetch_row($result);
    // falls fehlerhafte lid uebergeben
    if (empty($lid)) {
        mxErrorScreen('link id ' . intval($lid) . ' not found...');
    }
    $result = sql_query("SELECT ratinguser, rating, ratingcomments, ratingtimestamp FROM " . $prefix . "_links_votedata WHERE ratinglid = " . ($lid) . " AND ratingcomments <> '' ORDER BY ratingtimestamp DESC");
    $totalcomments = sql_num_rows($result);
    // Daten fuer header aufbereiten
    $pagetitle = strip_tags($title . ', ' . _COMMENTS);
    $pagesubmenu = modDetailsTopMenu($lid);

    include(PMX_MODULES_DIR . DS . $module_name . '/includes/header.php');
    OpenTable();
    // / <center>" . _TOTALOF . " " . $totalcomments . " " . _COMMENTS . "</font></center>
    echo '<h4 class="option">' . _COMMENTS . '</h4>';
    echo "<table align=\"center\" border=\"0\" cellspacing=\"0\" cellpadding=\"2\" width=\"100%\">";
    $x = 0;
    while (list($ratinguser, $rating, $ratingcomments, $ratingtimestamp) = sql_fetch_row($result)) {
        $formatted_date = formattimestamp($ratingtimestamp);
        $result2 = sql_query("SELECT rating FROM " . $prefix . "_links_votedata WHERE ratinguser = '" . mxAddSlashesForSQL($ratinguser) . "'");
        $usertotalcomments = sql_num_rows($result2);
        $useravgrating = 0;
        while (list($rating2) = sql_fetch_row($result2)) {
            $useravgrating = $useravgrating + $rating2;
        }
        $useravgrating = $useravgrating / $usertotalcomments;
        $useravgrating = number_format($useravgrating, 1);
        echo "<tr><td class=\"bgcolor2\">"
         . "<font class=\"content\"><b> " . _USER . ": </b>" . mxCreateUserprofileLink($ratinguser) . "</font>"
         . "</td>"
         . "<td class=\"bgcolor2\">"
         . "<font class=\"content\"><b>" . _RATING . ": </b>$rating</font>"
         . "</td>"
         . "<td class=\"bgcolor2\" align=\"right\">"
         . "<font class=\"content\">$formatted_date</font>"
         . "</td>"
         . "</tr>"
         . "<tr>"
         . "<td valign=\"top\">"
         . "<font class=\"tiny\">" . _USERAVGRATING . ": $useravgrating</font>"
         . "</td>"
         . "<td valign=\"top\" colspan=\"2\">"
         . "<font class=\"tiny\">" . _NUMRATINGS . ": $usertotalcomments</font>"
         . "</td>"
         . "</tr>"
         . "<tr>"
         . "<td colspan=\"3\">"
         . "<div class=\"content\">" . $ratingcomments . "</div>"
         . "</td></tr>";
        $x++;
    }

    if (MX_IS_USER && $usecomments && $usevoting) {
        echo '<tr><td colspan="3" align="center" class="bgcolor2">'
         . '<div align="center"><a rel="nofollow" href="modules.php?name=' . PMX_MODULE . '&amp;op=rating&amp;lid=' . $lid . '" title="' . _FEELFREE2ADD . '"><b>' . _ADDACOMMENT . '</b></a></div>'
         . '</td></tr>';
    }
    echo "</table>";

    if (mxGetAdminPref("radminlink")) {
        echo "<div align=\"right\"><a href=\"" . adminUrl(PMX_MODULE, 'ModData', "lid=" . $lid) . "\">" . mxCreateImage($modimagepath . 'edit.gif', _EDITTHISLINK, array('title' => _EDITTHISLINK, 'hspace' => 2)) . "</a></div>";
    }
    CloseTable();
    include(PMX_MODULES_DIR . DS . $module_name . '/includes/footer.php');
}

?>