<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 636 $
 * $Author: PragmaMx $
 * $Date: 2022-10-24 07:41:49 +0200 (Mo, 24. Okt 2022) $
 */

defined('mxMainFileLoaded') or die('access denied');
$modname = basename(dirname(dirname(__FILE__)));

unset($sqlqry);

if (!isset($tables["{$prefix}_links_links"])) {
    $sqlqry[] = "
CREATE TABLE `{$prefix}_links_links` (
  `lid` int(11) NOT NULL auto_increment,
  `cid` int(11) NOT NULL default '0',
  `sid` int(11) NOT NULL default '0',
  `title` varchar(100) NOT NULL default '',
  `url` varchar(255) NOT NULL default '',
  `description` text NULL,
  `date` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `name` varchar(100) NOT NULL default '',
  `email` varchar(100) NOT NULL default '',
  `hits` int(11) NOT NULL default '0',
  `submitter` varchar(60) NOT NULL default '',
  `linkratingsummary` double(6,4) NOT NULL default '0.0000',
  `totalvotes` int(11) NOT NULL default '0',
  `totalcomments` int(11) NOT NULL default '0',
  PRIMARY KEY  (`lid`),
  KEY `cid` (`cid`),
  KEY `hits` (`hits`),
  KEY `title` (`title`),
  KEY `date` (`date`),
  KEY `linkratingsummary` (`linkratingsummary`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
}

if (!isset($tables["{$prefix}_links_newlink"])) {
    $sqlqry[] = "
CREATE TABLE `{$prefix}_links_newlink` (
  `lid` int(11) NOT NULL auto_increment,
  `cid` int(11) NOT NULL default '0',
  `sid` int(11) NOT NULL default '0',
  `title` varchar(100) NOT NULL default '',
  `url` varchar(255) NOT NULL default '',
  `description` text NULL,
  `name` varchar(100) NOT NULL default '',
  `email` varchar(100) NOT NULL default '',
  `submitter` varchar(60) NOT NULL default '',
  `updated` timestamp NOT NULL default CURRENT_TIMESTAMP,
  PRIMARY KEY  (`lid`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
}

if (isset($tables["{$prefix}_links_categories"])) {
    // Felder aktualisieren
    $tf = setupGetTableFields("{$prefix}_links_categories");
    if (!isset($tf['parentid'])) {
        // nuke < 5.5
        $sqlqry[] = "ALTER TABLE `{$prefix}_links_categories` ADD `parentid` INT( 11 ) NOT NULL DEFAULT '0'";
        $nukebefore55 = true;
    } else {
        if ($tf['parentid']['Type'] != 'int(11)') $sqlqry[] = "ALTER TABLE `{$prefix}_links_categories` CHANGE `parentid` `parentid` INT( 11 ) NOT NULL DEFAULT '0';";
    }
} else {
    $sqlqry[] = "
CREATE TABLE `{$prefix}_links_categories` (
  `cid` int(11) NOT NULL auto_increment,
  `title` varchar(100) NOT NULL default '',
  `cdescription` text NULL,
  `parentid` int(11) NOT NULL default '0',
  `captcha` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`cid`),
  KEY `title` (`title`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
}

if (!isset($tables["{$prefix}_links_editorials"])) {
    $sqlqry[] = "
CREATE TABLE `{$prefix}_links_editorials` (
  `linkid` int(11) NOT NULL default '0',
  `adminid` varchar(60) NOT NULL default '',
  `editorialtimestamp` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `editorialtext` text NULL,
  `editorialtitle` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`linkid`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
}

if (!isset($tables["{$prefix}_links_modrequest"])) {
    $sqlqry[] = "
CREATE TABLE `{$prefix}_links_modrequest` (
  `requestid` int(11) NOT NULL auto_increment,
  `lid` int(11) NOT NULL default '0',
  `cid` int(11) NOT NULL default '0',
  `sid` int(11) NOT NULL default '0',
  `title` varchar(100) NOT NULL default '',
  `url` varchar(100) NOT NULL default '',
  `description` text NULL,
  `modifysubmitter` varchar(60) NOT NULL default '',
  `brokenlink` int(3) NOT NULL default '0',
  `name` varchar(100) NOT NULL default '',
  `email` varchar(100) NOT NULL default '',
  `updated` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY  (`requestid`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
}

if (!isset($tables["{$prefix}_links_votedata"])) {
    $sqlqry[] = "
CREATE TABLE `{$prefix}_links_votedata` (
  `ratingdbid` int(11) NOT NULL auto_increment,
  `ratinglid` int(11) NOT NULL default '0',
  `ratinguser` varchar(60) NOT NULL default '',
  `rating` int(11) NOT NULL default '0',
  `ratinghostname` varchar(60) NOT NULL default '',
  `ratingcomments` text NULL,
  `ratingtimestamp` timestamp NOT NULL default CURRENT_TIMESTAMP,
  PRIMARY KEY  (`ratingdbid`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}
// Links Tabelle aendern nuke < 5.4
// based on: Links Table Alteration - patched by simplywebdesign.com  20-01-2002
if (isset($tables["{$prefix}_links_subcategories"]) && isset($nukebefore55)) {
    $result = sql_query("select sid, cid, title from {$prefix}_links_subcategories order by sid");
    while (list($sid, $cid, $title) = sql_fetch_row($result)) {
        setupDoAllQueries("insert into {$prefix}_links_categories SET title='" . addslashes(strip_tags($title)) . "', parentid=" . intval($cid) . "");
        $result1 = sql_query("select max(cid) from {$prefix}_links_categories");
        while (list($lastcat) = sql_fetch_row($result1)) {
            $result2 = sql_query("select lid from {$prefix}_links_links where sid = " . intval($sid) . "");
            while (list($lid) = sql_fetch_row($result2)) {
                $sqlqry[] = "UPDATE {$prefix}_links_links set cid = " . intval($lastcat) . " where lid= " . intval($lid) . "";
            }
        }
    }
    $sqlqry[] = "RENAME TABLE `{$prefix}_links_subcategories` TO `" . RENAME_PREFIX . "{$prefix}_links_subcategories`;";
    unset($sid, $cid, $title, $lastcat, $lid, $nukebefore55);
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

if (isset($tables["{$prefix}_links_categories"])) {
    $tf = setupGetTableFields("{$prefix}_links_categories");
    if (!isset($tf['captcha'])) {
        $sqlqry[] = "ALTER TABLE `{$prefix}_links_categories` ADD `captcha` TINYINT( 1 ) NOT NULL DEFAULT '0'";
        $sqlqry[] = "UPDATE `{$prefix}_links_categories` SET `captcha` = 0";
    }
    if ($tf['cid']['Type'] != 'int(11)') $sqlqry[] = "ALTER TABLE `{$prefix}_links_categories` CHANGE `cid` `cid` INT( 11 ) NOT NULL DEFAULT '0';";
    if ($tf['title']['Type'] != 'varchar(100)') $sqlqry[] = "ALTER TABLE `{$prefix}_links_categories` CHANGE `title` `title` VARCHAR( 100 ) NOT NULL default ''";
    if (isset($tf['parentid']) && $tf['parentid']['Type'] != 'int(11)') $sqlqry[] = "ALTER TABLE {$prefix}_links_categories CHANGE parentid parentid INT(11) NOT NULL default '0';";
    if (isset($tf['view'])) $sqlqry[] = "ALTER TABLE `{$prefix}_links_categories` DROP `view` "; // cp
    if (isset($tf['mainid'])) $sqlqry[] = "ALTER TABLE `{$prefix}_links_categories` DROP `mainid` "; // cp
    if ($tf['cdescription']['Default'] !== null || $tf['title']['Default'] === null) {
        $sqlqry[] = "ALTER TABLE `{$prefix}_links_categories`
                CHANGE `cdescription` `cdescription` text NULL,
                CHANGE `title` `title` VARCHAR( 100 ) NOT NULL DEFAULT '' ";
    }
}

if (isset($tables["{$prefix}_links_links"])) {
    // Felder aktualisieren
    $tf = setupGetTableFields("{$prefix}_links_links");

    if (isset($tf['view'])) $sqlqry[] = "ALTER TABLE `{$prefix}_links_links` DROP `view` "; // cp

    switch (true) {
        case $tf['description']['Default'] !== null:
        case $tf['url']['Type'] != 'varchar(255)':
        case $tf['url']['Default'] === null:
        case $tf['date']['Null'] != 'NO':
        case $tf['date']['Type'] != 'timestamp':
        case $tf['date']['Default'] != 'CURRENT_TIMESTAMP':
            /* vorher gültige Daten erzeugen, sonst Fehler:
              * Incorrect datetime value: '0000-00-00 00:00:00' for column '***' at....*/
            $sqlqry[] = "UPDATE `${prefix}_links_links` SET `date` = NOW( ) WHERE `date` LIKE '0000-00-00%'";
            $sqlqry[] = "ALTER TABLE `{$prefix}_links_links`
                CHANGE `description` `description` text NULL,
                CHANGE `url` `url` varchar( 255 ) NOT NULL default '',
                CHANGE `date` `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP
                ";
    }
}

if (isset($tables["{$prefix}_links_editorials"])) {
    // Felder aktualisieren
    $tf = setupGetTableFields("{$prefix}_links_editorials");

    switch (true) {
        case $tf['editorialtext']['Default'] !== null:
        case $tf['editorialtimestamp']['Null'] != 'NO':
        case $tf['editorialtimestamp']['Type'] != 'timestamp':
        case $tf['editorialtimestamp']['Default'] != 'CURRENT_TIMESTAMP':
            /* vorher gültige Daten erzeugen, sonst Fehler:
              * Incorrect datetime value: '0000-00-00 00:00:00' for column '***' at....*/
            $sqlqry[] = "UPDATE `${prefix}_links_editorials` SET `editorialtimestamp` = NOW( ) WHERE `editorialtimestamp` LIKE '0000-00-00%'";
            $sqlqry[] = "ALTER TABLE `{$prefix}_links_editorials`
                CHANGE `editorialtext` `editorialtext` text NULL,
                CHANGE `editorialtimestamp` `editorialtimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP
                ";
    }
}

if (isset($tables["{$prefix}_links_modrequest"])) {
    $tf = setupGetTableFields("{$prefix}_links_modrequest");

    if (!isset($tf['name'])) {
        $sqlqry[] = "ALTER TABLE `{$prefix}_links_modrequest` ADD `name` varchar(100) NOT NULL default ''";
    }

    if (!isset($tf['email'])) {
        $sqlqry[] = "ALTER TABLE `{$prefix}_links_modrequest` ADD `email` varchar(100) NOT NULL default ''";
    }

    if (!isset($tf['updated'])) {
        $sqlqry[] = "ALTER TABLE `{$prefix}_links_modrequest` ADD `updated` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP";
    } else {
        switch (true) {
            case $tf['updated']['Null'] != 'NO':
            case $tf['updated']['Type'] != 'timestamp':
            case $tf['updated']['Default'] != 'CURRENT_TIMESTAMP':
                /* vorher gültige Daten erzeugen, sonst Fehler:
              * Incorrect datetime value: '0000-00-00 00:00:00' for column '***' at....*/
                $sqlqry[] = "UPDATE `${prefix}_links_modrequest` SET `updated` = NOW( ) WHERE `updated` LIKE '0000-00-00%'";
                $sqlqry[] = "ALTER TABLE `{$prefix}_links_modrequest`
                    CHANGE `updated` `updated` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP
                    ";
        }
    }

    switch (true) {
        case $tf['description']['Default'] !== null:
            $sqlqry[] = "ALTER TABLE `{$prefix}_links_modrequest
                CHANGE `description` `description` text NULL
                ";
    }
}

if (isset($tables["{$prefix}_links_newlink"])) {
    $tf = setupGetTableFields("{$prefix}_links_newlink");

    if (!isset($tf['updated'])) {
        $sqlqry[] = "ALTER TABLE `{$prefix}_links_newlink` ADD `updated` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP";
    } else {
        switch (true) {
            case $tf['updated']['Null'] != 'NO':
            case $tf['updated']['Type'] != 'timestamp':
            case $tf['updated']['Default'] != 'CURRENT_TIMESTAMP':
                /* vorher gültige Daten erzeugen, sonst Fehler:
              * Incorrect datetime value: '0000-00-00 00:00:00' for column '***' at....*/
                $sqlqry[] = "UPDATE `${prefix}_links_newlink` SET `updated` = NOW( ) WHERE `updated` LIKE '0000-00-00%'";
                $sqlqry[] = "ALTER TABLE `{$prefix}_links_newlink`
                    CHANGE `updated` `updated` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP
                    ";
        }
    }

    switch (true) {
        case $tf['description']['Default'] !== null:
        case $tf['url']['Type'] != 'varchar(255)':
        case $tf['url']['Default'] === null:
            $sqlqry[] = "ALTER TABLE `{$prefix}_links_newlink`
                CHANGE `description` `description` text NULL,
                CHANGE `url` `url` varchar(255) NOT NULL default ''
                ";
    }
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

if (isset($tables["{$prefix}_links_votedata"])) {
    $tf = setupGetTableFields("{$prefix}_links_votedata");
    switch (true) {
        case $tf['ratingcomments']['Default'] !== null:
        case $tf['ratingtimestamp']['Null'] != 'NO':
        case $tf['ratingtimestamp']['Type'] != 'timestamp':
        case $tf['ratingtimestamp']['Default'] != 'CURRENT_TIMESTAMP':
            /* vorher gültige Daten erzeugen, sonst Fehler:
              * Incorrect datetime value: '0000-00-00 00:00:00' for column '***' at....*/
            $sqlqry[] = "UPDATE `${prefix}_links_votedata` SET `ratingtimestamp` = NOW( ) WHERE `ratingtimestamp` LIKE '0000-00-00%'";
            $sqlqry[] = "ALTER TABLE `{$prefix}_links_votedata`
                CHANGE `ratingcomments` `ratingcomments` text NULL,
                CHANGE `ratingtimestamp` `ratingtimestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP
                ";
    }
}

/**
 * feststellen, ob Kategorien vorhanden sind, die als Parent wieder auf sich
 * selbst verweisen und versuchen dies zu aendern, indem bei diesen Kategorien
 * die Parent-Id auf 0 gesetzt wird, also der Hauptkategorie zugeordnet wird
 */
$arr = array();
$qry = "SELECT cid, parentid FROM `{$prefix}_links_categories` ORDER BY cid";
$result = sql_query($qry);
while ($row = sql_fetch_assoc($result)) {
    $arr[$row['cid']] = intval($row['parentid']);
}
if ($arr) {
    $flip = array_flip($arr);
    foreach($flip as $parent => $cid) {
        if (isset($arr[$parent]) && $arr[$parent] == $cid) {
            $sqlqry[] = "UPDATE `{$prefix}_links_categories` SET `parentid` = 0 WHERE cid=" . $cid . " OR cid=" . $parent . "";
        }
    }
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}
// indexe aktualisieren
$indexes = setupGetTableIndexes("{$prefix}_links_categories");
if (isset($indexes['cid'])) $sqlqry[] = "ALTER TABLE `{$prefix}_links_categories` DROP INDEX `cid` ";
if (!isset($indexes['title'])) $sqlqry[] = "ALTER TABLE `{$prefix}_links_categories` ADD INDEX `title` ( `title` )";

$indexes = setupGetTableIndexes("{$prefix}_links_links");
if (!isset($indexes['cid'])) $sqlqry[] = "ALTER TABLE `{$prefix}_links_links` ADD INDEX `cid` ( `cid` )";
if (!isset($indexes['hits'])) $sqlqry[] = "ALTER TABLE `{$prefix}_links_links` ADD INDEX `hits` ( `hits` )";
if (!isset($indexes['title'])) $sqlqry[] = "ALTER TABLE `{$prefix}_links_links` ADD INDEX `title` ( `title` )";
if (!isset($indexes['date'])) $sqlqry[] = "ALTER TABLE `{$prefix}_links_links` ADD INDEX `date` ( `date` )";
if (isset($indexes['ddate'])) $sqlqry[] = "ALTER TABLE `{$prefix}_links_links` DROP INDEX ddate";
if (!isset($indexes['linkratingsummary'])) $sqlqry[] = "ALTER TABLE `{$prefix}_links_links` ADD INDEX `linkratingsummary` ( `linkratingsummary` )";

if (isset($indexes['sid'])) $sqlqry[] = "ALTER TABLE `{$prefix}_links_links` DROP INDEX `sid` ";

$indexes = setupGetTableIndexes("{$prefix}_links_modrequest");
if (isset($indexes['requestid'])) $sqlqry[] = "ALTER TABLE `{$prefix}_links_modrequest` DROP INDEX `requestid` ";
if (isset($indexes['PRIMARY']) && $indexes['PRIMARY']['Column_name'] != 'requestid') {
    $sqlqry[] = "ALTER TABLE `{$prefix}_links_modrequest` DROP PRIMARY KEY , ADD PRIMARY KEY ( `requestid` ) ";
} else if (!isset($indexes['PRIMARY'])) {
    $sqlqry[] = "ALTER TABLE `{$prefix}_links_modrequest` ADD PRIMARY KEY ( `requestid` ) ";
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

?>