<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 *
 *
 * Based on Journey Links Hack
 * Copyright (c) 2000 by James Knickelbein
 * Journey Milwaukee (http://www.journeymilwaukee.com)
 */

defined('mxMainFileLoaded') or die('access denied');

function viewdetails($lid)
{
    global $prefix, $module_name, $pagetitle, $modimagepath;
    if (!modCheckAndCleanSubdata($lid)) {
        mxRedirect('modules.php?name=' . $module_name);
    }
    $qry = "SELECT dd.*, dd.name as auth_name, dd.date as updated, dc.title AS ctitle, dc.parentid AS cparentid, dc.captcha, de.linkid AS editorialid,  de.adminid AS editorialauthor, de.editorialtimestamp, de.editorialtext, de.editorialtitle
        FROM " . $prefix . "_links_links AS dd
        LEFT JOIN " . $prefix . "_links_categories AS dc ON dd.cid = dc.cid
        LEFT JOIN " . $prefix . "_links_editorials AS de ON dd.lid = de.linkid
        WHERE dd.lid = " . intval($lid) . "
        LIMIT 1";
    $result = sql_query($qry);
    $row = sql_fetch_assoc($result);
    // Daten fuer header aufbereiten
    $title = $row['title'];
    $pagetitle = strip_tags($title . ', ' . _LINKPROFILE);
    $pagesubmenu = modDetailsTopMenu($lid);

    $newimage = modNewMakeGrafic($row['date'], array('hspace' => 5, 'style' => 'vertical-align: middle;'));
    // wenn populaerer Link, dann ein Bildchen generieren
    if ($row['hits'] >= $GLOBALS['popular'] && (!isset($GLOBALS['op']) || $GLOBALS['op'] != 'MostPopular')) {
        $popimage = mxCreateImage($modimagepath . 'popular.gif', _WLPOPULAR, array('title' => _WLPOPULAR . ' (' . $row['hits'] . ' ' . _HITSTOITEM . ')', 'hspace' => 5, 'style' => 'vertical-align:middle'));
    } else {
        $popimage = '';
    }

    include(PMX_MODULES_DIR . DS . $module_name . '/includes/header.php');
    OpenTable();
    echo '<h3 class="option">', _LINKPROFILE, $newimage, $popimage, '</h3>';
    modViewData($row, 'single');
    CloseTable();
    echo '<br />';
    // Das Editorial, falls vorhanden
    if (!empty($row['editorialid'])) {
        echo '<a name="editorial" id="editorial"></a>';
        OpenTable();
        echo '<h3 class="option">&quot;<b>' . $row['editorialtitle'] . '</b>&quot;</h3>'
         . '<p align="right" class="tiny">' . _EDITORIALBY . ' ' . $row['editorialauthor'] . ' - ' . formattimestamp($row['editorialtimestamp']) . '</p>'
         . '<div class="content" style="text-align: justify;">' . $row['editorialtext'] . '</div>';
        CloseTable();
        echo '<br />';
    }
    // Captcha fuer direkten Link
    if (!MX_IS_ADMIN && $row['captcha']) {
        $captcha_object = load_class('Captcha');
        if ($captcha_object->get_active()) {
            $captcha_object = null;
            OpenTable();
            modFetchForm($row['lid'], $row['title'], $row['url'], '_blank');
            CloseTable();
            echo '<br />';
        }
    }
    // Fuss-Menue
    $menu = modDetailsFootMenu($row['lid']);
    $voting = ($GLOBALS['usevoting'] && $GLOBALS['useoutsidevoting']);
    if ($voting || $menu) {
        OpenTable();
        if ($menu) {
            echo '<p align="right" class="content">' . modDetailsFootMenu($row['lid'], __function__) . '</p>';
        }
        if ($voting) {
            echo '<p align="left" class="content">' . _ISTHISYOURSITE . '<br /><a href="modules.php?name=' . PMX_MODULE . '&amp;op=outsiderating&amp;lid=' . $lid . '">' . _ALLOWTORATE . '</a></p>';
        }
        CloseTable();
        echo '<br />';
    }

    include(PMX_MODULES_DIR . DS . $module_name . '/includes/footer.php');
}

?>