<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 */

defined('mxMainFileLoaded') or die('access denied');

if (!mxGetAdminPref("radminlink")) {
    mxErrorScreen("Access Denied");
    die();
}

$module_name = basename(dirname(dirname(__FILE__)));

$redirs = 0;
$starturl = '';
$endurl = '';
$status = '';
$type = '';
$url = '';

switch (true) {
    case isset($_GET['url']):
        $url = base64_decode($_GET['url']);
        break;
    case empty($_GET['lid']):
        $url = '';
        break;
    default:
        $result = sql_query("SELECT url FROM " . $prefix . "_links_links WHERE lid = " . intval($_GET['lid']));
        list($url) = sql_fetch_row($result);
}

/* versch. HTTP Header senden */
if (!headers_sent()) {
    header('Content-type: text/html; charset=utf-8');
    header('Content-Language: ' . _DOC_LANGUAGE);
    header('X-Powered-By: pragmaMx ' . PMX_VERSION);
}

if (!$url) {
    $msg = '<h3>' . _WLFNOTFOUND . '</h3>';
} else {
    ob_start();
    $header = modGetResponseHeader($url, true);
    $msg = ob_get_clean();

    if (empty($header['status']) && isset($header['errstr'])) {
        $status = 'Error:&nbsp;' . $header['errstr'] . ' (' . $header['errno'] . ')';
    } else {
        $status = '<a href="http://de.selfhtml.org/servercgi/server/httpstatuscodes.htm#uebersicht" target="_blank">' . $header['status'] . '</a>';
    }

    $starturl = (empty($url)) ? 'undefined' : '<a href="' . $url . '">' . $url . '</a>';
    $endurl = (empty($header['url'])) ? 'undefined' : '<a href="' . $header['url'] . '">' . $header['url'] . '</a>';
    $type = explode('/', $header['type']);
    $type = (empty($header['type'])) ? 'undefined' : '<a href="http://www.iana.org/assignments/media-types/' . $type[0] . '" target="_blank">' . $header['type'] . '</a>';
    $redirs = substr_count($msg, 'redirect to:');
}

?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<meta http-equiv="content-language" content="<?php echo _DOC_LANGUAGE ?>" />
<title><?php echo _LINKVALIDATION ?></title>
<link rel="stylesheet" type="text/css" href="layout/style/style.css.php?t=<?php echo MX_THEME ?>" />
<link rel="stylesheet" type="text/css" href="themes/<?php echo MX_THEME ?>/style/style.css" />
</head>

<body class="allone popup">
<h2><?php echo _LINKVALIDATION ?></h2>
<hr noshade="noshade" size="1" />
<?php if ($starturl): ?>
<h3>summary:</h3>
<table>
<?php if ($redirs): ?>
<tr><td><b>start-url:</b>&nbsp;</td><td><?php echo $starturl ?></td></tr>
<tr><td><b>redirected:</b>&nbsp;</td><td><?php echo $redirs ?> x</td></tr>
<?php endif ?>
<tr valign="top"><td><b>target-url:</b>&nbsp;</td><td><?php echo $endurl ?></td></tr>
<tr valign="top"><td><b>status:</b>&nbsp;</td><td><?php echo $status ?></td></tr>
<tr valign="top"><td><b>type:</b>&nbsp;</td><td><?php echo $type ?></td></tr>
</table>
<hr noshade="noshade" size="1" />
<h3>response headers:</h3>
<?php endif ?>
<?php echo $msg ?>
</body>
</html>
