<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 *
 *
 * Based on Journey Links Hack
 * Copyright (c) 2000 by James Knickelbein
 * Journey Milwaukee (http://www.journeymilwaukee.com)
 */

defined('mxMainFileLoaded') or die('access denied');
pmxBase::set("plugins",1);
$module_name = basename(dirname(__FILE__));
mxGetLangfile($module_name);
require_once(PMX_MODULES_DIR . DS . $module_name . '/l_config.php');
include(PMX_MODULES_DIR . DS . $module_name . '/includes/functions.php');

if (!isset($showemptycategories)) {
    mxErrorScreen('<p>' . _SETTINGSWARN . '<br /><br /><a href="' . adminUrl(PMX_MODULE, 'Config') . '">' . _WEBLINKSADMIN . '</a></p>');
}

$index = (empty($index)) ? 0 : 1;
$pagetitle = _MODUNAME;

$modimagepath = PMX_MODULES_PATH . $module_name . '/images/';

define('DLDEFAULTORDER', 'dateD');

function mainview()
{
    global $prefix, $module_name, $modimagepath, $pagetitle;
    // die aktuelle Kategorie-id aus request ermitteln, wenn leer, dann ist es die Hauptseite ohne spezielle Kategorie
    $cid = (empty($_REQUEST['cid']) || $_REQUEST['cid'] < 0) ? 0 : intval($_REQUEST['cid']);
    // Anzahl der Datensaetze pro Seite aus Konfigurationsdatei
    $show = (empty($GLOBALS['perpage']) || intval($GLOBALS['perpage']) <= 0) ? 10 : $GLOBALS['perpage'];
    // Startoffset fuer Limit aus Request
    $min = (empty($_REQUEST['min']) || $_REQUEST['min'] < 0) ? 0 : intval($_REQUEST['min']);
    // aktuelle Sortierung, falls per request uebergeben, wenn nicht, Standardsortierung
    $orderby = (empty($_REQUEST['orderby'])) ? DLDEFAULTORDER : modGetOrderBy($_REQUEST['orderby']);
    // check, ob nur eine  Hauptkategorie vorhanden
    if (!$cid) {
        $result = sql_query("SELECT cid FROM " . $prefix . "_links_categories WHERE parentid=0 LIMIT 2");
        $maincatcount = sql_num_rows($result);
        // wenn ja, diese Hauptkategorie als oberste Kategorie anzeigen
        if ($maincatcount === 1) {
            list($cid) = sql_fetch_row($result);
        }
    }

    if ($cid) {
        // Anzahl ALLER Links in dieser Kategorie
        $result = sql_query("select count(lid) from " . $prefix . "_links_links where cid=" . intval($cid) . " AND cid > 0");
        list($countincat) = sql_fetch_row($result);
        // aktuelle Kategoriedaten ermitteln
        $result = sql_query("select title, cdescription, parentid from " . $prefix . "_links_categories where cid=" . intval($cid) . " AND cid > 0");
        list($cattitle, $catdescription, $parentid) = sql_fetch_row($result);
        $cattitle = '<a href="modules.php?name=' . $module_name . '">' . mxCreateImage($modimagepath . 'folder_open.gif', _WLCATEGORY, array('title' => _WLCATEGORY, 'hspace' => 2)) . '</a>&nbsp;' . modGetParentTitlesAsLink($parentid, $cattitle, $cid);
        $title = $cattitle;
        if (!empty($catdescription)) {
            // Zeilenumbrueche vor und hinter der Beschreibung entfernen
            $catdescription = preg_replace('#<br\s*/?>+$#si', '', trim($catdescription));
            $catdescription = preg_replace('#^<br\s*/?>+#si', '', $catdescription);
        }
        // der Link fuer die Sortierliste und Pager
        $link = "modules.php?name=" . $module_name . "&amp;cid=" . $cid . "&amp;min=%d";
        // die query um die Links dieser Kategorie fuer die aktuelle Seite auszulesen
        $qry = "SELECT dd.*, dd.name as auth_name, dd.date as updated, de.linkid AS editorialid
                FROM " . $prefix . "_links_links AS dd
                LEFT JOIN " . $prefix . "_links_editorials AS de ON dd.lid = de.linkid
                WHERE dd.cid=" . intval($cid) . "
                AND dd.cid > 0
                ORDER BY " . modConvertOrderForSql($orderby) . "
                LIMIT " . $min . "," . $show;
        $result = sql_query($qry);
        // der Pager
        $pageview = modShowPageView($countincat, $min, $show, $link . (($orderby == DLDEFAULTORDER) ? '' : '&amp;orderby=' . $orderby));
    } else {
        $cattitle = _LINKSMAINCAT;
        $catdescription = '';
        $title = '';
        $countincat = 0;
        $pageview = '';
    }
    // Daten fuer header aufbereiten
    // Seitentitel
    $pagetitle = strip_tags(_MODUNAME . ': ' . $cattitle);
    // die Kategorien
    $categorieslist = modViewCategories($cid);

    include(PMX_MODULES_DIR . DS . $module_name . '/includes/header.php');

    if ($countincat) {
        OpenTable();
        if ($countincat > 3) {
            modSortMenu($orderby, $link);
        }
        // Schleife durch Suchergebnisse
        while ($row = sql_fetch_assoc($result)) {
            modViewData($row, 'list');
        }
        CloseTable();
        echo '<br />';
        if ($pageview) {
            OpenTable();
            echo $pageview;
            CloseTable();
            echo '<br />';
        }
    } else if ($cid && !$categorieslist) {
        OpenTable();
        echo '<div align="center" class="content">' . _NOTHINGINCAT . '<br /><br />' . _GOBACK . '<br /><br /><br /><br /><br /><br /><br /><br /></div>';
        CloseTable();
        echo '<br />';
    }
    modSpecialTopLists($cid);
    modShowStats($cid);
    include(PMX_MODULES_DIR . DS . $module_name . '/includes/footer.php');
}

/**
 * versch. Variablen vordefinieren
 */
$cid = (empty($cid)) ? 0 : intval($cid);
$lid = (empty($lid)) ? 0 : intval($lid);
/**
 * fuer die Suchabfrage, aktiv in allen Ansichten
 */
if (isset($_REQUEST['query'])) {
    $query = strip_tags(stripslashes(substr($_REQUEST['query'], 0, 60)));
} else {
    $query = "";
}
/**
 * dieser Schwachsinn muss für veraltete Links drin bleiben...
 */
if (empty($_REQUEST['l_op']) && isset($_REQUEST['ratinglid']) && isset ($_REQUEST['ratinguser']) && isset ($_REQUEST['rating'])) {
    $_REQUEST['l_op'] = 'addrating';
}

/**
 * Auswahl der Optionen
 */
$op = (empty($_REQUEST['op'])) ? '' : $_REQUEST['op'];
/**
 * l_op fuer alte links weiterhin auswerten
 */
$op = (isset($_REQUEST['l_op']) && !isset($_REQUEST['op'])) ? $_REQUEST['l_op'] : $op;

/**
 * Auswahl der Optionen
 */
switch ($op) {
    case "Add":
        require_once(PMX_MODULES_DIR . DS . "$module_name/addnew.php");
        Add();
        break;
    case "AddLink":
        require_once(PMX_MODULES_DIR . DS . "$module_name/addnew.php");
        AddLink();
        break;

    case "NewLinks":
    case "NewLinksDate":
        require_once(PMX_MODULES_DIR . DS . "$module_name/show_newest.php");
        NewLinks();
        break;

    case "TopRated":
        require_once(PMX_MODULES_DIR . DS . "$module_name/show_toprated.php");
        TopRated();
        break;

    case "MostPopular":
        require_once(PMX_MODULES_DIR . DS . "$module_name/show_mostpopular.php");
        MostPopular();
        break;

    case "RandomLink":
        require_once(PMX_MODULES_DIR . DS . "$module_name/show_random.php");
        RandomLink();
        break;

    case "search":
        require_once(PMX_MODULES_DIR . DS . "$module_name/show_search.php");
        search();
        break;

    case "reportbroken":
        require_once(PMX_MODULES_DIR . DS . "$module_name/reportbroken.php");
        reportbroken($lid);
        break;

    case "reportbrokensave":
        require_once(PMX_MODULES_DIR . DS . "$module_name/reportbroken.php");
        reportbrokensave();
        break;

    case "modifyrequest":
        require_once(PMX_MODULES_DIR . DS . "$module_name/reportmodify.php");
        modifyrequest($lid);
        break;

    case "modifyrequestsave":
        require_once(PMX_MODULES_DIR . DS . "$module_name/reportmodify.php");
        modifyrequestsave();
        break;

    case "ratelink": // alt
    case "rating":
        require_once(PMX_MODULES_DIR . DS . "$module_name/rating.php");
        rating($lid);
        break;

    case "addrating":
        require_once(PMX_MODULES_DIR . DS . "$module_name/rating.php");
        addrating();
        break;

    case "outsidelinksetup": // alt
    case "outsiderating": // neu
        require_once(PMX_MODULES_DIR . DS . "$module_name/outsiderating.php");
        outsiderating($lid);
        break;

    case "viewlinkcomments": // alt
    case "comments": // neu
        require_once(PMX_MODULES_DIR . DS . "$module_name/comments.php");
        viewcomments($lid);
        break;

    case "viewratingdetails":
        require_once(PMX_MODULES_DIR . DS . "$module_name/ratingdetails.php");
        viewratingdetails($lid);
        break;

    case "view":
    case "viewlinkdetails": // alt
    case "viewlinkeditorial": // alt
        $_REQUEST['op'] = $op; // zur Sicherheit, weil in Detailansicht abgefragt wird
        require_once(PMX_MODULES_DIR . DS . "$module_name/details.php");
        viewdetails($lid);
        break;

    case "getit":
    case "visit":
        require_once(PMX_MODULES_DIR . DS . "$module_name/fetch.php");
        getit($lid);
        break;

    case "check":
        require_once(PMX_MODULES_DIR . DS . "$module_name/includes/response.php");
        break;

    case "viewslink": // alt
    case "viewlink": // alt
    default:
        mainview();
        break;
}

?>
