<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Author: Olaf Herfurth / TerraProject  http://www.tecmu.de
 *

 * $Revision: 540 $
 * $Author: PragmaMx $
 * $Date: 2022-06-24 19:21:38 +0200 (Fr, 24. Jun 2022) $

 * 
 */

defined('mxMainFileLoaded') or die('access denied');

$pmx_plugin = function($module_name, $settings , &$outcome)
{
	if (!pmxBase::httprefmax()) pmxBase::set('httprefmax',500);
	
    global $prefix, $MX_SERVER;
    $ref = parse_url($MX_SERVER['HTTP_REFERER']);
    //mxDebugFuncVars($ref);
    if (empty($ref['host']) || empty($ref['scheme'])) {
        // gefakter referer
        return;
    }
    if (empty($ref['path'])) {
        $ref['path'] = '';
    } else {
        // nur den Pfad der URL extrahieren und gleich den letzten slash entfernen, Ergebnis in $x[1]
        preg_match('#(.*)/[^/]*#', $ref['path'], $x);
        if (isset($x[1])) {
            $ref['path'] = $x[1];
        }
    }

    $self = parse_url(PMX_HOME_URL . '/index.php');

    if (empty($self['path'])) {
        $self['path'] = '';
    } else {
        preg_match('#(.*)/[^/]*#', $self['path'], $x);
        if (isset($x[1])) {
            $self['path'] = $x[1];
        }
    }
    // referer von eigener Seite
    if (preg_replace('#^www\.#i', '', $ref['host']) == preg_replace('#^www\.#i', '', $self['host'])) {
        /**
         * Pfade noch ueberpruefen
         * - wenn Serverpfad leer
         * - wenn Refererpfad leer
         * - wenn die Pfade gleich sind
         * - wenn Serverpfad in Refererpfad am Anfang enthalten ist
         * - wenn Refererpfad in Serverpfad am Anfang enthalten ist
         * dann diesen Referer nicht notieren
         */
        switch (true) {
            case !$self['path']:
            case !$ref['path']:
            case $ref['path'] === $self['path']:
            case strpos($ref['path'], $self['path']) === 0:
            case strpos($self['path'], $ref['path']) === 0:
            return;
        }
    }
    // referer die unerwuenscht sind, ignorieren
    if (@file_exists('admin/.ignore_referer')) {
        $ignore = file_get_contents('admin/.ignore_referer');
        $ignore = preg_split('#\s*,\s*#m', trim($ignore));
        if (in_array($MX_SERVER['HTTP_REFERER'], $ignore) || in_array($ref['host'], $ignore)) {
            return;
        }
    }

    $result = sql_system_query("select min(rid), avg(rid), count(rid) from " . $prefix . "_referer");
    list ($min, $avg, $count) = sql_fetch_row($result);

    if ($count == pmxBase::httprefmax()) {
        sql_system_query("DELETE FROM " . $prefix . "_referer WHERE rid = " . $min);
    } else if ($count > pmxBase::httprefmax()) {
        sql_system_query("DELETE FROM " . $prefix . "_referer WHERE rid < " . $avg);
    }
    pmxDebug::pause();
    sql_system_query("REPLACE INTO " . $prefix . "_referer (rid, url) values (" . intval(MX_TIME) . ",'" . mxAddSlashesForSQL($MX_SERVER['HTTP_REFERER']) . "')");
    pmxDebug::restore();   
    
}

?>