<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 543 $
 * $Author: PragmaMx $
 * $Date: 2022-07-01 13:08:13 +0200 (Fr, 01. Jul 2022) $
 *
 *
 */

defined('mxMainFileLoaded') or die('access denied');

if (!mxGetAdminPref('radminsuper')) {
    mxErrorScreen("Access Denied");
    die();
}
/* Sprachdatei auswählen */
$pluginname=basename(dirname(dirname(__FILE__)));
mxGetLangfile(dirname(dirname(__FILE__)));


class adminReplace 
{
	private $_config=array();
	private $_settings=array();
	
	function __construct (...$settings) 
	{
		$cf=load_class("Plugin");
		//$this->_config = 
		$this->_settings=$settings[0];
		/* automatische installation der db */
		if (!sql_ifTableExists("_plugin_replace")) $this->_create_db();
		
		$this->main();
	}
	function main ()
	{
		$prefix= pmxBase::get('prefix');
		$plugin_name=basename(dirname(dirname(__FILE__)));
			
		$tb=load_class("AdminForm","adminReplaceContent");   
		$pl=load_class("Plugin");
		
		$config=$pl->get_PluginFromName($plugin_name);
		
		$this->_config=$this->_SetDefault($config);
		
		$plugin=$this->_config;
		$msg=FALSE;
		$pid=isset($_GET['pid'])?$_GET['pid']:0;
		$pid=isset($_POST['pid'])?$_POST['pid']:$pid;
		
		switch(pmxAdminForm::CheckButton())
		{

			case "back":
				mxRedirect(adminUrl("plugins","plugins","id=".$pid));
				break;
			case "new":
				$pid=0;
			case "save":
			case "accept":
				
				$this->replace_edit($pid);
				break;		
			case "delete":
				$this->replace_delete($pid);
			default:
				break;  
		}
		$pact=$this->_settings['pact'];

		switch ($pact)
		{
			case "edit":
				$this->replace_edit($pid);
			break;
			case "delete":
				$this->replace_delete($pid);
			break;
			case "activate":
				sql_query("Update ".$prefix ."_plugin_replace set active=1 where id='".$pid."'");
			break;
			case "deactivate":
				sql_query("Update ".$prefix ."_plugin_replace set active=0 where id='".$pid."'");
			break;			
		}

		$tb->__set("tb_direction", 'right');
		$tb->__set("infobutton", false);
		$tb->__set("tb_pic_heigth", 25);
		$tb->__set("csstoolbar", "toolbar1");
		$tb->__set("cssform", "a403030");
		$tb->__set('buttontext', false);
		$tb->__set('homelink', false);
		$tb->__set('fieldhomebutton', true);
		$tb->__set('formtabs', true);
		$tb->__set('acceptbutton', false);
		$tb->__set("toolbarfixed", true);
		
		
		$tb->addToolbar("new");	
		$tb->addToolbar("back");	
		
		if ($msg) $tb->add("","output","<div id='a5546425' class='info'>".$msg."</div>");
		
		
		/* Bilder definieren */
		$img_activate = mxCreateImage('images/deactivate.gif', _ACTIVATE, array('title' => _ACTIVATE));
		$img_deactivate = mxCreateImage('images/activate.gif', _DEACTIVATE, array('title' => _DEACTIVATE));
		$img_edit = mxCreateImage("images/edit.gif", _EDIT, 0, 'title="' . _EDIT . '"');
		$img_delete = mxCreateImage("images/delete.gif", _DELETE, 0, 'title="' . _DELETE . '"');
		
		$img_view = mxCreateImage("images/view.gif", _SHOW, 0, 'title="' . _SHOW . '"');
		$img_admin = mxCreateImage("images/admin.gif", _ADMINISTRATION); 
        /* Tabellenspalten vorbereiten */
        
        $fieldname=array(
		    array("name"=>mxText('_ID')),
            array("name"=>mxText('_KEY'),"attr"=>"style='min-width:200px'"),
            array("name"=>mxText('_REPLACEMENT'),"attr"=>"style='min-width:200px'"),

            array("name"=>mxText("_FUNCTIONS"),"attr"=>"style='width:100px'"),
            
            );
			
		$result = sql_query("SELECT * FROM ".$prefix ."_plugin_replace ");
		$values=array();
		
		while ($value = sql_fetch_array($result)) {
            $action_set="";    
			$action_set .='<a href="admin.php?op=plugins&amp;act=admin&amp;pact=edit&amp;plugin='.$plugin_name.'&amp;pid='.$value['id'].'&amp;id='.$_GET['id'].'" title="'._EDIT.'">'.$img_edit.'</a>&nbsp;';
			$action_set .=
                    '<a href="admin.php?op=plugins'
							.'&amp;act=admin'
							.'&amp;plugin='.$plugin_name
							.'&amp;pact='.(($value['active']==0)?"activate":"deactivate")
							.'&amp;pid='.$value['id']
							.'&amp;id='.$_GET['id']
							.'" title="">'.
							(($value['active']==1)?$img_deactivate:$img_activate)
							.'</a>&nbsp;';
                 //mxDebugFuncVars($value);   
                /* Adminlink noch einfügen, wenn vorhanden */
				$action_set .='<a href="admin.php?op=plugins&amp;act=admin&amp;pact=delete&amp;plugin='.$plugin_name.'&amp;pid='.$value['id'].'&amp;id='.$_GET['id'].'" title="'._DELETE.'">'.$img_delete.'</a>&nbsp;';
				

			    /* zusammensetzen */
                $values[$value['id']]=array(
					$value['id'],
                    mxStripSlashes($value['original']),
					mxStripSlashes($value['replaced']),
					$action_set,
                );
		}
		//$tb->add("","warning",PHP_VERSION_ID);
		
		$tb->add("","output",_CHANGECONTENT_HELP);
		$tb->add("","table",$fieldname,$values);
		$tb->add("","hidden","act","admin");
		$tb->add("","hidden","plugin",$plugin_name);
		$tb->add("","hidden","id",$_GET['id']);
		
	  /* formular abrufen */
		$form = $tb->Show();
		
		
		/* zusatzinfos abrufen */
		$info=array();
		include (PMX_PLUGIN_PATH.DS.$plugin_name.DS."setup.pmx.php");
		
		$info=$credits();
		/*
		 * Template
		 */
		// Template initialisieren
		$template = load_class('Template');
		$template->add_path(dirname(dirname(__FILE__)).DS.'templates'.DS);	
		/* hier die Ausgabefelder angeben */
		$info2=_CHANGECONTENT;
		/* Variablen an das Template uebergeben */
		$template->assign(compact('form', 'info2','info','plugin'));

		mxIncludeHeader();
		/* Template ausgeben (echo) */
		$template->display('main.html');

		mxIncludeFooter();			

		
	}

	function replace_edit ($pid=0)
	{
		
		$xnew=($pid==0)?true:false;
		
		
		$prefix= pmxBase::get('prefix');
		$plugin_name=basename(dirname(dirname(__FILE__)));
				
		$tb=load_class("AdminForm","adminReplaceContentEdit");   
		$plugin=$this->_config;
		
		$msg=false;
		$xreturn=false;
		$err=false;
		
		switch(pmxAdminForm::CheckButton())
		{
			case "save":
				$xreturn=true;
			case "accept":
				$original=mxAddSlashesForSQL($_POST['original']);
				$replaced=mxAddSlashesForSQL($_POST['replaced']);
				$setting=mxAddSlashesForSQL($_POST['setting']);
				$active=mxAddSlashesForSQL($_POST['active']);
				$pid=mxAddSlashesForSQL($_POST['pid']);
				$this->_settings['pid']=$pid;
				/* fehlerbehandlung */
				if ($pid==0) $xnew = true;
				if (trim($original)=="")  $msg=_ERR_NO_CONTENT;
				//mxDebugFuncVars($_POST,);
				/* abspeichern */
				if (!$msg) {
					if ($xnew) {
						sql_query("INSERT INTO ".$prefix ."_plugin_replace set 
						original='".$original."', 
						replaced='".$replaced."',
						active='".$active."',
						setting='".$setting."'");
						$this->_settings['pid']=sql_insert_id();
						$xnew=false;
						$msg=_ADMIN_SETTINGSAVED;						
					} else {
						sql_query("Update ".$prefix ."_plugin_replace set 
						original='".$original."', 
						replaced='".$replaced."',
						active='".$active."',
						setting='".$setting."' 
						where id=" . $pid);
					$msg=_ADMIN_SETTINGSAVED;
					}
				}
				if (!$xreturn) break;
				
			case "cancel":
				mxRedirect(adminUrl("plugins","","act=admin&amp;id=".$this->_settings['id']."&amp;pact=0&amp;plugin=".$plugin_name));
			default:
				break;  
		}
		if ($this->_settings['pid']==0) $xnew = true;
		
		pmxHeader::add_jquery();
		pmxHeader::add_script_code("
			$(document).ready(function () {
            $('#g6545645').css('display', 'block');
            $('#g6545645').fadeOut(6000);
			});
			"	
		);		
		
		
		$tb->__set("tb_direction", 'right');
		$tb->__set("infobutton", false);
		$tb->__set("tb_pic_heigth", 25);
		$tb->__set("csstoolbar", "toolbar1");
		$tb->__set("cssform", "a306010");
		$tb->__set('buttontext', false);
		$tb->__set('homelink', false);
		$tb->__set('fieldhomebutton', true);
		$tb->__set('formtabs', true);
		$tb->__set('acceptbutton', false);
		
		$tb->addToolbar("accept");	
		$tb->addToolbar("save");	
		$tb->addToolbarLink("cancel",adminUrl("plugins","","act=admin&amp;pact=0&amp;id=".$this->_settings['id']."&amp;plugin=".$plugin_name));	
		
		if ($msg) $tb->add("","output","<div id='#g6545645' class='info'>".$msg."</div>");		
		
		if ($xnew) {
			$replacement=array(
				"id"=>0,
				"original"=>"",
				"replaced"=>"",
				"setting"=>0,
				"active"=>0,
				);
		} else {
			$result = sql_query("SELECT * FROM ".$prefix ."_plugin_replace where id=" . $this->_settings['pid']);
			if (!$result) return;		
			$replacement=sql_fetch_array($result);
		}
		

		
		//mxdebugfuncvars($replacement);
		
		$tb->add("","output","");
		
		$tb->add("","text","original",mxStripSlashes($replacement['original']),_KEY,"",60,255,true);
		$tb->add("","textbox","replaced",mxStripSlashes($replacement['replaced']),_REPLACEMENT,_REPLACEMENT_INFO,60,10);
		$tb->add("", "select", "setting", $replacement['setting'], _REPLACEMENT_NUMBER, "",  0,array(_EACH=>0,_ONCE=>1));
		$tb->add("","yesno","active",$replacement['active'],_ACTIVATE);
		//$tb->add("","table",$fieldname,$values);
		$tb->add("","hidden","act","admin");
		$tb->add("","hidden","plugin",$plugin_name);
		$tb->add("","hidden","pid", (($xnew)?0:$this->_settings['pid']));
		$tb->add("","hidden","id", $this->_settings['id']);
		$tb->add("","hidden","pact", "edit");
		
	  /* formular abrufen */
		$form = $tb->Show();
		
		
		/* zusatzinfos abrufen */
		$info=array();
		include (PMX_PLUGIN_PATH.DS.$plugin_name.DS."index.php");
		$pmx_plugin($plugin_name,$info);
		//mxDebugFuncVars($info);
		$info=$info[0];
		/*
		 * Template
		 */
		// Template initialisieren
		$template = load_class('Template');
		$template->add_path(dirname(dirname(__FILE__)).DS.'templates'.DS);	
		/* hier die Ausgabefelder angeben */
		$info2=_CHANGECONTENT;
		/* Variablen an das Template uebergeben */
		$template->assign(compact('form', 'info2','info','plugin'));

		mxIncludeHeader();
		/* Template ausgeben (echo) */
		$template->display('main.html');

		mxIncludeFooter();			
		
		
	}

	function replace_new ()
	{
		$this->replace_edit(0);
		
		
	}
	
	function replace_delete ($pid)
	{
		
		if ($pid==0) return;
		
		$prefix= pmxBase::get('prefix');
		$plugin_name=basename(dirname(dirname(__FILE__)));
		
		$tb=load_class("AdminForm","adminReplaceContentEdit");   
		$plugin=$this->_config;
		
		$msg=false;
		$xreturn=false;
		$err=false;
		
		switch(pmxAdminForm::CheckButton())
		{

			case "delete":
				$pid=mxAddSlashesForSQL($_POST['pid']);
				sql_query("DELETE from ".$prefix ."_plugin_replace where id='".$pid."'");				
				
			case "cancel":
				mxRedirect(adminUrl("plugins","","act=admin&amp;id=".$this->_settings['id']."&amp;pact=0&amp;plugin=".$plugin_name));
			default:
				break;  
		}

		$tb->__set("tb_direction", 'right');
		$tb->__set("infobutton", false);
		$tb->__set("tb_pic_heigth", 25);
		$tb->__set("csstoolbar", "toolbar1");
		$tb->__set("cssform", "a306010");
		$tb->__set('buttontext', false);
		$tb->__set('homelink', false);
		$tb->__set('fieldhomebutton', true);
		$tb->__set('formtabs', true);
		$tb->__set('acceptbutton', false);
		
		$tb->addToolbar("delete");	

		$tb->addToolbarLink("cancel",adminUrl("plugins","","act=admin&amp;pact=0&amp;id=".$this->_settings['id']."&amp;plugin=".$plugin_name));	

		$result = sql_query("SELECT * FROM ".$prefix ."_plugin_replace where id=" . $this->_settings['pid']);
		if (!$result) return;		
		$replacement=sql_fetch_array($result);
		
		$tb->add("","warning",_CHANGECONTENT_DELETE);
		$tb->add("","output",_KEY .": " .mxStripSlashes($replacement['original']));
		$tb->add("","output",_REPLACEMENT .": ".mxStripSlashes($replacement['replaced']));
		//$tb->add("","table",$fieldname,$values);
		$tb->add("","hidden","act","admin");
		$tb->add("","hidden","plugin",$plugin_name);
		$tb->add("","hidden","pid", $this->_settings['pid']);
		$tb->add("","hidden","id", $this->_settings['id']);
		$tb->add("","hidden","pact", "delete");
		
	  /* formular abrufen */
		$form = $tb->Show();
		
		
		/* zusatzinfos abrufen */
		$info=array();
		include (PMX_PLUGIN_PATH.DS.$plugin_name.DS."index.php");
		$pmx_plugin($plugin_name,$info);
		//mxDebugFuncVars($info);
		$info=$info[0];
		/*
		 * Template
		 */
		// Template initialisieren
		$template = load_class('Template');
		$template->add_path(dirname(dirname(__FILE__)).DS.'templates'.DS);	
		/* hier die Ausgabefelder angeben */
		$info2=_CHANGECONTENT;
		/* Variablen an das Template uebergeben */
		$template->assign(compact('form', 'info2','info','plugin'));

		mxIncludeHeader();
		/* Template ausgeben (echo) */
		$template->display('main.html');

		mxIncludeFooter();			
						
		
	}

	private function _SetDefault($config)
	{
		$default = array("settings"=>array(),"replacements"=>
			array("TECMU"=>
				array("replace"=>"<a href='https://www.tecmu.de'>TECMU</a>",
					  "active"=>0,
					  "type"=>0,		// 0 alle Vorkommen. 1 nur erstes Vorkommen 
					  "word"=>0,		// 0 jegliche Version, 1 nur ganzes Wort
					)
				)
			);
		$config=array_merge($default,$config);
		return $config;
	}
	
	
	private function _create_db ()
	{
		global $prefix;
		
		include(PMX_PLUGIN_PATH . "Replace" . DS. "core/install.tabeldef.php");
	}
}
global $plugin, $act,$mod,$id;

$pact=(!isset($_GET['pact']))?"":$_GET['pact'];
$pid=(!isset($_GET['pid']))?"":$_GET['pid'];
$op=(!isset($_GET['op']))?"":$_GET['op'];
$id=(!isset($id))?NULL:$id;
$setting=compact('id','pid','op','act','pact','mod','plugin');

$tmp = new adminReplace($setting);
unset ($tmp);


?>