<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Author: Olaf Herfurth / TerraProject  http://www.tecmu.de
 *

 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $

 * 
 */

defined('mxMainFileLoaded') or die('access denied');

$pmx_plugin = function($module_name, $settings , &$mxoutput){
    
   // global $doctype_arr;
	// Das Array mit den versch. Doc-Type Deklarationen auslesen
    $doctype_arr = mxDoctypeArray($GLOBALS['DOCTYPE']);
	
    /* HTML-Validation */
    if (is_tidy_available()) {
        
		header('X-Tidy: Yes');
        // Specify configuration: http://tidy.sourceforge.net/docs/quickref.html
        $tidyconfig = array(/* Tidy-Konfiguration */
            'output-html' => $doctype_arr['html'],
            'output-xhtml' => $doctype_arr['xhtml'],
            'add-xml-decl' => $doctype_arr['xhtml'],
            'doctype' => $doctype_arr['tidy_doctype'],
            'wrap' => 0,
            'indent' => false,

            'output-bom' => false,
            'char-encoding' => 'utf8',
            // 'input-encoding' => 'utf8',
            // 'output-encoding' => 'utf8',
            'ascii-chars' => false,
            // 'indent-spaces' => 1,
            // 'clean'   => true,
            // 'alt-text' => 'img',
            );
        $tidy = new tidy;
        $tidy->parseString($mxoutput, $tidyconfig, 'utf8');
        $tidy->cleanRepair();
        $mxoutput = $tidy;
        // die tidy-Funktion fügt vor </textara> einen Zeilenumbruch ein, diesen hier entfernen
        $mxoutput = preg_replace('#\s*</textarea>#', '</textarea>', $mxoutput);
        unset($tidy);
    } else {
        if ($doctype_arr['xhtml']) {
            // versuchen, die xhtml-Endung anzufügen
            $mxoutput = preg_replace('#<((?:img|input|hr|br|link|meta|base)(?:[^>]*[^/])?)>#i', '<$1 />', $mxoutput);
            // bei <img> muss ein ALT Attribut spezifiert sein, hier versuchen die anzufügen, falls es fehlt
            
            $mxoutput = preg_replace_callback('#(<img[^>]*)/>#i', function($match)
						{
							if (preg_match("#\salt\s*=#i", $match[1], $mmmmm)) {
								return $match[0];
							} else {
								return $match[1] . ' alt="" />';
							}
						}, $mxoutput);
        } else {
            // die xhtml-Endung < /> entfernen, da Fehler in HTML 4.01
            $mxoutput = preg_replace('#(<[[:alnum:]]+[^>]*)/>#', '$1>', $mxoutput);
            // bei <img> muss ein ALT Attribut spezifiert sein, hier versuchen die anzufügen, falls es fehlt
            
            $mxoutput = preg_replace_callback('#(<img[^>]*)>#i', function($match)
							{
								if (preg_match("#\salt\s*=#i", $match[1], $mmmmm)) {
									return $match[0];
								} else {
									return $match[1] . ' alt="">';
								}
							} , $mxoutput);
        }
        // Link auf ungültige Verweise entfernen, kommt evtl. von Spaw, etc.
        $mxoutput = preg_replace('!\s+href="#?"!i', '', $mxoutput);
    }
    /* ENDE HTML-Validation */    
}

?>